General remarks to the procedure

Note: The input file formats and some general issues are explained in chuck3_manual.pdf and angcor_manual.pdf.


-----------------

0.) Create the input files for CHUCK3

There are some examples in the input file folders.

The Harakeh Dieperink dipole form factors which are needed for isoscalar dipole excitations can be calculated using the program formf in the corresponding directory.
There is an example input file called "input" in the same directory. The program can be used with an input file or via typing the values in the command line.
It basically need the mass and optical potential parameters.


-----------------

1.) Run Chuck3 with the desired input-file
./chuck < input.com

This command creates a "fort.2" file in the chuck directory which contains the relevant output for ANGCOR.
ANGCOR needs the "fort.2" file in the directory where it is started.
One can permantly fix this by placing a symbolic link in this directory.


-----------------

2.) Create input files for ANGCOR
You can use and adjust the c program (make_input) provided in the angcor/input/ directory to create input files for various angles.
These input files are needed to run angcor in its directory.


-----------------

3.) Run ANGCOR for each input file

./angcor < input/example_010.com > output/example_010.lis

for each input file.

I usually use it like this:

for ball in input_ca_*.com; do ../angcor < $ball > ../output/${ball%com}lis; done


-----------------

4.) Extract the angular correlation information from the ANGCOR output files

There is a script in the ANGCOR output directory which reads the *.lis output files and extracts the necessary values from the *.lis files.

The script

./make_final.sh

uses awk sort.awk and generates a 4-column "final.dat" file which contains the relevant information of angles theta_particle,theta_gamma,phi_gamma and W(theta_particle,theta_gamma,phi_gamma).


-----------------

5.) Averaging over the acceptance of the spectrometer

The last step is to use the "final.dat" file to average over the spectrometer acceptance that means the angles that can be detected in the experiment.

W(theta_particle,theta_gamma,phi_gamma)  --->  W(theta_gamma)

I have an old c program but it's very specialized, so it is probably not useful for you. I just put it that you get an idea of how it can be done.
./averaging final.dat


-----------------

VD on 03/31/15

C ANGCOR
C  Written by:  M.N. Harakeh and L.W. Put, Internal report KVI-67
C               Last modified 25 August 1985.
c Nov-2000 M.Yosoi   Rev. for IBM-xlf
c Sept 2009 R.G.T. Zegers Rev. for linux

To run on linux:
* recompile to code (if necessary adjust the makefile)
* test the program with input.dat (modified from VMS,originally by J. Enders)
* the DWUCK/CHUCK/DW81 file should be renamed "fort.2"
* to run type:

angcor < input.dat > output.dat

* The output.dat file will have the output.
* output.orig is included as a reference.

      PROGRAM CHUCK
      IMPLICIT REAL*8(A-H,O-Z)
C     PROGRAM CHUCK(INPUT,OUTPUT,PUNCH,TAPE5=INPUT,TAPE6=OUTPUT
C    1,TAPE7=PUNCH,TAPE8=2001,TAPE9,TAPE4,TAPE2)
C***********************************************************************
C
C                  *****     CHUCK-3     *****
C
C     CHANGES FROM BASIC COLORADO EXPORT VERSION,  J.R.COMFORT
C
C   1. THE NUMBER OF CONTROL INTEGERS WAS INCREASED FROM 16 TO 20.
C   2. CONTROL INTEGER 1 WAS MODIFIED.  ANGLE DATA ARE CONTROLED AS--
C          C.I. 1 = 0  REPEAT SAME SET OF ANGLES AS LAST CASE.  DO NOT READ
C                        CARD 2.  (DEFAULT SET IS 0-180 DEG. IN 5 DEG. STEPS)
C                 = 1  READ NUMBER OF ANGLES, INITIAL ANGLE, STEP SIZE.
C                 = 2  READ INITIAL ANGLE, FINAL ANGLE, STEP SIZE
C                        (OR FINAL ANGLE, INITIAL ANGLE, STEP SIZE).
C   3. CONTROL INTEGER 2 WAS ADDED TO SUPPRESS FORM-FACTOR PRINTING.
C          C.I. 2 = 0  PRINT ALL FORM-FACTOR INFORMATION.
C                 = 1  SAME.
C                 = 2  SUPPRESS SINGLE-PARTICLE WAVE FUNCTIONS, ICODE=2.
C                 = 3  SUPPRESS PARAMETER LISTINGS ALSO (ANY ICODE).
C   4. CONTROL INTEGER 3 IS NOT USED ANYMORE, POLARIZATIONS ARE ALWAYS
C        PRINTED.
C   5. CONTROL INTEGER 4 IS NOT USED ANYMORE INSTEAD CONTROL INTEGER
C        13 IS USED TO CONTROL PUNCHING OF CROSS SECTIONS AND POLARIZAT-
C        IONS.
C   6. CONTROL INTEGER 9 GIVES 3-CYCLE SEMILOG PLOTS BY DEFAULT.. PLOTS
C        SUPPRESSED IF C.I. 9 IS GREATER THAN 5.
C   7. THE PHYSICAL CONSTANTS IN THIS VERSION ARE BASED ON TAYLOR, PARKE
C        LANGENBERG (RMP 41,375,1969), EXCEPT FOR AMU WHICH IS BASED ON
C        1973 TABLE OF FUNDAMENTAL CONSTANTS (E.R.COHEN).
C   8. THE SCRATCH TAPES ARE TAPE 8 AND TAPE 9.
C   9. THE DATE AND TIME ARE CURRENT DATE AND CPU TIME OBTAINED BY CALLS TO
C        SUBROUTINE CUDATE.  THE DATA WORDS ARE DOUBLE PRECISION AND THE
C        FORMAT IS (A10,2X,F7.2).  THE FORMATS ARE 9003 IN MAIN AND 9019
C        ACHK, BCHK, SOLVE, AND XSECT.
C  10. PRINTING OF THE FIRST TITLE WAS MOVED FROM THE MAIN ROUTINE TO
C        SUBROUTINE ACHK, AFTER THE FIRST READ STATEMENT.
C  11. THE WATSON L.S POTENTIAL WAS ADDED TO POTENT.
C  12. THE FINITE-RANGE ROUTINE FNLOC WAS MODIFIED TO BE THE SAME AS DWUCK.
C  13. ALL NON-LOCALITY CORRECTIONS USE THE OLD L.E.A. METHOD (HULTHEN FORM
C        IN DWUCK-2) AS STANDARD.  THE ROST-KUNZ (EXPONENTIAL) FORM IS O???
C        BY SETTING PNLOC LESS THAN ZERO FOR EACH PROJECTILE FOR WHICH IT IS
C        TO BE APPLIED.
C  14. GAUSSIAN MICROSCOPIC INTERACTION INCLUDED IN CATHEN, WITH ICODE=4.
C  15. SUBROUTINE DWPLOT IS A MODIFIED VERSION.
C  16. THE ANGULAR MOMENTUM PACKAGE HAS BEEN MODIFIED SO AS TO WORK WITH
C        LOG FACTORIALS.  THE INTERNAL TABLES ARE EXPANDED UP TO FACTORIAL 82
C        THE HANDLING OF THE YXFCT FUNCTION CALLS IN SUBROUTINE SOLVE WAS
C        MODIFIED.
C  17. EXPLICIT DOUBLE PRECISIONING HAD TO BE DONE IN THE INTEGRATION SETUP
C        ON THE DEC-10.  THIS INVOLVED SEVERAL VARIABLES IN SUBROUTINES ???
C        AND SOLVE, AND A REWRITTING OF SUBROUTINE INVERT.  NOTE--
C           A. THE WRITING OF REAL WORDS INTO AND FROM THE BUFFER IN SUBROUTINE
C              WRITEB AND READB WAS DOUBLED IN LENGTH.
C  18. THE LIMIT ON THE NUMBER OF INTEGRATION POINTS WAS INCREASED TO 40.
C  19. THE LIMIT ON THE NUMBER OF TRANSITION AMPLITUDES WAS INCREASED FROM ???
C        TO 12800 AND THE LIMIT ON STOP CODE 111 WAS INCREASED FROM 192 TO ???
C        THE NUMBER OF SUBCHANNELS WAS INCREASED FROM 32 TO 40.  THE MAXIMUM
C        NUMBER OF PARTIAL WAVES FOR ALL CHANNELS HAS GONE FROM 400 TO 6???
C  20. AN ARRAY JPRT WAS ADDED TO CONTAIN THE PARITY OF EACH NUCLEAR STATE.
C        ODD VALUE (E.G., 1 OR -1) WILL CHANGE THE SIGN ON THE LTRT ARRAY
C        INTENDED FOR USE WITH 0- STATES.
C  21. CORRECTIONS MADE FOR THE PROPER HANDLING OF INTEGRATION COORDINATES
C        IN MICROSCOPIC INELASTIC SCATTERING.  USE CORE MASS = A-1.
C  22. MODIFICATIONS WERE MADE IN THE HANDLING OF UNBOUND FORM FACTORS,
C        FOLLOWING VINCENT AND FORTUNE.  THE HUBY-MINES DAMPING WAS CHANGED
C        TO GAUSSIAN DAMPING.
C  23. NEGATIVE RADIUS VALUES IMPLY A1**(1/3)+A2**(1/3).
C  24. LOWER-L CUTOFF FACILITY ADDED.
C  25. A FLOATING-CORE FEATURE WAS ADDED.  SEE SUBROUTINE BCHK.
C  26. MICROSCOPIC INELASTIC SCATTERING MODIFIED FOR BETTER TREATMENT.
C  27. FOLDING OPTION HAS BEEN ADDED. THE TRANSITION DENSITY IS ENTERED
C      IN A SEPARATE SUBROUTINE FMN WHICH HAS TO BE COMPILED AND LINKED
C      TO THE PROGRAM EVERY TIME A FOLDING CALCULATION IS MADE.
C  28. FORM FACTORS FOR BETA, GAMMA AND OCTUPOLE BANDS.
C
C***********************************************************************
C     DOUBLE PRECISION BETA
      COMMON THETAN,THETA1,DTHETA,DRT,RMAX,ALPHA(15),IDAT(6)
     1,ICON(20),LMAX,KT,KMAX,LLCO,JOUT,NLTR,IBUFF,IWORD
     2,KLAM( 8),LTRT( 8),JTRT( 8),NADD( 8),LAM(16),ISP(16),JSP(16)
     3,ILK(16),JPRT( 8)
      COMMON EN( 8),FM( 8),Z( 8),FMA( 8),ZA( 8),RY( 8),FS( 8),ECM( 8)
     1,FMU( 8),RC( 8),FK2( 8),FK( 8),ETA( 8),AFACT( 8),DRF( 8),FN( 8)
     2,PNLOC( 8),DUM( 8),SIG( 8)
     3,IS( 8),NS( 8),NLI( 8),LKTAB(32),ICUP(32),JCUP(32)
     4,IN( 8),INN( 8, 8),INDTAB(10)
      COMMON/LOCAL /ARRAY(4400)
      COMMON/BUFSPC/ BUFFR(800)
C
C     CALL ERRSET(10)
      KMAX=400
      IBUFF=800
      THETAN=37.D0
      THETA1=0.D0
      DTHETA=5.D0
 5001 CONTINUE
C
C     CUDATE IS DECODER SUBROUTINE FOR DATE AND TIME ROUTINES
C
      CALL CUDATE(IDAT)
C
C
C     READ IN CARD SET 1
C
      READ(5,9000,END=1)ICON,ALPHA
      IF (ICON(1).GE.8) STOP
      WRITE(6,9001)
      WRITE(6,9005)
      WRITE(6,9002)
      WRITE(6,9003) ICON,ALPHA,IDAT
C      WRITE(6,9003) ICON,ALPHA,ICON,XTIME
      REWIND 8
      REWIND 9
      CALL ACHK
      IF(JOUT.GT.1) STOP
      IF(JOUT.NE.0) GO TO 5001
      REWIND 8
      REWIND 9
      CALL BCHK
      GO TO 5001
 1    STOP
 9000 FORMAT(20I1,15A4)
 9001 FORMAT(  '1 COUPLED CHANNELS CODE--CHUCK3-VERSION 01/JULY/1978.  J
     1.R. COMFORT EXTENDED VERSION 25/JUNE/1979.'/
     2,55X,'M.N. HARAKEH EXTENDED VERSION 1/JANUARY/1982.'/
     3,55X,'M. ELVERS AND J. ENDRES MODIFIED VERSION 10/NOVEMBER/2009.')
 9002 FORMAT(41H  1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0,22H    RUN IDE
     1NTIFICATION)
 9003 FORMAT(1H ,20I2,4X,15A4,4X,I2,2(1H/,I2),I4,2(1H.,I2))
C 9003 FORMAT(1H ,20I2,4X,15A4,4X,A10)
 9005 FORMAT(18H0CONTROL INTEGERS  )
      END
      SUBROUTINE ACHK
      IMPLICIT REAL*8(A-H,O-Z)
C     ABS(XXX)=DABS(XXX)
C     FLOAT(III)=DFLOAT(III)
C     SIGN(XXX,YYY)=DSIGN(XXX,YYY)
C     DOUBLE PRECISION BETA
C     Modified by (JE and ME)
C     USE THE NEXT 1 CARDS FOR 32-BIT MACHINES
      DOUBLE PRECISION VCC
      COMMON THETAN,THETA1,DTHETA,DRT,RMAX,ALPHA(15),IDAT(6)
     1,ICON(20),LMAX,KT,KMAX,LLCO,JOUT,NLTR,IBUFF,IWORD
     2,KLAM( 8),LTRT( 8),JTRT( 8),NADD( 8),LAM(16),ISP(16),JSP(16)
     3,ILK(16),JPRT( 8)
      COMMON EN( 8),FM( 8),Z( 8),FMA( 8),ZA( 8),RY( 8),FS( 8),ECM( 8)
     1,FMU( 8),RC( 8),FK2( 8),FK( 8),ETA( 8),AFACT( 8),DRF( 8),FN( 8)
     2,PNLOC( 8),FMFCT( 8),SIG( 8)
     3,IS( 8),NS( 8),NLI( 8),LKTAB(32),ICUP(32),JCUP(32)
     4,IN( 8),INN( 8, 8),INDTAB(10)
      COMMON/LOCAL/ W(800),V(400),SAV1(800),SAV2(800),SAV3(1600)
      COMMON/BUFSPC/ X(800,1)
      COMMON /KPROJ/ MU
      COMMON /CORR/ BETAR,BETAI,VBETA,RHO0R,RHO0I,INDDEF,INDIM
      DIMENSION GAMMA(2),AKIN(32),BKIN(8,32),IJ(2),LDFRM(4),ABETA(3)
      EQUIVALENCE (BKIN(1,1),EN(1))
      DATA LCORE/600/
      DATA GAMMA/3H/2 ,3H   /
      DATA NLKMAX/16/
      DATA HBARC,AMU/197.329,931.502/
C modified by (JE, ME)
      SAVE
C
      KMAX2=KMAX+KMAX
      IF(ICON(1).EQ.0) GO TO 6
C
C     READ IN CARD SET 2
C
      READ(5,9008)THETAN,THETA1,DTHETA
      IF(THETA1.LE.0.0) THETA1=0.D0
      IF(DTHETA.LE.0.0) DTHETA=5.D0
      IF(ICON(1).EQ.1) GO TO 5
      IF(THETAN.GE.THETA1) GO TO 4
      ST=THETAN
      THETAN=THETA1
      THETA1=ST
    4 CONTINUE
      IF(THETAN.LE.0.0) THETAN=180.D0
      NTHETA=NINT((THETAN-THETA1)/DTHETA)+1
      THETAN=NTHETA
      GO TO 6
    5 CONTINUE
      IF(THETAN.LE.0.0) THETAN=37.D0
    6 CONTINUE
      WRITE(6,9010)THETAN,THETA1,DTHETA
C
C     READ IN CARD SET 3
C
      READ (5,9004)LMAX,NLTR,(LTRT(I),I=1,NLTR),(KLAM(I),I=1,NLTR)
     1    ,(JPRT(I),I=1,NLTR)
      WRITE(6,9026)LMAX,(LTRT(I),I=1,NLTR)
      WRITE(6,9027)NLTR,(KLAM(I),I=1,NLTR)
      ISUM=0
      DO 7 I=1,NLTR
      ISUM=ISUM+JPRT(I)
    7 CONTINUE
      IF(ISUM.NE.0) WRITE(6,9029) (JPRT(I),I=1,NLTR)
      LMAX=MIN0(LMAX+1,LCORE/NLTR)
C
C     READ IN CARD SET 4
C
      READ (5,9008)DRT,RMAX,FLCO
      IF(DRT.LE.0.0) DRT=0.1D0
      IF(RMAX.EQ.0.0) RMAX=20.D0
      LLCO=FLCO
      IF(LLCO.LT.0) LLCO=0
      WRITE(6,9028)DRT,RMAX,LLCO
      KT=NINT(ABS(RMAX)/DRT)
      KTMIN=KT
      CALL CUDATE(IDAT)
      WRITE(6,9019)ALPHA,IDAT
C      WRITE(6,9019)ALPHA,IDAT,XTIME
C
C     READ IN DIAGONAL CHANNEL CARD SETS
C
      DO 200 I=1,NLTR
      K=I
      JTRT(I)=IABS(LTRT(I))
      LTEMP=LTRT(I)
      TEMP=GAMMA(1)
      IF(PHASEF(LTRT(I)))86,85,85
   85 CONTINUE
      LTEMP=LTEMP/2
      TEMP=GAMMA(2)
   86 CONTINUE
      WRITE(6,9011)I,LTEMP,TEMP
C
C
      CALL KINEX(AKIN,W(1  ),ECM(1),DRT,K,KMAX,ICON)
      DO 140 M=1,19
      BKIN(I,M)=AKIN(M)
  140 CONTINUE
      IS(I)=FS(I)
      FS(I)=FS(I)/2.0
      NS(I)=IS(I)+1
C
C
      READ (5,9018)II,JJ,LAMBDA,ISPIN,JSPIN,ICODE,LDFRM(1),ICOUEX,ABETA
      LAMBDA=0
      DO 148 J=1,3
      LDFRM(J+1)=LDFRM(J)+2
      IF(ABETA(J).NE.0.0) WRITE(6,9007)LAMBDA,ABETA(J),LDFRM(J)
  148 CONTINUE
      DO 150 M=1,KMAX
      V(M  )=0.D0
  150 CONTINUE
      CALL POTENT(AKIN,W(1  ),V(1  ),KT,KMAX,ICODE,LAMBDA,LDFRM,ABETA
     1 ,JOUT,ICON,K)
      WRITE(9) W,V
      IF(ICON(11).EQ.0) GO TO 190
C
C     WRITE OUT K(I,I)**2 ELEMENTS
C
      WRITE(6,9901)I
      KT2=KT+KT
      IND=0
      R=DRF(I)
      DO 180 M=1,KT2,10
      INC=IND+1
      IND=MIN0(INC+9,KT2)
      WRITE(6,9900)R,(W(J  ),J=INC,IND)
      WRITE(7,9900)R,(W(J  ),J=INC,IND)
      R=R+5.0*DRF(I)
  180 CONTINUE
  190 CONTINUE
  200 CONTINUE
C
C
      JOUT=0
      KTFLG=0
C
C      READ IN CHANNEL COUPLING
C
      CALL CUDATE(IDAT)
      WRITE(6,9019)ALPHA,IDAT
      DO 210 I=1,8
      DO 210 J=1,8
      INN(I,J)=0
  210 CONTINUE
      LK=0
      NCUP=0
  220 CONTINUE
      READ (5,9018)II,JJ,LAMBDA,ISPIN,JSPIN,ICODE,LDFRM(1),ICOUEX,ABETA
     1,RCX,FNRNG,AGAMMA,VBETA
      ICOD=ICODE
      ICODE=IABS(ICODE)
      IF(ICOD.EQ.7.OR.(ICODE.LT.7.OR.ICODE.GT.8)) GO TO 221
      IF(ABS(VBETA).LT.1.0E-6) VBETA=1.D0
      BETAR= FNRNG/VBETA
      BETAI=AGAMMA/VBETA
  221 CONTINUE
      IF(II.EQ.0) GO TO 985
      IF(JJ.EQ.0) JJ=1
      I=IABS(II)
      J=IABS(JJ)
      MU=IABS(KLAM(I)-KLAM(J))
      WRITE(6,9017)II,JJ,ICODE
      LK=LK+1
      IF(LK.LE.NLKMAX) GO TO 232
  231 CONTINUE
      WRITE(6,9054)
      JOUT=2
      GO TO 2000
  232 CONTINUE
      NCUP=NCUP+1
      ICUP(NCUP)=J
      JCUP(NCUP)=I
      LKTAB(NCUP)=LK
      INN(I,J)=1
      IF(I.EQ.J) GO TO 260
      IF(II.LT.0) GO TO 260
      NCUP=NCUP+1
      ICUP(NCUP)=I
      JCUP(NCUP)=J
      LKTAB(NCUP)=LK
      INN(J,I)=1
  260 CONTINUE
      LAM(LK)=LAMBDA
      ISP(LK)=ISPIN
      IF(ISPIN.EQ.0) JSPIN=LAMBDA+LAMBDA
      JSP(LK)=JSPIN
C   THE FOLLOWING STATEMENT IS TO WRITE A ZERO FOR FNRNG SINCE FNRNG IS
C   GIVEN A VALUE FOR THE PURPOSE OF USING CORRECTION TERMS FOR BETA
C   AND OCTUPOLE VIBRATIONS
      IF(ICOD.EQ.-7.OR.ICOD.EQ.8)
     1WRITE(6,9037) LAM(LK),ISP(LK),JSP(LK),ICOUEX,RCX,ABETA(3)
      IF(ICOD.EQ.7.OR.(ICODE.LT.7.OR.ICODE.GT.8))
     1WRITE(6,9037) LAM(LK),ISP(LK),JSP(LK),ICOUEX,RCX,FNRNG
      IF(ICOD.EQ.7) WRITE(6,9038) AGAMMA
      IF(ICOD.EQ.-7) WRITE(6,9039) VBETA
      IF(ICOD.EQ.-7) WRITE(6,9041) FNRNG,AGAMMA
      IF(ICOD.EQ.8) WRITE(6,9040) VBETA
      IF(ICOD.EQ.8) WRITE(6,9042) FNRNG,AGAMMA
      DO 265 K=1,3
      LDFRM(K+1)=LDFRM(K)+2
      IF(ABETA(K).NE.0.0) WRITE(6,9007)LAM(LK),ABETA(K),LDFRM(K)
  265 CONTINUE
      IF(ABETA(1).NE.0.0) GO TO 270
      JOUT=1
      WRITE(6,9050)
  270 CONTINUE
C
C     CHECK COUPLING FOR CONSISTENCY
C
      IF(ISPIN.NE.0) GO TO 282
      IF((ISPIN.EQ.0).AND.(IS(I).EQ.IS(J))) GO TO 282
      JOUT = 1
      WRITE(6,9051)IS(I),IS(J),ISPIN
 282  CONTINUE
      IF(PHASEF(IS(I)+IS(J)+ISPIN).GT.0.0) GO TO 283
      JOUT=1
      WRITE(6,9051)IS(I),IS(J),ISPIN
  283 CONTINUE
      IF(PHASEF(LTRT(I)+LTRT(J)+JSPIN).GT.0.0) GO TO 284
      JOUT=1
      WRITE(6,9052)LTRT(I),LTRT(J),JSPIN
  284 CONTINUE
      IF(DFLOAT(ISIGN(1,LTRT(I))*ISIGN(1,LTRT(J)))
     X  *PHASEF(JPRT(I))*PHASEF(JPRT(J))
     1*PHASEF(LAMBDA).GT.0.0) GO TO 285
      JOUT=1
      WRITE(6,9053)LTRT(I),LTRT(J),LAMBDA
  285 CONTINUE
      IF(I.LE.NLTR) GO TO 286
      JOUT=1
      WRITE(6,9055)
  286 CONTINUE
      IF(J.LE.NLTR) GO TO 287
      JOUT=1
      WRITE(6,9055)
  287 CONTINUE
C
C
      BFACT=-ABETA(1)*2.0*AMU/HBARC**2
      ILK(LK)=ICODE
      IF(ICODE.EQ.0) GO TO 300
      IF(ICODE.EQ.1) GO TO 320
      IF(ICODE.EQ.2) GO TO 340
      IF(ICODE.EQ.3) GO TO 300
      IF(ICODE.EQ.4) GO TO 360
      IF(ICODE.EQ.5) GO TO 380
      IF(ICODE.EQ.6) GO TO 400
C
C    ICODE.EQ.7 FOR EXCITATION OF GAMMA BAND.OR. EXCITATION OF BETA BAND
C    ICODE.EQ.8 FOR EXCITATION OF OCTUPOLE BANDS
C
      IF(ICODE.EQ.7) GO TO 300
      IF(ICODE.EQ.8) GO TO 300
      WRITE(6,9056)ICODE
      JOUT=2
      GO TO 2000
C
C     COLLECTIVE FORM FACTOR
C
  300 CONTINUE
      IF(ICODE.NE.0) GO TO 305
      IF((KLAM(I).EQ.KLAM(J)).AND.PHASEF(JTRT(J)+KLAM(J)).GT.0.0)
     1  GO TO 305
      JOUT=1
      WRITE(6,9050)
  305 CONTINUE
      RCX=RCX*AFACT(J)
      IF(RCX.LT.0.0) RCX=RCX+RCX*FMFCT(J)
      RCX=ABS(RCX)
      AKIN(18)=FMFCT(J)
      AKIN(19)=1.D0
      AKIN(14)=AFACT(J)
      AKIN(15)=DRF(J)
      DO 310 M=1,KMAX
      MK=M+M-1
      X(MK  , 1)=0.D0
      X(MK+1, 1)=0.D0
  310 CONTINUE
C
      CALL POTENT(AKIN,X,SAV2,KT,KMAX,ICOD,LAMBDA
     1,LDFRM,ABETA,JOUT,ICON,0)
      TEMP = 1.D0
      IF(ICOD.EQ.7) TEMP=AGAMMA*ABETA(1)
      IF(ICOD.EQ.-7.OR.ICODE.EQ.8) TEMP=VBETA
      R = 0.D0
      SUMR1=0.D0
      SUMI1=0.D0
      SUMR2=0.D0
      SUMI2=0.D0
      DO 315 M=1,KT
      MK=M+M-1
      X(MK  ,1)=BFACT*X(MK  ,1)*TEMP
      X(MK+1,1)=BFACT*X(MK+1,1)*TEMP
      R=R+DRT
      R2=R*R
      RL=R2*R**LAMBDA
      IF(LAMBDA.EQ.0.OR.LAMBDA.EQ.1) RL=RL*R2
      SUMR2=SUMR2+X(MK  ,1)*RL
      SUMI2=SUMI2+X(MK+1,1)*RL
      IF(LAMBDA.GT.1) GO TO 315
      SUMR1=SUMR1+X(MK  ,1)*RL/R2
      SUMI1=SUMI1+X(MK+1,1)*RL/R2
  315 CONTINUE
      TEMP=ZA(I)*ABETA(1)/BFACT
      IX=JTRT(I)
      IY=JTRT(J)
      KLMM=KLAM(I)
      XIX=SQRT(DFLOAT(IX+1))
      LL2=2*LAMBDA
      IF(ICODE.EQ.0) TEMP=TEMP*XIX*VCC(IX,LL2,IY,KLMM,0)
      IF(ICODE.EQ.3) TEMP=TEMP*XIX/SQRT(DFLOAT(LL2+1))*PHASEF((IX-IY)/2)
      IF(ICODE.EQ.7.OR.ICODE.EQ.8) TEMP=TEMP*XIX*VCC(IX,LL2,IY,-KLMM,MU)
      SUMR2=TEMP*SUMR2/(12.56637*RHO0R)
      SUMI2=TEMP*SUMI2/(12.56637*RHO0I)
      SUMR1=TEMP*SUMR1/(12.56637*RHO0R)
      SUMI1=TEMP*SUMI1/(12.56637*RHO0I)
      IF(LAMBDA.NE.0) GO TO 313
C   THE MONOPOLE TRANSITION IS CALCULATED FOR THE OPERATOR (1/2)*R**2
      SUMR2=SUMR2*1.772454
      SUMI2=SUMI2*1.772454
  313 CONTINUE
      IF(LAMBDA.NE.1) GO TO 314
C   THE DIPOLE TRANSITION IS CALCULATED FOR THE OPERATOR (1/2)*R**3*Y1
      SUMR2=SUMR2*0.5
      SUMI2=SUMI2*0.5
  314 CONTINUE
      IF(LAMBDA.EQ.0) WRITE(6,9043) SUMR1,SUMI1,SUMR2,SUMI2
      IF(LAMBDA.EQ.1) WRITE(6,9044) SUMR1,SUMI1,SUMR2,SUMI2
      IF(LAMBDA.GT.1) WRITE(6,9045) LAMBDA,SUMR2,LAMBDA,SUMI2
      IF(INDDEF.EQ.1.AND.INDIM.EQ.1) THEN
        WRITE(6,9046)
        WRITE(6,9048)
        WRITE(6,9047)
      ELSEIF(INDDEF.EQ.1) THEN
        WRITE(6,9046)
        WRITE(6,9047)
      ELSEIF(INDIM.EQ.1) THEN
        WRITE(6,9048)
        WRITE(6,9047)
      ELSE
      ENDIF
      IF(ICOUEX.EQ.0) GO TO 318
C
C     CALCULATE COULOMB EXCITATION
C
      ETAK= 6.0*ETA(J)*FK(J)*RCX**LAMBDA
     1/(FMU(J)*DFLOAT(LAMBDA+LAMBDA+1))
      ETAK=-ABETA(1)*ETAK
      R=0.D0
      DO 316 M=1,KT
      R=R+DRF(I)
      IF(R.LT.RCX) GO TO 316
      MK=M+M-1
      X(MK  ,1)=X(MK  ,1)+ETAK/R**(LAMBDA+1)
  316 CONTINUE
  318 CONTINUE
      GO TO 960
C
C     SINGLE PARTICLE ORBITAL
C
  320 CONTINUE
      CALL KINEX(AKIN,SAV1,ECMT,DRT,0,KMAX,ICON)
      DO 330 M=1,KMAX
      MK=M+M-1
      SAV2(MK  )=0.D0
      SAV2(MK+1)=0.D0
  330 CONTINUE
      CALL POTENT(AKIN,SAV1,SAV2,KT,KMAX,1,0,0,0.D0,JOUT,ICON,0)
      DO 335 M=1,KMAX
      MK=M+M-1
      X(MK  ,1)=SAV1(MK)*BFACT
      X(MK+1,1)=0.D0
  335 CONTINUE
      GO TO 960
C
C     MICROSCOPIC MODEL FORM FACTOR
C
  340 CONTINUE
      DO 350 M=1,KMAX
      MK=M+M-1
      X(MK  , 1)=0.D0
      X(MK+1, 1)=0.D0
  350 CONTINUE
      DR=DRT
      IERR=0
      CALL CATHEN(LAMBDA,ISPIN,JSPIN,KT,KMAX,SAV1,SAV3,X,DR,ICON,IERR)
      IF(IERR.EQ.0) GO TO 352
      JOUT=IERR
      WRITE(6,9050)
  352 CONTINUE
      IF(KT.LT.0) KTFLG=MAX0(-KT,KTFLG)
      KT=IABS(KT)
      AKIN(15)=DR
      IF(ABS(FMA(J)-FMA(I)).GT.1.2) ILK(LK)=1
      DO 355 M=1,KMAX
      MK=M+M-1
      X(MK  , 1)=X(MK  , 1)*BFACT
      X(MK+1, 1)=X(MK+1, 1)*BFACT
  355 CONTINUE
      GO TO 960
C
C     'CLUSTER' (COLLECTIVE) COMPLEX F.F., HANDLED AS STRIPPING
C
  360 CONTINUE
      DO 365 M=1,KMAX
      MK=M+M-1
      X(MK  ,1)=0.D0
      X(MK+1,1)=0.D0
  365 CONTINUE
      CALL KINEX(AKIN,SAV1,ECMT,DRT,0,KMAX,ICON)
      AKIN(19)=1.D0
      CALL POTENT(AKIN,X,SAV2,KT,KMAX,ICODE,LAMBDA
     1,LDFRM,ABETA,JOUT,ICON,0)
      DO 368 M=1,KMAX
      MK=M+M-1
      X(MK  ,1)=BFACT*X(MK  ,1)
      X(MK+1,1)=BFACT*X(MK+1,1)
  368 CONTINUE
      GO TO 960
C
C     RESCALE LAST F.F. WITH NEW STRENGTH
C
  380 CONTINUE
      DO 390 M=1,KMAX
      MK=M+M-1
      X(MK  ,1)=ABETA(1)*X(MK  ,1)
      X(MK+1,1)=ABETA(1)*X(MK+1,1)
  390 CONTINUE
      ILK(LK)=ILK(LK-1)
      GO TO 960
C
C     STRONG COUPLING COLLECTIVE MODEL
C     SPECTROSCOPIC FACTOR ALGEBRA
C
  400 CONTINUE
      JT=JSPIN
      IF((PHASEF(JTRT(I)+KLAM(I)).GT.0.0).AND.
     1  (PHASEF(JTRT(J)+KLAM(J)).GT.0.0)) GO TO 402
      JOUT=1
      WRITE(6,9050)
  402 CONTINUE
      IF(FMA(J).GT.FMA(I)+0.2) GO TO 405
C     STRIPPING
      MK=KLAM(I)-KLAM(J)
      BFACT=BFACT*SQRT(DFLOAT(JTRT(J)+1)/DFLOAT(JTRT(I)+1))
     1*VCC(JTRT(J),JT,JTRT(I),KLAM(J),MK)
      GO TO 410
C     PICKUP
  405 CONTINUE
      MK=KLAM(J)-KLAM(I)
      BFACT=BFACT*SQRT(DFLOAT(JTRT(I)+1)/DFLOAT(JTRT(J)+1))
     1*VCC(JTRT(I),JT,JTRT(J),KLAM(I),MK)
  410 CONTINUE
      IF(MK.LT.0) BFACT=BFACT*PHASEF((JT-MK)/2)
      ILK(LK)=1
      GO TO 320
C
  960 CONTINUE
      IF(ICODE.EQ.7.OR.ICODE.EQ.8) GO TO 980
      IF((ABS(FNRNG)+ABS(PNLOC(I))+ABS(PNLOC(J))).EQ.0.0) GO TO 980
      IJ(1)=I
      IJ(2)=J
      REWIND 9
      I4=MIN0(I,J)-1
      IF(I4.EQ.0) GO TO 964
      DO 962 M=1,I4
      READ(9)
  962 CONTINUE
  964 CONTINUE
      READ(9) (SAV3(M),M=1,800)
      I4=IABS(J-I)-1
      IF(I4.LT.0) BACKSPACE 9
      IF(I4.LE.0) GO TO 968
      DO 966 M=1,I4
      READ(9)
  966 CONTINUE
  968 CONTINUE
      READ(9) (SAV3(M),M=801,1600)
      CALL FNLOC(SAV3,X,SAV2,LAMBDA,BKIN,FNRNG,KT,IJ,AKIN,ICODE,KMAX)
  980 CONTINUE
C
C     WRITE COUPLING ELEMENTS ON TAPE
C
      WRITE(8)(X(M,1),M=1,KMAX2)
C
C     WRITE OUT K(I,J)**2 ELEMENTS
C
      IF(ICON(12).EQ.0) GO TO  984
      WRITE(6,9902)I,J
      KT2=KT+KT
      DR=AKIN(15)
      IND=0
      R=DR
      DO 983 M=1,KT2,10
      INC=IND+1
      IND=MIN0(INC+9,KT2)
      WRITE(6,9900)R,(X(K,1),K=INC,IND)
      WRITE(7,9900)R,(X(K,1),K=INC,IND)
      R=R+5.0*DR
  983 CONTINUE
  984 CONTINUE
      GO TO 220
  985 CONTINUE
      IF(KTFLG.NE.0) KT=MIN0(KT,KTFLG-5)
      NLI(1)=LK
      NLI(2)=NCUP
      IF(RMAX.LT.0.0) KT=KTMIN
      L=LMAX-1
      WRITE(6,9021)L,KT
 2000 CONTINUE
      RETURN
C
 9004 FORMAT(26I3)
 9007 FORMAT(18H                  ,9H   LAM  =,I4,14H        BETA =,F9.3
     1,9H   LDFRM=,I4)
 9008 FORMAT(10F8.4)
 9009 FORMAT(18H0INPUT DATA       ,9H   DR   =,F9.4,9H   RMAX =,F9.4)
 9010 FORMAT(18H0ANGLE DATA       ,9H   THETN=,F9.4,9H   THET1=,F9.4,9H
     1  DTHET=,F9.4)
 9011 FORMAT( 8H0CHANNEL,I2,8X,9H   ISPIN=,I3,A3,2X,80(1H*))
 9017 FORMAT( 8H0CHANNEL,I2,10H - CHANNEL,I2,9H COUPLING ,5X,67(1H*)
     1,9H   ICODE=,I4 )
 9018 FORMAT(8I3,7F8.4)
 9019 FORMAT(1H1,17X,15A4,4X,I2,2(1H/,I2),I4,2(1H.,I2))
 9021 FORMAT(1H0,17X,9H   LMAX =,I4,5X,9H   NSTEP=,I4)
 9026 FORMAT(18H0ANG MOM DATA     ,9H   LMAX =,I4,14H        2*JTR=,8I4)
 9027 FORMAT(18H                  ,9H   NJTR =,I4,14H        2*KLM=,8I4)
 9028 FORMAT(18H0CARD SET 4 DATA   ,9H   DRF  =,F9.4,9H   RMAX =,F9.4,9H
     1   LLCO =,I4)
 9029 FORMAT(40X,5HJPRT=,8I4)
 9037 FORMAT(18H                  ,9H   LAM  =,I4,14H        2*STR=,I4,1
     14H        2*JTR=,I4,14H        ICOUX=,I4,9H   RCOUL=,F9.4,9H   FNR
     2NG=,F9.4)
 9038 FORMAT(1H0,20X,'FOR ICODE=7 GAMMA =',F7.4,/)
 9039 FORMAT(1H0,20X,'FOR ICODE=-7  BETA-BETA2 =',F7.4,/)
 9040 FORMAT(1H0,20X,'FOR ICODE=8 BETA3 =',F7.4,/)
 9041 FORMAT(1H0,20X,'CORRECTION TERM TO CONSERVE NUMBER OF PARTICLES FO
     1R A MONOPOLE BETA VIBRATION',
     2/21X,'BETA0R =',F7.4,'   BETA0I =',F7.4,/)
 9042 FORMAT(1H0,20X,'CORRECTION TERM TO REMOVE SPURIOUS CENTER OF MASS
     1MOTION FOR ISOSCALAR DIPOLE TRANSITIONS IN OCTUPOLE BANDS',
     2/21X,'BETA1R =',F7.4,'   BETA1I =',F7.4,/)
 9043 FORMAT(10X,'VOLUME REAL MONOPOLE MATRIX ELEMENT =',E15.6,
     110X,'VOLUME IMAGINARY MONOPOLE MATRIX ELEMENT =',E15.6,
     2/10X,'REAL MONOPOLE MATRIX ELEMENT        =',E15.6,
     310X,'IMAGINARY MONOPOLE MATRIX ELEMENT        =',E15.6)
 9044 FORMAT(10X,'CENTER OF MASS REAL MATRIX ELEMENT =',E15.6,
     110X,'CENTER OF MASS IMAGINARY MATRIX ELEMENT =',E15.6,
     2/10X,'REAL DIPOLE MATRIX ELEMENT         =',E15.6,
     310X,'IMAGINARY DIPOLE MATRIX ELEMENT         =',E15.6)
 9045 FORMAT(10X,I1,'TH POLE REAL MATRIX ELEMENT =',E15.6,
     110X,I1,'TH POLE IMAGINARY MATRIX ELEMENT =',E15.6)
 9046 FORMAT(1X,'WARNING: BECAUSE OF IMPROPER NORMALIZATION, THE MATRIX
     1 ELEMENT FOR THIS DEFORMED FORM FACTOR CAN BE QUITE OFF.')
 9047 FORMAT(1X,'         USE  B E L G E N  TO CALCULATE THE CORRECT
     1 MATRIX ELEMENTS.')
 9048 FORMAT(1X,'WARNING: IMAGINARY MATRIX ELEMENTS ARE NOT CORRECT. TH
     1EY SHOULD BE CALCULATED SEPARATELY FOR EACH IMAGINARY POTENTIAL')
 9050 FORMAT(26H0NO TRANSITION STRENGTH   ,50(1H$))
 9051 FORMAT(39H0SPINS DO NOT SATISFY PROPER STATISTICS,10H  2*IS(I)=,I2
     1,10H  2*IS(J)=,I2,8H  2*STR=,I2,3X,50(1H$))
 9052 FORMAT(39H0SPINS DO NOT SATISFY PROPER STATISTICS,10H  2*I (I)=,I2
     1,10H  2*I (J)=,I2,8H  2*JTR=,I2,3X,50(1H$))
 9053 FORMAT(22H0PARITY DOES NOT CHECK ,10H   2*J(I)=,I2,10H   2*J(J)=,
     1 I2,10H   LAMBDA=,I2,3X,60(1H$))
 9054 FORMAT(30H0TOO MANY CHANNEL COUPLINGS   ,90(1H$))
 9055 FORMAT(30H0COUPLING.GT.NO. OF CHANNELS  )
 9056 FORMAT(20H0ICODE.GT.8, ICODE= ,I2)
 9901 FORMAT(1H0,7HCHANNEL,I3,15H  DIAGONAL K**2)
 9902 FORMAT(1H0,7HCHANNEL,I3,10H - CHANNEL,I3,10H  COUPLING)
 9900 FORMAT(F6.2,10E12.3)
      END
      SUBROUTINE KINEX(AKIN,W,ECMT,DRT,I,KMAX,ICON)
      IMPLICIT REAL*8(A-H,O-Z)
C     SQRT(XXX)=DSQRT(XXX)
C     ABS(XXX)=DABS(XXX)
C     USE THE NEXT 1 CARDS FOR 32-BIT MACHINES
C modified by (JE,ME)
      DOUBLE PRECISION Q,ECM1,FM1,FM2,FMT,W1,W2,T1
      DIMENSION AKIN(32),BKIN(32),W(800),ICON(20)
      EQUIVALENCE (EN,BKIN(1)),(FM,BKIN(2)),(Z,BKIN(3)),(FMA,BKIN(4))
     1,(ZA,BKIN(5)),(RY,BKIN(6)),(FS,BKIN(7)),(ECM,BKIN(8))
     2,(FMU,BKIN(9)),(RC,BKIN(10)),(FK2,BKIN(11)),(FK,BKIN(12))
     3,(ETA,BKIN(13)),(AFACT,BKIN(14)),(DRF,BKIN(15)),(FN,BKIN(16))
     4,(PNLOC,BKIN(17)),(BFACT,BKIN(18)),(FACT,BKIN(19))
      DATA HBARC,AMU/197.329,931.502/
C modified by (JE,ME)
      SAVE
C
C
      IREL=ICON(10)
      ICON2=ICON(2)
      READ (5,9000)Q ,FM,Z,FMA,ZA,RY,AC,PNLOC,FS,FN
      IF(I.NE.1) GO TO 50
      EN=Q
      ECM1=EN*FMA/(FM+FMA)
      FMA1=FMA
      Q=0.D0
      GO TO 52
   50 CONTINUE
      Q=Q+FN
   52 CONTINUE
      FMU=FM*FMA/(FM+FMA)
      IF(I.NE.0) GO TO 55
      EN=Q
      ECM=Q
      ECM1=0.D0
      GO TO 56
   55 CONTINUE
      EN=(ECM1+Q )*FM/FMU
      ECM=EN*FMU/FM
   56 CONTINUE
      DRF=DRT*FMA1/FMA
      AFACT=FMA**.333333333
      BFACT=FM **.333333333
      RC=ABS(RY)*AFACT
      IF(RY.LT.0.0) RC=RC+ABS(RY)*BFACT
      IF(IREL.EQ.0) GO TO 75
C
C     IREL=ICON(10).NE.0 GIVES RELATIVISTIC KINEMATICS
C
      IF(I.EQ.0) GO TO 66
      IF(I.EQ.1) GO TO 66
      IF(FN .GT.0.0) GO TO 66
      EN=EN+(ECM1+Q)**2/(2.0*FMA*AMU)
   66 CONTINUE
      E=EN
      FM1=FM*AMU
      FM2=FMA*AMU
      FMT=FM1+FM2
      IF(I.EQ.0) E=EN*(0.5*EN+FMT)/FM2
      T1=SQRT(2.0*E*FM2+FMT*FMT)
      W1=(FMT*FM1+FM2*E)/T1
      W2=FM2*(E+FMT)/T1
      FMU=W1*W2/(W1+W2)
      ECM=T1-FMT
      IF(I.EQ.1) ECM1=ECM
      FACT=2.0*FMU/(HBARC*HBARC)
      FMU=FMU/AMU
      FK2=(E*E+2.0*E*FM1)*(FM2/(T1*HBARC))**2
      GO TO 76
   75 CONTINUE
      FACT=2.0*FMU*AMU/(HBARC*HBARC)
      FK2=ECM*FACT
   76 CONTINUE
      IF(FK2.EQ.0.0) GO TO 80
      FK=SQRT(ABS(FK2))
      ETAK=1.43998*Z*ZA*FACT
      ETA=0.5*ETAK/FK
      GO TO 81
   80 CONTINUE
      FK=0.D0
      ETA=0.D0
      ETAK=0.D0
   81 CONTINUE
      ECMT=ECM1
      Q=ECM-ECM1
      IF((I.EQ.0).AND.(ICON2.GE.3)) GO TO 82
      WRITE(6,9012)EN,RY,FS
      WRITE(6,9013)FM,FMA,Q
      WRITE(6,9014)Z,ZA,DRF,PNLOC
      RHO=FK*RC
      WRITE(6,9015)ECM,RC,RHO
      DRHOC=DRF*FK
      WRITE(6,9016)FK,ETA,DRHOC
   82 CONTINUE
      R=0.D0
      RC2=RC*RC
      F1=0.5*ETAK/RC
      DO 100 M=1,KMAX
      R=R+DRF
      MK=M+M-1
      IF(R.GT.RC) GO TO 90
      FC=F1*(3.0-R*R/RC2)
      GO TO 95
   90 CONTINUE
      FC=ETAK/R
   95 CONTINUE
      IF(I.EQ.0) GO TO 98
      W(MK  )=FK2-FC
      W(MK+1)=0.D0
      GO TO 99
   98 CONTINUE
      W(MK+1)=FK2-FC
      W(MK  )=0.D0
   99 CONTINUE
  100 CONTINUE
C
C
      DO 110 J=1,32
      AKIN(J)=BKIN(J)
  110 CONTINUE
      RETURN
 9000 FORMAT(10F8.4)
 9012 FORMAT(18H0INPUT DATA       ,9H   ELAB =,F9.4,9H   RC0  =,F9.4,
     19H   2*S  =,F9.4)
 9013 FORMAT(18H                  ,9H   MASSP=,F9.4,9H   MASST=,F9.4,
     19H   Q    =,F9.4)
 9014 FORMAT(18H                  ,9H   ZP   =,F9.4,9H   ZT   =,F9.4,
     19H   DR   =,F9.4,9H   PNLOC=,F9.4)
 9015 FORMAT(18H0DERIVED DATA     ,9H   ECM  =,F9.4,9H   RC   =,F9.4,
     19H   RHOC =,F9.4)
 9016 FORMAT(18H                  ,9H   K    =,F9.4,9H   ETA  =,F9.4,
     19H   DRHOC=,F9.4)
      END
      SUBROUTINE POTENT(AKIN,U,V,K,KMAX,ICODET,LAM,LDFRM,ABETA,IERR
     1 ,ICON,IPART)
      IMPLICIT REAL*8(A-H,O-Z)
C     SQRT(XXX)=DSQRT(XXX)
C     ABS(XXX)=DABS(XXX)
C     AMAX1(XXX,YYY)=DMAX1(XXX,YYY)
C     EXP(XXX)=DEXP(XXX)
C     FLOAT(III)=DFLOAT(III)
C     AMIN1(XXX,YYY)=DMIN1(XXX,YYY)
C     DOUBLE PRECISION B
      COMMON /KPROJ/ MU
      COMMON /CORR/ BETAR,BETAI,VBETA,RHO0R,RHO0I,INDDEF,INDIM
      DIMENSION U(800),V(800),UT(5),G(4),ICON(20)
     1,        AKIN(32),BKIN(32),CN(16),YLAM(16),X( 8),W( 8),B(3,17)
     2,CP(16),LDFRM(3),ABETA(3),BETA(3),FACTR(3)
      DIMENSION UB(800),VB(1600)
      EQUIVALENCE (G(1),FN),(G(2),FL),(G(3),FJ2),(G(4),FSS)
      EQUIVALENCE (EN,BKIN(1)),(FM,BKIN(2)),(Z,BKIN(3)),(FMA,BKIN(4))
     1,(ZA,BKIN(5)),(RY,BKIN(6)),(FS,BKIN(7)),(ECM,BKIN(8))
     2,(FMU,BKIN(9)),(RC,BKIN(10)),(FK2,BKIN(11)),(FK,BKIN(12))
     3,(ETA,BKIN(13)),(AFACT,BKIN(14)),(DRF,BKIN(15))
     4,(PNLOC,BKIN(17)),(BFACT,BKIN(18)),(FACT,BKIN(19))
     5,(BIF,BKIN(28)),(G,BKIN(29))
      DATA B(1,1),B(2,1),B(3,1)/6H NX=1 ,6HVOLUME,6H W-S  /
      DATA B(1,2),B(2,2),B(3,2)/6H NX=2 ,6HSURFAC,6HE W-S /
      DATA B(1,3),B(2,3),B(3,3)/6H NX=3 ,6H2ND DE,6HRIV   /
      DATA B(1,4),B(2,4),B(3,4)/6H NX=4 ,6HL.S VO,6HLUME  /
      DATA B(1,5),B(2,5),B(3,5)/6H NX=5 ,6HL.S SU,6HRFACE /
      DATA B(1,6),B(2,6),B(3,6)/6H NX=6 ,6HVOL*R*,6H*POWR /
      DATA B(1,7),B(2,7),B(3,7)/6H NX=7 ,6HSUR*R*,6H*POWR /
      DATA B(1,8),B(2,8),B(3,8)/6H NX=8 ,6H2DER*R,6H**PWR /
      DATA B(1,9),B(2,9),B(3,9)/6H NX=9 ,6HHARMON,6HIC OSC/
      DATA B(1,10),B(2,10),B(3,10)/6H NX=10,6H GAUSS,6HIAN   /
      DATA B(1,11),B(2,11),B(3,11)/6H NX=11,6H DEFOR,6HM VOL /
      DATA B(1,12),B(2,12),B(3,12)/6H NX=12,6H DEFOR,6HM SURF/
      DATA B(1,13),B(2,13),B(3,13)/6H NX=13,6H DEFOR,6HM 2DER/
      DATA B(1,14),B(2,14),B(3,14)/6H NX=14,6H EXTER,6H FORMF/
      DATA B(1,15),B(2,15),B(3,15)/6H NX=15,6H FOLD ,6HFORMF /
      DATA B(1,16),B(2,16),B(3,16)/6H NX=16,6H WATSO,6HN L.S /
      DATA B(1,17),B(2,17),B(3,17)/6H NX= O,6HUT OF ,6HRANGE /
      DATA X/0.0950125098,0.2816035507,0.4580167776,0.6178762444,
     1       0.7554044083,0.8656312023,0.9445750230,0.9894009439/
      DATA W/0.1894506104,0.1826034150,0.1691565193,0.1495959888,
     1       0.1246289712,0.0951585116,0.0622535239,0.0271524594/
      DATA SQRPI,PI/1.772453851,3.141593/
      DATA ETA4,ETA5,ETA6/ 4.D0,10.D0,60.D0/
      DATA F4PI/12.56637061/
C
      IND=0
      INDDEF=0
      INDIM=0
      RHO0R=0.D0
      RHO0I=0.D0
      ICOD=ICODET
      ICODE=IABS(ICODET)
      ICO=ICODE
      IF(ICODE.EQ.0.OR.ICODE.EQ.3.OR.ICODE.EQ.7.OR.ICODE.EQ.8) ICO=0
C
      ICON2=ICON(2)
      IF((IPART.EQ.0).AND.(ICON2.GE.3)) GO TO 40
      WRITE(6,9008)
   40 CONTINUE
      DO 45 M=1,32
      BKIN(M)=AKIN(M)
   45 CONTINUE
      DR=DRF
      RM=0.D0
C
C
C     READ IN CARD SET 5,6,OR 7   POTENTIAL CARDS
C
   70 CONTINUE
      IF(IND.EQ.0) GO TO 71
      READ(5,9000) BETAR,BETAI
      IF(ICOD.EQ.-7) WRITE(6,9002) BETAR,BETAI
      IF(ICOD.EQ.8) WRITE(6,9003) BETAR,BETAI
      BETAR=BETAR/VBETA
      BETAI=BETAI/VBETA
      IND=0
   71 CONTINUE
      READ (5,9000)FZ,VR,RY,AR,VSOR,VI,RZ,AI,VSOI,PWR
      NX=ABS(FZ)
      VRT=VR
      VIT=VI
      IF(NX.LE. 0) NX=17
      IF(NX.GT.17) NX=17
      RR=ABS(RY)*AFACT
      RI=ABS(RZ)*AFACT
      IF(RY.LT.0.0) RR=RR+ABS(RY)*BFACT
      IF(RZ.LT.0.0) RI=RI+ABS(RZ)*BFACT
   74 CONTINUE
      IF((IPART.EQ.0).AND.(ICON2.GE.3)) GO TO 75
      WRITE(6,9509)(B(J,NX),J=1,3),VR,RY,AR,RR,VSOR
      WRITE(6,9510)                VI,RZ,AI,RI,VSOI,PWR
   75 CONTINUE
      RY=ABS(RY)
      RZ=ABS(RZ)
C      NX=1 VOLUME WOODS-SAXON
C      NX=2 SURFACE WOODS-SAXON
C      NX=3 SECOND DERIVATIVE WOODS-SAXON
C      NX=4 L.S POTENTIAL FOR WOODS-SAXON VOLUME
C      NX=5 L.S POTENTIAL FOR WOODS-SAXON SURFACE
C      NX=6 WOOD-SAXON*R**PWR
C      NX=7 1ST-DER WOOD-SAXON*R**PWR
C      NX=8 2ND-DER WOOD-SAXON*R**PWR
C      NX=9 HARMONIC OSCILLATOR
C      NX=10 GAUSSIAN*R**PWR
C      NX=11 DEFORMED VOLUME
C      NX=12 DEFORMED SURFACE
C      NX=13 DEFORMED SECOND DERIVATIVE
C      NX=14 FORMF EXTERNAL FORM FACTOR
C      NX=15 FOLDING FORM FACTOR
C      NX=16 WATSON L.S POTENTIAL
      KFLAG=0
      VR=VR*FACT
      VI=VI*FACT
      IF(ICODE.EQ.1) GO TO 81
      IF(ICODE.EQ.2) GO TO 81
      KT=FK*MAX(RR,RI)+ETA5
      LPLUS=MAX0(LPLUS,KT)
   80 CONTINUE
      KT=(2.3*ETA4*MAX(AR,AI)+MAX(RR,RI))/DR
      GO TO 82
   81 CONTINUE
      RM=MAX(RR,RM)
      IF(EN.GT.0.0) GO TO 80
      ALPHB=2.3*ETA4
      TEMP=1.0+ALPHB/10.0
      KT=((ALPHB-ETA*TEMP)/FK+RR)/DR
   82 CONTINUE
      K=MIN0(MAX0(K,KT),KMAX)
   83 CONTINUE
      IF(AR.NE.0.0) GO TO 85
      F1=0.D0
      F2=0.D0
      GO TO 86
   85 CONTINUE
      F2=EXP(-DR/AR)
      F1=EXP( RR/AR)
   86 CONTINUE
      IF(AI.NE.0.0) GO TO 95
      F3=0.D0
      F4=0.D0
      GO TO 96
   95 CONTINUE
      F4=EXP(-DR/AI)
      F3=EXP( RI/AI)
   96 CONTINUE
      IF(IPART.NE.0) GO TO 98
      IF(ICO  .NE.0) GO TO 98
      IF(ICODE.EQ.7.OR.ICODE.EQ.8) GO TO 97
      IF(NX.GT.5) GO TO 98
   97 CONTINUE
      IF(ICODE.EQ.7.AND.NX.LT.12) GO TO 3010
      IF (ICODE .EQ. 7 .AND. NX .GT. 15) GOTO 3010
      IF(ICODE.EQ.8.AND.NX.LT.12) GO TO 3020
      IF(ICODE.EQ.8.AND.NX.GT.15) GO TO 3020
      IF(NX.EQ.14.OR.NX.EQ.15) GO TO 98
      PWR=PWR+1.D0
      IF(AR.NE.0.0) VR=VR*(RR/AR)**PWR
      IF(AI.NE.0.0) VI=VI*(RI/AI)**PWR
   98 CONTINUE
      IF(NX.GT.16) GO TO 2009
C  THIS SECTION IS ADDED TO CALCULATE VOLUME INTEGRALS OF THE REAL AND
C  IMAGINARY PARTS OF THE OMP TO USE FOR NORMALIZATION OF THE MULTIPOLE
C  MOMENTS OF THESE POTENTIALS AS CALCULATED IN SUBROUTINE ACHK. SINCE
C  THIS IS NOT DONE PROPERLY FOR DEFORMED POTENTIALS, IT GIVES ONLY
C  APPROXIMATE VALUES FOR THESE CASES. ALSO IN THE CASE OF MORE THAN ONE
C  IMAGINARY POTENTIAL THE MULTIPOLE MOMENTS ARE NOT CORRECT. FOR ALL
C  THESE CASES USE PROGRAM  BELGEN  TO OBTAIN THE CORRECTLY NORMALIZED
C  MULTIPOLE MOMENTS.
      IF(ICO.NE.0.OR.IPART.NE.0) GOTO 12
      IF(ABS(RHO0I).GT.1.0E-7) THEN
        INDIM=1
        GOTO 12
      ENDIF
      F5=F1
      F6=F3
      IF(LAM.NE.0) GOTO 2
      IF(ICODE.NE.3) GOTO 1
      IF(PWR.NE.0.0) GOTO 12
      MNX=NX-5
      VRT=VRT/3.
      VIT=VIT/3.
      GOTO 7
    1 IF(ICODE.NE.7) GOTO 12
      MNX=NX-11
      GOTO 7
    2 IF(LAM.NE.1) GOTO 4
      IF(ICODE.NE.3) GOTO 3
      IF(PWR.NE.1.0) GOTO 12
      MNX=NX-5
      VRT=VRT*RR/10.
      VIT=VIT*RI/10.
      GOTO 7
    3 IF(ICODE.NE.8) GOTO 12
      MNX=NX-11
      GOTO 7
    4 IF(ICODE.NE.0) GOTO 5
      IF(NX.EQ.2.OR.NX.EQ.11) MNX=1
      IF(NX.EQ.3.OR.NX.EQ.12) MNX=2
      GOTO 7
    5 IF(ICODE.NE.3) GOTO 6
      MNX=NX-1
      GOTO 7
    6 MNX=NX-11
    7 CONTINUE
      IF(NX.GE.11) INDDEF=1
      R=0.D0
      DO 11 M=1,K
      R=R+DR
      R2=R*R
      F5=F5*F2
      F6=F6*F4
      XTEMP=1.D0
      IF(M.EQ.1.OR.M.EQ.K) XTEMP=0.5D0
      IF(MNX.EQ.1) GOTO 8
      IF(MNX.EQ.2) GOTO 9
      GOTO 11
    8 IF(VR.NE.0.) RHO0R=RHO0R+XTEMP*VRT*R2*F5/(1.0+F5)
      IF(VI.NE.0.) RHO0I=RHO0I+XTEMP*VIT*R2*F6/(1.0+F6)
      GOTO 11
    9 IF(VR.NE.0.) RHO0R=RHO0R-XTEMP*VRT*R2*F5/(1.0+F5)**2
      IF(VI.NE.0.) RHO0I=RHO0I-XTEMP*VIT*R2*F6/(1.0+F6)**2
   11 CONTINUE
   12 CONTINUE
C   
      GO TO (100,200,300,400,500,600,700,800,900,1000,
     1  1100,1200,1300,1400,1500,1600), NX
C
C     VOLUME WOODS SAXON
C
  100 CONTINUE
      DO 160 M=1,K
      MK=M+M-1
      F1=F1*F2
      F3=F3*F4
      U(MK  )=U(MK  )-VR*F1/(1.0+F1)
      U(MK+1)=U(MK+1)-VI*F3/(1.0+F3)
  160 CONTINUE
      GO TO 2000
C
C     1ST DER WOODS SAXON
C
  200 CONTINUE
      DO 260 M=1,K
      MK=M+M-1
      F1=F1*F2
      F3=F3*F4
      U(MK  )=U(MK  )+VR*F1/(1.0+F1)**2
      U(MK+1)=U(MK+1)+VI*F3/(1.0+F3)**2
  260 CONTINUE
      GO TO 2000
C
C     2ND DER WOODS SAXON
C
  300 CONTINUE
      DO 360 M=1,K
      MK=M+M-1
      F1=F1*F2
      F3=F3*F4
      U(MK  )=U(MK  )-VR*F1*(1.0-F1)/(1.0+F1)**3
      U(MK+1)=U(MK+1)-VI*F3*(1.0-F3)/(1.0+F3)**3
  360 CONTINUE
      GO TO 2000
C
C     L.S VOLUME WOODS SAXON
C
  400 CONTINUE
      IF(AR.NE.0.0) VR=VR/AR
      R=0.D0
      DO 460 M=1,K
      R=R+DR
      F1=F1*F2
      V(M)=V(M)-VR*F1/(R*(1.0+F1)**2)
  460 CONTINUE
      GO TO 2000
C
C     L.S 1ST DER WOODS SAXON
C
  500 CONTINUE
      IF(AR.NE.0.0) VR=VR/AR
      SPO=0.D0
      IF(VSOR.GT.0.0)SPO=1.D0
      R=0.D0
      DO 560 M=1,K
      R=R+DR
      F1=F1*F2
      TEMP=1.D0+F1
      V(M)=V(M)+VR*F1*((1.-F1)/TEMP+SPO*AR/R)/(R*TEMP*TEMP)
  560 CONTINUE
      GO TO 2000
C
C     WOOD SAXON*R**PWR
C
  600 CONTINUE
      R=0.D0
      DO 660 M=1,K
      R=R+DR
      MK=M+M-1
      F1=F1*F2
      F3=F3*F4
      RPWR=R**PWR
      U(MK  )=U(MK  )-VR*F1*RPWR/(1.0+F1)
      U(MK+1)=U(MK+1)-VI*F3*RPWR/(1.0+F3)
  660 CONTINUE
      GO TO 2000
C
C      1ST DER WOOD SAXON*R**PWR
C
  700 CONTINUE
      R=0.D0
      DO 760 M=1,K
      R=R+DR
      MK=M+M-1
      F1=F1*F2
      F3=F3*F4
      RPWR=R**PWR
      U(MK  )=U(MK  )+VR*F1*RPWR/(1.0+F1)**2
      U(MK+1)=U(MK+1)+VI*F3*RPWR/(1.0+F3)**2
  760 CONTINUE
      GO TO 2000
C
C     2ND DER WOODS-SAXON*R**PWR
C
  800 CONTINUE
      R=0.D0
      DO 860 M=1,K
      R=R+DR
      MK=M+M-1
      F1=F1*F2
      F3=F3*F4
      RPWR=R**PWR
      U(MK  )=U(MK  )-VR*RPWR*F1*(1.0-F1)/(1.0+F1)**3
      U(MK+1)=U(MK+1)-VI*RPWR*F3*(1.0-F3)/(1.0+F3)**3
  860 CONTINUE
      GO TO 2000
C
C     HARMONIC OSCILLATOR
C
  900 CONTINUE
      READ (5,9000)G
      WRITE(6,9508)G
      RY=ABS(RY)
      F1=1.0/RY**2
      F2=F1/RY
      F3=0.5D0
      F4=SQRPI*0.5
      L=FL
      IF(L.EQ.0) GO TO 931
      DO 930 I=1,L
      F3=F3+1.D0
      F4=F4*F3
      F2=F2*F1
  930 CONTINUE
  931 CONTINUE
      NN=FN
      T1=1.D0
      T2=F4
      CN(1)=(-1.0)**NN
      IF(NN.EQ.0) GO TO 941
      DO 940 I=1,NN
      F3=F3+1.D0
      T1=T1*FLOAT(I)
      T2=T2*F3
      CN(I+1)=-CN(I)*F1*FLOAT(NN+1-I)/(FLOAT(I)*F3)
  940 CONTINUE
  941 CONTINUE
      T2=SQRT(2.0*F2*T2/T1)/F4
      IF(VR.NE.0.0) T2=T2*VR
      KT=10.0*RY/DR
      KT=MIN0(KT,K)
      R=0.D0
      F1=F1/2.0
      DO 960 M=1,KT
      MK=M+M-1
      R=R+DR
      R2=R**2
      F2=CN(1)
      IF(NN.EQ.0) GO TO 951
      F3=1.D0
      DO 950 I=1,NN
      F3=F3*R2
      F2=F2+CN(I+1)*F3
  950 CONTINUE
  951 CONTINUE
      U(MK  )=U(MK  )+F2*T2*EXP(-F1*R2)*R**L
  960 CONTINUE
      GO TO 2000
C
C     EXP(-((R-R0)/A)**2)*R**POWR
C
 1000 CONTINUE
      IF(VR.EQ.0.0) GO TO 1061
      IF(AR.EQ.0.0) GO TO 1061
      M1=NINT((RR-6.0*AR)/DR)+1
      M1=MAX0(M1,1)
      M2=NINT((RR+6.0*AR)/DR)+1
      M2=MIN0(M2,K)
      R=FLOAT(M1-1)*DR
      DO 1060 M=M1,M2
      MK=M+M-1
      R=R+DR
      TEMP=((R-RR)/AR)**2
      U(MK  )=U(MK  )-VR*EXP(-TEMP)*R**PWR
 1060 CONTINUE
 1061 CONTINUE
      IF(VI.EQ.0.0) GO TO 1071
      IF(AI.EQ.0.0) GO TO 1071
      M1=NINT((RI-6.0*AI)/DR)+1
      M1=MAX0(M1,1)
      M2=NINT((RI+6.0*AI)/DR)+1
      M2=MIN0(M2,K)
      R=FLOAT(M1-1)*DR
      DO 1070 M=M1,M2
      MK=M+M-1
      R=R+DR
      TEMP=((R-RI)/AI)**2
      U(MK+1)=U(MK+1)-VI*EXP(-TEMP)*R**PWR
 1070 CONTINUE
 1071 CONTINUE
      GO TO 2000
C
C   THE FOLLOWING STATEMENTS ARE INCLUDED TO TREAT CORRECTION TERMS FOR
C   BETA AND OCTUPOLE VIBRATIONS
C
 1099 CONTINUE
      IND=1
      VR=VR*BETAR
      VI=VI*BETAI
C
C
C     DEFORMED VOLUME OR SURFACE BY YLM EXPANSION
C     ALSO DEFORMED THE POTENTIALS FOR COUPLINGS OF BETA, GAMMA
C     AND OCTUPOLE BANDS
C
 1100 CONTINUE
      IF(VBETA.EQ.1.0.AND.IND.EQ.0) GO TO 1171
      DO 1101 I=1,3
      BETA(I)=ABETA(I)
      FACTR(I)=SQRT(DFLOAT(LDFRM(I)+LDFRM(I)+1))*BETA(I)/(SQRPI*2.0)
 1101 CONTINUE
      LMAX=MAX0(LAM,LDFRM(3))+1
      LTEMP=2
      IF(ICOD.EQ.8) LTEMP=3
      IF(IND.EQ.1.AND.ICOD.EQ.-7) LTEMP=0
      IF(IND.EQ.1.AND.ICOD.EQ. 8) LTEMP=1
      IF(ICODE.EQ.7.OR.ICODE.EQ.8) LMAX=MAX0(LAM+LTEMP,LDFRM(3))+1
      DO 1103 I=1,8
      YLAM(I  )=0.D0
 1103 YLAM(I+8)=0.D0
      T2=(-1.0)**LAM
      T1=(-1.0)**LDFRM(1)
      DO 1109 I=1,8
      CN(I  )=0.D0
      CN(I+8)=0.D0
      P2=0.D0
      P3=1.D0
      Z=X(I)
      DO 1108 M=1,LMAX
      L=M-1
      FL=L-1
      IF(L.EQ.0) GO TO 1102
      P3=((2.0*FL+1.0)*Z*P2-FL*P1)/(FL+1.0)
 1102 CONTINUE
      DO 1104 J=1,3
      IF(L.NE.LDFRM(J)) GO TO 1104
      CN(I  )=CN(I  )+P3*FACTR(J)
      CN(I+8)=CN(I+8)+P3*FACTR(J)*T1
 1104 CONTINUE
      IF(ICODE.EQ.8.OR.ICODE.EQ.7) GO TO 1106
      GO TO 1105
 1106 CONTINUE
      IF(IABS(L-LAM).GT.LTEMP.OR.L+LAM.LT.LTEMP) GO TO 1107
      T3=SQRT(DFLOAT((LTEMP+LTEMP+1)*(L+L+1))/DFLOAT(LAM+LAM+1))*0.5
     1/SQRPI*VCC(L+L,LTEMP+LTEMP,LAM+LAM,0,0)*VCC(L+L,LTEMP+LTEMP,
     2LAM+LAM,0,MU)*P3*W(I)*SQRT(DFLOAT(L+L+1))*SQRPI
      YLAM(I  )=YLAM(I  )+T3
      YLAM(I+8)=YLAM(I+8)+T3
      GO TO 1107
 1105 IF(L.NE.LAM) GO TO 1107
      YLAM(I  )= P3*W(I)*SQRT(DFLOAT(L+L+1))*SQRPI
      YLAM(I+8)=YLAM(I  )*T2
 1107 CONTINUE
      P1=P2
      P2=P3
 1108 CONTINUE
 1109 CONTINUE
      DO 1170 I=1,2
      GO TO (1110,1120),I
 1110 CONTINUE
      IF(VR.EQ.0.0) GO TO 1170
      VX=VR
      RX=RR
      AX=AR
      F1=1.D0
      FTEMP=F2
      IFL=-1
      GO TO 1130
 1120 CONTINUE
      IF(VI.EQ.0.0) GO TO 1170
      VX=VI
      RX=RI
      AX=AI
      F1=1.D0
      FTEMP=F4
      IFL=0
 1130 CONTINUE
      DO 1135 J=1,16
      CP(J)=EXP((1.D0+CN(J))*RX/AX)
 1135 CONTINUE
      VX=VX/BETA(1)
      IF(LAM.EQ.0.AND.ICODE.NE.7) VX=-VX*BETA(1)/(2.0*SQRPI)
      JT=NX-10
      DO 1160 M=1,K
      MK=M+M+IFL
      VTEMP=0.D0
      F1=F1*FTEMP
      DO 1155 J=1,16
      F3=F1*CP(J)
      GO TO (1140,1145,1150), JT
 1140 CONTINUE
      VTEMP=VTEMP+YLAM(J)*VX*F3/(1.0+F3)
      GO TO 1155
 1145 CONTINUE
      VTEMP=VTEMP-YLAM(J)*VX*F3/(1.0+F3)**2
      GO TO 1155
 1150 CONTINUE
      VTEMP=VTEMP+YLAM(J)*VX*F3*(1.0-F3)/(1.0+F3)**3
 1155 CONTINUE
      U(MK  )=U(MK  )+VTEMP
 1160 CONTINUE
 1170 CONTINUE
 1171 CONTINUE
      IF(ICOD.EQ.7.OR.(ICODE.LT.7.OR.ICODE.GT.8)) GO TO 2000
      IF(IND.EQ.0) GO TO 1099
      GO TO 2000
 1200 CONTINUE
      GO TO 1100
 1300 CONTINUE
      GO TO 1100
C
C     EXTERNAL FORM FACTOR
C
 1400 CONTINUE
      READ(2,9000) F1,F2
      WRITE(6,9513) F1,F2
      F3=VR
      IGT=F2+1.D0
      IF(MOD(IGT,2).EQ.0) F3=VI
      IF(F3.EQ.0) F3=1.D0
      KT=F1
      IF(IGT.GT.2) GO TO 1440
      MK=IGT
      DO 1430 M=1,KT,5
      READ(2,9100) UT
      IF(M.GT.KMAX) GO TO 1430
      DO 1420 I=1,5
      U(MK  )=U(MK  )-UT(I)*F3
      MK=MK+2
 1420 CONTINUE
 1430 CONTINUE
      GO TO 1480
 1440 CONTINUE
      MK=IGT-2
      DO 1460 M=1,KT,5
      READ(5,9100) UT
      IF(M.GT.KMAX) GO TO 1460
      IF(MK.GE.2) GO TO 1460
      DO 1450 I=1,5
      V(MK  )=V(MK  )-UT(I)*F3
      MK=MK+2
 1450 CONTINUE
 1460 CONTINUE
 1480 CONTINUE
      K=MAX0(K,KT)
      K=MIN0(K,KMAX)
      GO TO 2000
C
C     FOLDING FORM FACTOR
C
 1500 CONTINUE
      READ(5,9000) F1,QCODE,FMUV,OPT
      F3=OPT
      KT=F1
      DRX=DRF
      VOPT=OPT*F4PI
      IQODE=QCODE
      KM=400
      MINL=LAM+1
      CALL FMN(UB,KT,DRX)
      IF(IQODE.NE.6) GO TO 1501
      DO 1502 I=1,KT
      MK=I+I-1
      U(MK)=U(MK)+UB(I)*OPT
 1502 CONTINUE
      GO TO 1580
 1501 CONTINUE
      CALL SLATR(KT,DRX,VB,MINL,FMUV,IQODE,KM)
      DO 1570 I=1,KT
      VB(I+ 800)=VB(I    )
      VB(I+1200)=VB(I+400)
 1570 CONTINUE
      WRITE(6,9001) IQODE,FMUV,OPT
      CALL RADIN(KT,DRX,VB,UB,SL,SK,VOPT,U(1),IQODE,MINL,FMUV,KM)
 1580 CONTINUE
      K=MAX0(K,KT)
      K=MIN0(K,KMAX)
      GO TO 2000
C
C     WATSON L.S POTENTIAL
C
 1600 CONTINUE
      IF(AR.NE.0.0) VR=VR/AR
      DO 1660 M=1,K
      F1=F1*F2
      V(M)=V(M)-VR*F1/(RR*(1.0+F1)**2)
 1660 CONTINUE
 2000 CONTINUE
      IF(KFLAG.NE.0) GO TO 2009
      IF(VSOR.EQ.0.0) GO TO 2009
      NX=NX+3
      IF(NX.GT.5) GO TO 2009
      KFLAG=1
      VR=VR*VSOR/45.2
      GO TO 83
 2009 CONTINUE
      IF(FZ.GT.0.0) GO TO 70
      IF(ICODE.EQ.0) GO TO 3000
      IF(ICODE.EQ.3) GO TO 3000
      IF(ICODE.EQ.4) GO TO 3000
      IF(ICODE.EQ.7) GO TO 3000
      IF(ICODE.EQ.8) GO TO 3000
C
C     SINGL PARTICLE ORBITAL
C
C
C     READ IN QUANTUM NUMBERS FO SINGLE PARTICLE ORBITAL
C
      READ(5,9000)G,VTRIAL,FISW,DAMP
      ISW=FISW
      WRITE(6,9500)
      FJ=FJ2/2.0
      IF(VTRIAL.EQ.0.0) VTRIAL=ETA6
      WRITE(6,9508)G,FISW,VTRIAL
      IF(DAMP.NE.0.0) WRITE(6,9511) DAMP
      FSS=FSS/2.0
      FACT=(FJ**2+FJ-FL**2-FL-FSS**2-FSS)*0.5
      DO 2028 M=1,KMAX
      MK=M+M-1
      U(MK  )=U(MK  )+V(M)*FACT
 2028 CONTINUE
      CALL BIND(U,V,DR,RM,FN,FL,K,FK,ETA,VTRIAL,ECM,FK2,ISW,IERR)
      BIF=RM/DR
      DO 2045 M=28,32
      AKIN(M)=BKIN(M)
 2045 CONTINUE
      FACT=PNLOC*PNLOC/4.0
C
C     NON-LOCAL CORRECTION FOR SINGLE PARTICLE FUNCTION
C
      SUM=0.D0
      R=0.D0
      DO 2075 M=1,K
      MK=M+M-1
      R=R+DR
      U(MK+1)=VTRIAL*U(MK  )+U(MK+1)
      TEMP=FACT*(U(MK+1)-FK2)
      IF(PNLOC) 2072,2075,2070
 2070 CONTINUE
      V(M)=V(M)/SQRT(1.0+TEMP)
      GO TO 2074
 2072 CONTINUE
      V(M)=V(M)*EXP(-TEMP/2.0)
 2074 CONTINUE
      SUM=SUM+(V(M)*R)**2
 2075 CONTINUE
      IF(FACT.EQ.0.0) SUM=1.D0
      IF(FACT.EQ.0.0) GO TO 2076
      SUM=1.0/SQRT(SUM*DR)
 2076 CONTINUE
      IF(DAMP.EQ.0.0) GO TO 2090
C
C     APPLY DAMPING FACTOR, EXP(-DAMP*R*R) TO FORM FACTOR
C
      R=0.D0
      H=ABS(DAMP)
      DO 2085 M=1,K
      R=R+DR
      F2=H*R*R
      F2=-MIN(F2,30.D0)
      F1=EXP(F2)
      V(M)=V(M)*F1
 2085 CONTINUE
 2090 CONTINUE
      DO 2100 M=1,KMAX
      MK=M+M-1
      IF(M.GT.K) V(M)=0.D0
      U(MK  )=V(M)*SUM
      V(M)=U(MK+1)
      U(MK+1)=0.D0
 2100 CONTINUE
 3000 CONTINUE
      IF(ABS(RHO0R).LT.1.0E-7) RHO0R=1.D0
      IF(ABS(RHO0I).LT.1.0E-7) RHO0I=1.D0
      RETURN
 3010 WRITE(6,9501)
      STOP
 3020 WRITE(6,9502)
      STOP
 9000 FORMAT(10F8.4)
 9001 FORMAT(18H0PARAMETERS       ,9H   QCODE=,F9.4,9H   RANGE=,F9.4,7H
     1  V0 =,F11.4)
 9002 FORMAT(/21X,'BETA0R =',F7.4,'   BETA0I =',F7.4,/)
 9003 FORMAT(/21X,'BETA1R =',F7.4,'   BETA1I =',F7.4,/)
 9008 FORMAT(21H0POTENTIAL PARAMETERS)
 9010 FORMAT( 9H0PARTICLE,I2,120(1H*))
 9100 FORMAT(5E16.7)
 9500 FORMAT(1H ,3A6,5(3X,A6,F9.4))
 9501 FORMAT('0  XXX  INCORRECT GAMMA.OR.BETA BAND COUPLING POTENTIAL  X
     1XX')
 9502 FORMAT('0  XXX  INCORRECT OCTUPOLE BAND COUPLING POTENTIAL  XXX')
 9508 FORMAT(18X,9H   NODES=,F9.4,9H   L    =,F9.4,9H   2*J  =,F9.4,
     19H   2*S  =,F9.4,9H   FISW =,F9.4,9H   VTRL =,F9.4)
 9509 FORMAT(3A6,9H   V RL =,F9.4,9H   R0RL =,F9.4,9H   A RL =,F9.4,
     19H   R RL =,F9.4,9H   VSOR =,F9.4)
 9510 FORMAT(18X,9H   V IM =,F9.4,9H   R0IM =,F9.4,9H   A IM =,F9.4,
     19H   R IM =,F9.4,9H   VSOI =,F9.4,9H   POWR =,F9.4)
 9511 FORMAT(18X,9H   DAMP =,F9.4)
 9513 FORMAT(18X,9H   F1   =,F9.4,9H   F2   =,F9.4)
      END
      SUBROUTINE FNLOC(U,W,VB,LTR,BKIN,FNRNG,KT,IJ,AKIN,ICODE,KMAX)
      IMPLICIT REAL*8(A-H,O-Z)
C     SIN(XXX)=DSIN(XXX)
C     COS(XXX)=DCOS(XXX)
C     EXP(XXX)=DEXP(XXX)
C     ABS(XXX)=DABS(XXX)
      DIMENSION U(800,2),W(800),VB(400),BKIN(8,18),AKIN(18),IJ(2)
     1,RT(8,7),FM(3),FMA(3),PNLOC(3),DR(3),FMU(3),FK2(3)
      DIMENSION FACTNL(2)
      DATA  RT/  0.0   ,  4.4934,  7.7253, 10.9041, 14.0662, 17.2208,
     1 20.3713, 23.5195,  2.0816,  5.9404,  9.2058, 12.4044, 15.5792,
     2 18.7426, 21.8997, 25.0528,  3.3421,  7.2899, 10.6139, 13.8461,
     3 17.0429, 20.2219, 23.3905, 26.5526,  4.5141,  8.5838, 11.9727,
     4 15.2445, 18.4681, 21.6666, 24.8501, 28.0239,  5.6467,  9.8404,
     5 13.2956, 16.6093, 19.8624, 23.0828, 26.2833, 29.4706,  6.7565,
     6 11.0702, 14.5906, 17.9472, 21.2311, 24.4748, 27.6937, 30.8960,
     7  7.8511, 12.2793, 15.8632, 19.2627, 22.5781, 25.8461, 29.0843,
     8 32.3025/
C
C     FINITE RANGE CORRECTION
C
C
C     POSITIVE FR PARAMETER CALCULATES A HULTHEN TYPE FR CORRECTION
C     NEGATIVE FR PARAMETER CALCULATES A EXPONENTIAL TYPE FR CORRECTION
C
      KMAX2=KMAX+KMAX
      K=KT
      DO 20 I=1,2
      J=IJ(I)
      FM(I)   =BKIN(J,2)
      FMA(I)  =BKIN(J,4)
      PNLOC(I)=BKIN(J,17)
      DR(I)   =BKIN(J,15)
      FK2(I)  =BKIN(J,11)
      FMU(I)  =BKIN(J,9)
   20 CONTINUE
      FM(3)   =AKIN(2)
      FMA(3)  =AKIN(4)
      PNLOC(3)=AKIN(17)
      DR(3)   =AKIN(15)
      FK2(3)  =AKIN(11)
      FMU(3)  =AKIN(9)
C
C     CHANGE CHANNELS I,J INTO 1,2
C
      IF(IJ(1).GT.IJ(2)) GO TO 35
      IJ(1)=1
      IJ(2)=2
      GO TO 40
   35 CONTINUE
      IJ(1)=2
      IJ(2)=1
   40 CONTINUE
      IF(FNRNG.EQ.0.0) GO TO 348
      IF(FM(1)-FM(2))143,348,142
  142 I1=1
      I2=2
      J1=IJ(1)
      J2=IJ(2)
      GO TO 144
  143 I1=2
      I2=1
      J1=IJ(2)
      J2=IJ(1)
C
C     I1 IS FOR LARGER MASS , I2 IS FOR SMALLER MASS
C
  144 CONTINUE
      FM1=FMU(I1)
      FM2=FMU(I2)
      TEMP=FM(I2)*FNRNG**2/FM(I1)
      FACT=TEMP*FMA(I1)/FMA(I2)
      FMX=FM(I1)-FM(I2)
      TEMP=TEMP*FMX
      IF((FMX.LT.1.5).OR.(ICODE.NE.2)) GO TO 260
      FNRNG=-ABS(FNRNG)
C
C     FORM FACTOR PART BY ROST-KUNZ METHOD
C     USED FOR MULTI-NUCLEON TRANSFER REACTIONS
C
      DR2=DR(3)**2
      FLF=LTR*(LTR+1)
      R3=DR(3)*FLOAT(K+1)
      D3=0.D0
      A3=0.D0
      KM=K+K+1
      R2=R3-DR(3)
      D2=-FLF/R3
      A2=W (KM-2)*R2
      DO 220 M=1,K
      KM=KM-2
      R1=R2-DR(3)
      A1=W (KM-2)*R1
      D1=-FLF/(R2*R2)
      IF(A3.EQ.0.0) GO TO 215
      D1=D1+(A3-2.0*A2+A1)/(A2*DR2)
      W (KM+2)=EXP(D2*FACT)*W (KM+2)
      DX2=(D3*A3-2.0*D2*A2+D1*A1)/(R2*DR2)-A2*D2*D2/R2
      W (KM+2)=W (KM+2)+0.5*DX2*FACT*FACT
  215 CONTINUE
      IF(ABS(W (KM-2)).LT.ABS(W (KM  ))) GO TO 225
      R3=R2
      R2=R1
      D3=D2
      D2=D1
      A3=A2
      A2=A1
  220 CONTINUE
  225 CONTINUE
      KM=KM/2+1
      DO 227 M=1,KM
      MK=M+M-1
      VB(M)=W(MK)
      W(MK)=0.D0
  227 CONTINUE
      RKM=FLOAT(KM)*DR(3)
      LL=MIN0(LTR,6)
      FLF=LL*(LL+1)
      DR12=DR2/12.0
      DO 250 N=1,8
      FKX=(RT(N,LL+1)/RKM)**2
      A1=0.D0
      D1=0.D0
      RF=DR(3)
      A2=DR(3)
      D2=(1.0+DR12*(FKX-FLF/(RF*RF)))*A2
      FNORM=0.D0
      AN=0.D0
      DO 230 M=1,KM
      AN=AN+(VB(M)*A2*RF)
      FNORM=FNORM+A2*A2
      VB(M+KMAX2)=A2/RF
      RF=RF+DR(3)
      D3=1.D0+DR12*(FKX-FLF/(RF*RF))
      A3=(12.0*A2-10.0*D2-D1)/D3
      D1=D2
      D2=D3*A3
      A1=A2
      A2=A3
  230 CONTINUE
      AN=AN-0.5*VB(KM)*A1*(RF-DR(3))
      FNORM=FNORM-0.5*A1*A1
      FNORM=AN*EXP(-FACT*FKX)/FNORM
      DO 240 M=1,KM
      MK=M+M-1
      W (MK)=W (MK)+VB(M+KMAX2)*FNORM
  240 CONTINUE
  250 CONTINUE
      GO TO 300
  260 CONTINUE
      IF(FNRNG.GT.0.0) GO TO 300
C
C     SINGLE PARTICLE PART, GAUSSIAN FACTOR
C
      DO 270 M=1,K
      MK=M+M-1
      FACT=EXP(-TEMP*VB(M)/FMU(3))
      W(MK  )=W(MK  )*FACT
      W(MK+1)=W(MK+1)*FACT
  270 CONTINUE
  300 CONTINUE
C
C     DISTORTED WAVE PART
C
      DO 345 M=1,K
      MK=M+M-1
      CTEMP1=TEMP*(U(MK  ,J2)/FM2-U(MK  ,J1)/FM1)
      CTEMP2=TEMP*(U(MK+1,J2)/FM2-U(MK+1,J1)/FM1)
      IF(FNRNG.LT.0.0) GO TO 320
      UT1=CTEMP1+TEMP*VB(M)/FMU(3)+1.0
      UT2=CTEMP2
      DET=UT1*UT1+UT2*UT2
      UT1= UT1/DET
      UT2= UT2/DET
      GO TO 330
  320 CONTINUE
      FACT=EXP(-CTEMP1)
      UT1=FACT*COS(CTEMP2)
      UT2=FACT*SIN(CTEMP2)
  330 CONTINUE
      UF1   =UT1*W(MK  )+UT2*W(MK+1)
      UF2   =UT1*W(MK+1)-UT2*W(MK  )
      W(MK  )=UF1
      W(MK+1)=UF2
  345 CONTINUE
  348 CONTINUE
C
C     NON LOCALITY CORRECTION FACTOR FOR DISTORTED WAVES
C
      DO 350 I=1,2
      FACTNL(I)=PNLOC(I)**2/4.0
  350 CONTINUE
      IF(FACTNL(1)+FACTNL(2).EQ.0.0) GO TO 410
      DO 400 M=1,K
      MK=M+M-1
      DO 390 I=1,2
      L=IJ(I)
      IF(FACTNL(I).EQ.0.0) GO TO 390
      CTEMP1=-FACTNL(I)*(U(MK  ,L)-FK2(I))
      CTEMP2=-FACTNL(I)* U(MK+1,L)
      IF(PNLOC(I).LT.0.0) GO TO 370
      CTEMP1=1.0-CTEMP1
      THETA=ATAN(CTEMP2/CTEMP1)/2.0
      RX=SQRT(SQRT(CTEMP1*CTEMP1+CTEMP2*CTEMP2))
      UT1= COS(THETA)/RX
      UT2= SIN(THETA)/RX
      GO TO 380
  370 CONTINUE
      CTEMP1=CTEMP1/2.0
      FACT=EXP(CTEMP1)
      CTEMP2=CTEMP2/2.0
      UT1=FACT*COS(CTEMP2)
      UT2=FACT*SIN(CTEMP2)
  380 CONTINUE
      UF1   =UT1*W(MK  )-UT2*W(MK+1)
      UF2   =UT1*W(MK+1)+UT2*W(MK  )
      W(MK  )=UF1
      W(MK+1)=UF2
  390 CONTINUE
  400 CONTINUE
  410 CONTINUE
      RETURN
      END
      SUBROUTINE CATHEN(LOPT,IOPT,JOPT,K ,KMAX,UB,VB,SI,DRT,ICON,IERR)
      IMPLICIT REAL*8(A-H,O-Z)
C     SQRT(XXX)=DSQRT(XXX)
C     FLOAT(III)=DFLOAT(III)
C     ABS(XXX)=DABS(XXX)
C modified by (JE, ME)
C     USE THE NEXT 1 CARDS FOR 32-BIT MACHINES
      DOUBLE PRECISION VCC,RACAH,WINEJ
      DIMENSION UB(800,2),VB(1600),SI(800),C(10),QNUM(4,2),G(4),IQN(3)
     1,BKIN(32),JI(2),JJ(2),FJT(2),ICON(20)
      EQUIVALENCE (EN,BKIN(1)),(FM,BKIN(2)),(Z,BKIN(3)),(FMA,BKIN(4))
     1,(ZA,BKIN(5)),(RY,BKIN(6)),(FS,BKIN(7)),(ECM,BKIN(8))
     2,(FMU,BKIN(9)),(RC,BKIN(10)),(FK2,BKIN(11)),(FK,BKIN(12))
     3,(ETA,BKIN(13)),(AFACT,BKIN(14)),(DRF,BKIN(15)),(FN,BKIN(16))
     4,(PNLOC,BKIN(17)),(BFACT,BKIN(18)),(FACT,BKIN(19))
     5,(BIF,BKIN(28)),(G,BKIN(29))
     6,(C(1),CNTROL),(C(2),QCODE),(C(3),FMUV),(C(4),OPT)
      DATA SQR4PI,SQRTEN/3.54490780,3.162277660/
C modified by (JE,ME)
      SAVE
C
      ICON2=ICON(2)
      KMAX2=KMAX +KMAX
      KMAX3=KMAX2+KMAX
      IQFLG=0
      KMFLG=0
      IQN(1)=LOPT
      IQN(2)=IOPT
      IQN(3)=JOPT
      KT=KMAX
      TOTAL=0.D0
  100 CONTINUE
      READ(5,9001)C
      CNTRL=ABS(CNTROL)
      IF(CNTRL.EQ.0.0) GO TO 3010
      IF(QCODE)2020,3000,1100
 1100 CONTINUE
C
C     LOOP FOR TWO ORBITALS
C
      ML=1
      DO 2010 I=1,2
      FJT(1)=C(5)
      FJT(2)=C(I+5)
      IF(I.EQ.1) GO TO 2004
      IF(CNTRL.EQ.1.0) GO TO 2005
 2004 CONTINUE
      CALL KINEX(BKIN,UB(1,2),ECMT,DRT,0,KMAX,ICON)
      RAM=(DRF/DRT)**3
      DO 2003 M=1,KMAX
      MK=M+M-1
      VB(MK  )=0.D0
      VB(MK+1)=0.D0
 2003 CONTINUE
C
C
      CALL POTENT(BKIN,UB(1,2),VB,K,KMAX,2,0,0,0.D0,IERR,ICON,0)
      FJ2=G(3)
      IBF=BIF
      IF(KMFLG.EQ.0) KM=IBF
      KMFLG=1
      KT=MIN0(KT,K)
 2005 CONTINUE
C
C     PRINT OUT SINGLE PARTICLE INFORMATION
C
      IF(ICON2.GE.2) GO TO 2007
      IF((I.EQ.2).AND.(CNTRL.EQ.1.0)) GO TO 2007
      WRITE(6,9501) I,CNTRL
      R=DRF
      K2=K+K
      DO 2006 M=1,K2,20
      MK4=MIN0(M+19,K2)
      WRITE(6,9052)R,(UB(N,2),N=M,MK4,2)
      R=R+DRF*10.0
 2006 CONTINUE
 2007 CONTINUE
      DO 2008 M=1,KMAX
      MK=M+M-1
      UB(ML,1)=UB(MK,2)
      ML=ML+1
 2008 CONTINUE
      DO 2009 M=1,4
      QNUM(M,I)=G(M)
 2009 CONTINUE
      JI(I)=FJT(1)
      JJ(I)=FJT(2)
 2010 CONTINUE
      SLP=0.D0
      RMSP=0.D0
      R=0.D0
      DO 2015 M=1,KT
      R=R+DRF
      RSQ=R*R
      TEMP=UB(M     ,1)*UB(M+KMAX,1)
      SLP =SLP +TEMP*RSQ
      RMSP=RMSP+TEMP*RSQ*RSQ
 2015 CONTINUE
      IF(SLP.NE.0.0) RMSP=SQRT(RMSP/SLP)
      SLP=SLP*DRF
 2020 ICODE=ABS(QCODE)
      KT=MIN0(KT,K)
      LTR1=IQN(1)+1
      JLX=QNUM(3,1)
      JPX=QNUM(3,2)
      WRITE(6,9050) JLX,JI(1),JJ(1),JPX,JI(1),JJ(2)
      WRITE(6,9051) QCODE,FMUV,OPT,SLP,RMSP
C     ENTER TIME REVERSAL PHASE
      LVR=QNUM(2,1)+QNUM(2,2)
      OPT=OPT*PHASEF((IQN(1)-LVR)/2)
      IFLAG=1
      IF(ICODE.LE.10) GO TO 2025
      IFLAG=2
      ICODE=ICODE-10
 2025 CONTINUE
C
      GO TO (2100,2100,2300,2100,2500,2100),ICODE
C
C     ICODE=1  YUKAWA POTENTIAL
C     ICODE=2  COULOMB POTENTIAL
C     ICODE=3  OPEP TENSOR POTENTIAL
C     ICODE=4  GAUSSIAN POTENTIAL
C     ICODE=5  TWO PARTICLE TRANSFER
C     ICODE=6  ZERO RANGE KNOCK OUT
C     ICODE=11-16  GIVES IMAGINARY FORM FACTOR
C
 2100 LVR=0
      TOPT=1.D0
      GO TO 2350
 2300 ICODE=1
      LVR=2
      TOPT=-SQRTEN
 2350 MNNL=IABS(LTR1-LVR-1)+1
      MXXL=LTR1+LVR
      LTR2=LTR1+LTR1-2
      LVR2=LVR+LVR
      LLX=QNUM(2,1)*2.0
      LPX=QNUM(2,2)*2.0
      JLX=QNUM(3,1)
      JPX=QNUM(3,2)
      IS1=QNUM(4,1)*2.0
      IS2=QNUM(4,2)*2.0
      OPT=OPT*PHASEF(LLX/2)
      DRF=DRT
      DO 2390 LAM =MNNL,MXXL,2
      LAMA=LAM
      LAM2 =LAM +LAM -2
      VOPT=TOPT*OPT*SQR4PI*SQRT(DFLOAT(LAM2 +1)*DFLOAT(IQN(2)+1))
     1 *VCC(LAM2 ,LVR2,LTR2 ,0,0)
     2 *RACAH(IQN(2),IQN(2),LAM2 ,LTR2 ,LVR2,IQN(3))
      RME=0.D0
      IF(IQN(2).EQ.0) RME=1.D0
      IF(IQN(2).EQ.2) RME=SQRT(DFLOAT(IS1*(IS1+2)))
      RME=RME*SQRT(DFLOAT((IS1+1)*(IQN(2)+1)))
     1*SQRT(DFLOAT((LLX+1)*(LAM2+1)))*VCC(LLX,LAM2,LPX,0,0)
     2 *SQRT(DFLOAT(JLX+1)*DFLOAT(JPX+1)*DFLOAT(IQN(3)+1))
     3 *WINEJ(LPX,LLX,LAM2 ,IS2,IS1,IQN(2),JPX,JLX,IQN(3))
       IF(JI(1).NE.0) RME=RME*PHASEF((JI(1)+IQN(3)-JLX-JJ(2))/2)
     1 *RACAH(JPX,JJ(2),JLX,JJ(1),JI(1),IQN(3))
     2 *SQRT(DFLOAT(JJ(1)+1)*DFLOAT(JJ(2)+1))
      VOPT=VOPT*RME
      VOPT=VOPT*RAM
      TOTAL=TOTAL+ABS(VOPT)
      SL=0.D0
      RMS=0.D0
      IF(VOPT.EQ.0.0) GO TO 2385
      IF(ICODE.NE.6) GO TO 2365
      SCALE=VOPT/(SQR4PI*SQR4PI)
      R=0.D0
      MK=IFLAG
      DO 2360 M=1,KT
      R=R+DRF
      RSQ=R*R
      TEMP=UB(M    ,1)*UB(M+KMAX,1)*SCALE
      SI(MK  )=SI(MK  )+TEMP
      SL      =SL      +TEMP*RSQ
      RMS     =RMS     +TEMP*RSQ*RSQ
      MK=MK+2
 2360 CONTINUE
      IF(SL.NE.0.0) RMS=SQRT(RMS/SL)
      SL=SL*DRF
      GO TO 2385
C
 2365 CONTINUE
      CALL SLATR (KT,DRF,VB(  1),LTR1,FMUV,ICODE,KMAX)
      IF(LAM.NE.LTR1) GO TO 2375
      DO 2370 I=1,KT
      VB(I+KMAX2)=VB(I     )
      VB(I+KMAX3)=VB(I+KMAX)
 2370 CONTINUE
      GO TO 2380
 2375 CONTINUE
      CALL SLATR (KT,DRF,VB(KMAX2+1),LAMA,FMUV,ICODE,KMAX)
 2380 CONTINUE
      CALL RADIN(KT,DRF,VB,UB,SL,RMS,VOPT,SI(IFLAG),ICODE,LTR1,FMUV
     1  ,KMAX)
C
 2385 CONTINUE
      I=LAM -1
      WRITE(6,9102) IQN(1),I,RME,SL,RMS
 2390 CONTINUE
      GO TO 2990
C
C     HERE FOR TWO NUCLEON TRANSFER
C
 2500 CONTINUE
      M=0
      UB(M,1)=0.0
      IF(FMUV.EQ.0.0) FMUV=1.7
      CALL DSTRIP(IQN,DRF,KT,UB,SI(IFLAG),QNUM,OPT,FMUV,KM,SL)
      TOTAL=TOTAL+ABS(SL)
      WRITE(6,9002)KM,SL
      IQFLG=1
      GO TO 2990
 2990 CONTINUE
 3000 CONTINUE
      IF(CNTROL.GT.0.0) GO TO 100
      IF(IQFLG.EQ.1) KT=-KT
      K=KT
 3010 CONTINUE
      DRT=BKIN(15)
      IF(TOTAL.EQ.0.0) IERR=1
      RETURN
 9001 FORMAT(10F8.4)
 9002 FORMAT(15H FORM FACTOR,M=,I3,E18.6)
 9050 FORMAT(33H0ANGULAR MOMENTUM COUPLING  2*J1=,I3,3X,5H2*JC=,I3,3X,
     15H2*JI=,I3,5X,5H2*J2=,I3,3X,5H2*JC=,I3,3X,5H2*JF=,I3)
 9051 FORMAT(18H0PARAMETERS       ,9H   QCODE=,F9.4,9H   RANGE=,F9.4,
     17H   V0 =,F11.4,3X,21HSING. PART. OVERLAP =,F12.4,9H   RMS R=,
     2F9.4)
 9052 FORMAT(1H ,F6.2,10E12.4)
 9102 FORMAT(18X,9H   LTR  =,I4,5X,9H   LAM  =,I4,5X,9H   RME  =,F9.4,3X
     1,21HF.F. VOL. INTEGRAL  =,F12.4,9H   RMS R=,F9.4)
 9501 FORMAT(25H0FORM FACTOR DATA   PART.,I3,3H OF,F3.0)
 9998 FORMAT(1H1)
      END
      SUBROUTINE BCHK
      IMPLICIT REAL*8(A-H,O-Z)
C***********************************************************************
C
C     THIS ROUTINE MAY BE USED IN EITHER OF TWO MODES--
C       (1) A STANDARD MODE WITH FIXED DIMENSIONS AND FIXED CORE LOAD;
C       (2) A FLOATING MODE IN WHICH THE ROUTINE WILL ACQUIRE NEEDED
C           CORE DYNAMICALLY.  THE PARTICULAR CODE FOR THIS IS DESIGNED
C           FOR OPERATION AT THE UNIV. OF PITTSBURGH DEC-10 COMPUTER.
C
C     THE STANDARD-CODE AND FLOATING-CODE SECTIONS ARE MARKED AT
C     THEIR BEGINNINGS AND ENDS.
C
C     IN THE FLOATING-CODE FORM, THE ROUTINES THAT MUST BE REPLACED ON
C     OTHER SYSTEMS ARE--
C       CORSIZ(KUSE,KLIM) -- RETURNS CURRENT CORE USAGE AND UPPER LIMIT
C             IN UNITS OF PAGES (512 WORDS).
C       HEREIS(CORE) -- INITIALIZES DYNAMIC-ALLOCATION PACKAGE.
C       ALLOC (J,LEN,KRET) -- ACQUIRES CORE OF LENGTH LEN WORDS.
C             J IS THE LOCATION IN THE DUMMY ARRAY CORE AND KRET IS
C             USED FOR ERROR RETURNS (ERROR CODE IN J).
C       FREE  (CORE(J)) -- RELEASES CORE AT LOCATION J.
C
C***********************************************************************
C
C     FOR SINGLE PRECISION VERSIONS, CHANGE THE DEFINITION OF IDBL,
C     WHICH OCCURS AT THE BEGINNING OF THE ROUTINE, TO READ
C       IDBL=1
C
C***********************************************************************
C     DOUBLE PRECISION BETA
      DIMENSION LIM(4),NEED(6)
      COMMON THETAN,THETA1,DTHETA,DRT,RMAX,ALPHA(15),IDAT(6)
     1,ICON(20),LMAX,KT,KMAX,LLCO,JOUT,NLTR,IBUFF,IWORD
     2,KLAM( 8),LTRT( 8),JTRT( 8),NADD( 8),LAM(16),ISP(16),JSP(16)
     3,ILK(16),JPRT( 8)
      COMMON EN( 8),FM( 8),Z( 8),FMA( 8),ZA( 8),RY( 8),FS( 8),ECM( 8)
     1,FMU( 8),RC( 8),FK2( 8),FK( 8),ETA( 8),AFACT( 8),DRF( 8),FN( 8)
     2,PNLOC( 8),DUM( 8),SIG( 8)
     3,IS( 8),NS( 8),NLI( 8),LKTAB(32),ICUP(32),JCUP(32)
     4,IN( 8),INN( 8, 8),INDTAB(10)
C***********************************************************************
C        STANDARD CODE
C        ======== ====
C     DOUBLE PRECISION ZI,CZ,AMAT,CMAT
      DIMENSION W(800,8),V(400,8),ZI(80,2),CZ(80,5)
     1         ,AMAT(80,40),CMAT(80,40),PLM(6400),SR(2048),SI(2048)
      COMMON/STORAG/ CORE(12800)
      COMMON/POT/ X(800,16)
      EQUIVALENCE (W(1,1),CORE(1)), (V(1,1),CORE(6401))
     1           ,(ZI(1,1),CORE(9601)), (CZ(1,1),CORE(10401))
     2           ,(AMAT(1,1),CORE(1)),  (CMAT(1,1),CORE(6401))
     3           ,(PLM(1),CORE(1)),(SR(1),CORE(6401)),(SI(1),CORE(8451))
      DATA NCHAN/   40/
      DATA MAXD /12800/
      DATA MAXT / 2048/
      DATA MAXLM/ 6400/
C        END STANDARD CODE
C***********************************************************************
C        FLOATING CODE
C        ======== ====
C     LOGICAL FIRST
C     DIMENSION CORE(1)
C     DATA FIRST/.TRUE./
C     DATA NCHAN/  100/
C        END FLOATING CODE
C***********************************************************************
C
      CALL CUDATE(IDAT)
      WRITE(6,9006) (IDAT(KJ),KJ=4,6)
      KMAX2=KMAX+KMAX
      NPAR=NLI(1)
      IDBL=2
C
C     CHECK STORAGE SIZE FOR D AMPLITUDE SPACE
C
      LK=0
      NLL=0
      DO 40 I=1,NLTR
      M=(JTRT(I)+1)*NS(I)
      LK=LK+M
      NLL=MAX0(NLL,M)
   40 CONTINUE
      M=(JTRT(1)+1)*NS(1)
      LK=(LK+LK)*M*LMAX
      NLL=(NLL+NLL)*M
      LIM(2)=LK
      LIM(3)=NLL
C
C     COUNT MAXIMUM NUMBER OF SUBCHANNELS, YLM TERMS
C
      MAXM=0
      NLL=0
      DO 60 I=1,NLTR
      NLL=NLL+((JTRT(I)+1)*NS(I)+1)/2
      MAXM=MAX0(MAXM,(JTRT(1)+JTRT(I)+IS(1)+IS(I))/2+1)
   60 CONTINUE
      LIM(1)=NLL
      LIM(4)=MAXM*LMAX
      NLL2=NLL+NLL
C
C***********************************************************************
C        STANDARD CODE
C        ======== ====
C
C     READ IN DIAGONAL AND COUPLING POTENTIALS
C
      DO 120 I=1,NLTR
      READ(9) (W(J,I),J=1,KMAX2),(V(J,I),J=1,KMAX)
  120 CONTINUE
      DO 130 I=1,NPAR
      READ(8) (X(J,I),J=1,KMAX2)
  130 CONTINUE
C
      WRITE(6,9100) LIM,NCHAN,MAXD,MAXT,MAXLM
      IF(LIM(1).GT.NCHAN) GO TO 1200
      IF(LIM(2).GT.MAXD ) GO TO 1200
      IF(LIM(3).GT.MAXT ) GO TO 1200
      IF(LIM(4).GT.MAXLM) GO TO 1200
C
      CALL CUDATE(IDAT)
      WRITE(6,9007) (IDAT(KJ),KJ=4,6)
C
      CALL INTEG(ZI,CZ,W,V,X,NLL2)
C
      CALL CUDATE(IDAT)
      WRITE(6,9008) (IDAT(KJ),KJ=4,6)
C
      CALL SOLVE(AMAT,CMAT,X,NLL2)
C
      CALL CUDATE(IDAT)
      WRITE(6,9009) (IDAT(KJ),KJ=4,6)
      WRITE(6,9019)ALPHA,IDAT
C
      CALL XSECT(X,PLM,SR,SI)
C        END STANDARD CODE
C***********************************************************************
C        FLOATING CODE
C        ======== ====
C     WRITE(6,9100) LIM,NCHAN
C     IF(LIM(1).GT.NCHAN) GO TO 1200
C     IF(FIRST) CALL CORSIZ(KORUSE,KORLIM)
C     FIRST=.FALSE.
C     CALL HEREIS(CORE)
C     NEED(1)=KMAX2*NLTR
C     NEED(2)=KMAX *NLTR
C     NEED(3)=KMAX2*NPAR
C     ISUM=NEED(1)+NEED(2)+NEED(3)
C     NEED(4)=7*IDBL*NLL2
C     NEED(5)=2*IDBL*NLL2*NLL+LIM(2)
C     NEED(6)=LIM(4)+2*LIM(3)
C     ISUM=MAX0(NEED(4)+ISUM,NEED(5),NEED(6)+LIM(2))
C     NPG=(ISUM+511)/512
C     KORNED=KORUSE+NPG+4
C     KORSAF=KORNED+1
C     WRITE(6,9112) KORSAF,KORLIM
C     IF(KORSAF.GT.KORLIM) GO TO 1000
C     CALL ALLOC(LS,2048)
C     CALL ALLOC(KOR1,ISUM)
C     CALL FREE(CORE(LS))
C     LW=KOR1
C     LV=LW+NEED(1)
C     LX=LV+NEED(2)
C     LZ=LX+NEED(3)
C     LC=LZ+ 2*IDBL*NLL2
C
C     READ IN DIAGONAL AND COUPLING POTENTIALS
C
C     KW1=LW
C     KV1=LV
C     DO 120 I=1,NLTR
C     KW2=KW1+799
C     KV2=KV1+399
C     READ(9) (CORE(J),J=KW1,KW2),(CORE(J),J=KV1,KV2)
C     KW1=KW1+800
C     KV1=KV1+400
C 120 CONTINUE
C     KX1=LX
C     DO 130 I=1,NPAR
C     KX2=KX1+799
C     READ(8) (CORE(J),J=KX1,KX2)
C     KX1=KX1+800
C 130 CONTINUE
C
C     CALL CUDATE(IDAT)
C     WRITE(6,9007) (IDAT(KJ),KJ=4,6)
C
C     CALL INTEG(CORE(LZ),CORE(LC),CORE(LW),CORE(LV),CORE(LX),NLL2)
C     LD=KOR1
C     LA=LD+LIM(2)
C     LC=LA+IDBL*NLL2*NLL
C
C     CALL CUDATE(IDAT)
C     WRITE(6,9008) (IDAT(KJ),KJ=4,6)
C
C     CALL SOLVE(CORE(LA),CORE(LC),CORE(LD),NLL2)
C     LW=LA+LIM(4)
C     LV=LW+LIM(3)
C
C     CALL (IDAT)
C     WRITE(6,9009) (IDAT(KJ),KJ=4,6)
C     WRITE(6,9019)ALPHA,IDAT
C
C     CALL XSECT(CORE(LD),CORE(LA),CORE(LW),CORE(LV))
C     CALL FREE(CORE(KOR1))
C        END FLOATING CODE
C***********************************************************************
C
 1000 CONTINUE
      RETURN
 1200 CONTINUE
      WRITE(6,9110)
      GO TO 1000
 9006 FORMAT(24H0SUBROUTINE BCHK ENTERED,10X,I4,2(1H.,I2))
 9007 FORMAT(24H0SUBROUTINE INTEG CALLED,10X,I4,2(1H.,I2))
 9008 FORMAT(24H0SUBROUTINE SOLVE CALLED,10X,I4,2(1H.,I2))
 9009 FORMAT(24H0SUBROUTINE XSECT CALLED,10X,I4,2(1H.,I2))
 9019 FORMAT(1H1,17X,15A4,4X,I2,2(1H/,I2),I4,2(1H.,I2))
 9100 FORMAT(22H0ARRAY NEEDS -- NCHAN=,I4,3X,7HNDAMPL=,I6,3X,5HNTR1=,I5,
     13X,5HNYLM=,I5,3X,12HWITH LIMITS ,I4,1H,,I6,1H,,I5,1H,,I5)
 9110 FORMAT(16H0LIMITS EXCEEDED)
 9112 FORMAT(15H0PROGRAM NEEDS ,I3,28H CORE PAGES.  YOUR LIMIT IS ,I3)
      END
      SUBROUTINE INTEG(ZI,CZ,W,V,X,NLL2)
      IMPLICIT REAL*8(A-H,O-Z)
C     SQRT(XXX)=DSQRT(XXX)
C     AMAX1(XXX,YYY)=DMAX1(XXX,YYY)
C     AMIN1(XXX,YYY)=DMIN1(XXX,YYY)
C     FLOAT(III)=DFLOAT(III)
C     DOUBLE PRECISION BETA,CZ,ZI
C modified by (JE,ME)
C     USE THE NEXT 2 CARDS FOR 32-BIT MACHINES
      DOUBLE PRECISION VCC,RACAH,WINEJ
      DOUBLE PRECISION CZ,ZI
      DIMENSION ZI(NLL2,2),CZ(NLL2,5),W(1),V(1),X(1)
      COMMON THETAN,THETA1,DTHETA,DRT,RMAX,ALPHA(15),IDAT(6)
     1,ICON(20),LMAX,KT,KMAX,LLCO,JOUT,NLTR,IBUFF,IWORD
     2,KLAM( 8),LTRT( 8),JTRT( 8),NADD( 8),LAM(16),ISP(16),JSP(16)
     3,ILK(16),JPRT( 8)
      COMMON EN( 8),FM( 8),Z( 8),FMA( 8),ZA( 8),RY( 8),FS( 8),ECM( 8)
     1,FMU( 8),RC( 8),FK2( 8),FK( 8),ETA( 8),AFACT( 8),DRF( 8),FN( 8)
     2,PNLOC( 8),DUM( 8),SIG( 8)
     3,IS( 8),NS( 8),NLI( 8),LKTAB(32),ICUP(32),JCUP(32)
     4,IN( 8),INN( 8, 8),INDTAB(10)
      COMMON/LOCAL/ FTAB(100),VTAB(100),NTAB(100),LTAB(100),JTAB(100)
     1      ,MTAB(100),NTBL(100),MI(100),IFAKE1(600),CTAB(510)
     2      ,IKTAB(510),JKTAB(510),LKTLK(510),IKTBL(510),MZTBL(512)
     3      ,ITEMP(8,8),IFAKE2(2616),DR2(8),KTT,MZ,NMM,IK,BUFC(464)
      COMMON/BUFSPC/ BUFFR(800)
      DATA MAXIJ/510/
      DATA ETA1/1.0D-08/
      DATA SQRFPI/3.5449077/
      SAVE
C
      IPWR=2*ICON(20)
      IF(IPWR.EQ.0) IPWR=8
      ETA1=10.0**(-IPWR)
      REWIND 8
      KTT=KT
      NCUP=NLI(2)
      IWORD=0
      NPAR=2
      LDEL=1
      IF(LTRT(1).NE.0) GO TO 21
      IF(  IS(1).NE.0) GO TO 21
      NPAR=1
      LDEL=2
   21 CONTINUE
      DO 40 I=1,NLTR
      DR2(I)=DRF(I)**2
   40 CONTINUE
C
C     CONSTRUCT EFFECTIVE COUPLING MATRIX
C
      DO 52 I=1,NLTR
      INN(I,I)=INN(I,I)+1
   52 CONTINUE
      DO 56 I=1,NLTR
      DO 54 J=1,NLTR
      DO 54 K=1,NLTR
      MK=0
      DO 53 M=1,NLTR
      MK=MK+INN(J,M)*INN(M,K)
   53 CONTINUE
      IF(MK.GT.1) MK=2
      ITEMP(J,K)=MK
   54 CONTINUE
      DO 55 J=1,NLTR
      DO 55 K=1,NLTR
      INN(J,K)=ITEMP(J,K)
   55 CONTINUE
   56 CONTINUE
      DO 57 I=1,NLTR
      INN(I,I)=INN(I,I)-1
   57 CONTINUE
C
C
      JX1=(1.0-PHASEF(JTRT(1)+IS(1)))/2.0
      JMAX=LMAX
      LMAX22=LMAX+LMAX-2
C
C      J LOOP
C
      DO 1000 JA=1,JMAX
      JT=JA+JA-2+JX1
      LMIN=IABS(IABS(JT-JTRT(1))-IS(1))/2
      DO 1000 JPAR=1,NPAR
C
C     SELECT SUBCHANNELS
C
      NLL=0
      MAXL=0
      DO 80 I=1,NLTR
      NLI(I)=0
      JMXX=     JT+JTRT(I)
      JMNN=IABS(JT-JTRT(I))
      IF(JMXX.LT.JMNN) GO TO 80
      XPHAS=PHASEF(JPRT(1))*PHASEF(JPRT(I))
     1*DFLOAT(ISIGN(1,LTRT(1))*ISIGN(1,LTRT(I)))
      IN(I)=SIGN(1.1D0,XPHAS)
      DO 70 J=JMNN,JMXX,2
      LMXX=MIN0(J+IS(I),LMAX22)/2
      LMNN=IABS(J-IS(I))/2
      IF(LMXX.LT.LMNN) GO TO 70
      DO 60 L=LMNN,LMXX
      PHAS=PHASEF(LMIN+JPAR-1-L)*XPHAS
      IF(PHAS.LT.0.0) GO TO 60
      NLL   =NLL   +1
      NLI(I)=NLI(I)+1
      LTAB(NLL)=L
      JTAB(NLL)=J
      NTAB(NLL)=I
      FTAB(NLL)=L*(L+1)
      VTAB(NLL)=FLOAT(J*(J+2)-IS(I)*(IS(I)+2))/4.0-FTAB(NLL)
      VTAB(NLL)=VTAB(NLL)*0.5
      MTAB(NLL)=(I-1)*KMAX
   60 CONTINUE
   70 CONTINUE
   80 CONTINUE
C modifiedy by JE,ME
      WRITE(8) NLL,NLI
     1        ,(NTAB(L),L=1,NLL),(LTAB(L),L=1,NLL),(JTAB(L),L=1,NLL)
      IF(NLI(1).EQ.0) GO TO 980
      MAXA=NLL+NLL
C
C      COEFFICENT TABLE
C
      IJ=0
      IF(NCUP.EQ.0) GO TO 115
C     I IS INITIAL CHANNEL
      DO 110 I=1,NLL
      LX=LTAB(I)*2
      JX=JTAB(I)
      II=NTAB(I)
      IF((II.NE.1).AND.(LTAB(I).LT.LLCO)) GO TO 110
      IX=JTRT(II)
      ISX=IS(II)
C     J IS FINAL CHANNEL
      DO 105 J=1,NLL
      LY=LTAB(J)*2
      JY=JTAB(J)
      JJ=NTAB(J)
      IF((JJ.NE.1).AND.(LTAB(J).LT.LLCO)) GO TO 105
      IY=JTRT(JJ)
      ISY=IS(JJ)
      DO 100 K=1,NCUP
      IF((ICUP(K).NE.II).OR.(JCUP(K).NE.JJ)) GO TO 100
      LK=LKTAB(K)
      LL2=LAM(LK)*2
      JJ2=JSP(LK)
      IS2=ISP(LK)
      TEMP=RACAH(JX,IX,JY,IY,JT,JJ2)
     1*SQRT(DFLOAT(JX+1)*DFLOAT(JY+1)*DFLOAT(JJ2+1))
     2*WINEJ(LX,ISX,JX,LL2,IS2,JJ2,LY,ISY,JY)
     3*VCC(LX,LL2,LY,0,0)*SQRT(DFLOAT(LX+1)*DFLOAT(LL2+1))
     4*PHASEF((JT-IX-JY-JJ2)/2)/SQRFPI
     5*PHASEF((LX-LL2-LY)/4)
      IF(ILK(LK).EQ.0) GO TO 82
      IF(ILK(LK).EQ.1) GO TO 84
      IF(ILK(LK).EQ.2) GO TO 86
      IF(ILK(LK).EQ.3) GO TO 88
      IF(ILK(LK).EQ.4) GO TO 84
      IF(ILK(LK).EQ.7) GO TO 90
      IF(ILK(LK).EQ.8) GO TO 90
      GO TO 92
C
C     COLLECTIVE
C
   82 CONTINUE
      KLMM=KLAM(II)
      TEMP=TEMP*SQRT(DFLOAT(IX+1)*DFLOAT(ISY+1))*VCC(IX,LL2,IY,KLMM,0)
      IPHAS=-LL2
      IF((DFLOAT(ISIGN(1,LTRT(II)))*PHASEF(JPRT(II))).LT.0.0)
     1  IPHAS=IPHAS+2
      IF((DFLOAT(ISIGN(1,LTRT(JJ)))*PHASEF(JPRT(JJ))).LT.0.0)
     1  IPHAS=IPHAS-2
      TEMP=TEMP*PHASEF(IPHAS/4)
      GO TO 92
   84 CONTINUE
C
C     PARTICLE TRANSFER
C
C     PICKUP
      IF(FMA(II).GT.FMA(JJ)+0.2) TEMP=TEMP
     1*SQRT(DFLOAT(IX+1)*DFLOAT(ISY+1))
     2*PHASEF((IX+JJ2-IY)/2)
C     STRIPPING
      IF(FMA(JJ).GT.FMA(II)+0.2) TEMP=TEMP
     1*SQRT(DFLOAT(IY+1)*DFLOAT(ISX+1))
     2*PHASEF((ISY+IS2-ISX)/2)
      GO TO 92
   86 CONTINUE
C
C     MICROSCOPIC
C
      TEMP=TEMP*PHASEF(JJ2/2)
      IF(IS2.EQ.0) TEMP=TEMP*SQRT(DFLOAT(ISY+1))
      IF(IS2.EQ.2)TEMP=TEMP*(SQRT(DFLOAT(ISX)*DFLOAT(ISY)*2.)
     1 -DFLOAT(IABS(ISX-ISY))*SQRT(3.D0))
      IF(II.LE.JJ) GO TO 92
      IPHAS=IY+JJ2-IX+ISY+IS2-ISX
      TEMP=TEMP*PHASEF(IPHAS/2)
      GO TO 92
C
C     COLLECTIVE-NON STRONG COUPLING MODEL *** K IS NOT A GOOD QUANT. NO
C
   88 CONTINUE
      TEMP=TEMP*SQRT(DFLOAT((IY+1)*(ISY+1))/DFLOAT(LL2+1))
      IPHAS=-LL2
      IF((DFLOAT(ISIGN(1,LTRT(II)))*PHASEF(JPRT(II))).LT.0.0)
     1  IPHAS=IPHAS+2
      IF((DFLOAT(ISIGN(1,LTRT(JJ)))*PHASEF(JPRT(JJ))).LT.0.0)
     1  IPHAS=IPHAS-2
      TEMP=TEMP*PHASEF(IPHAS/4)
      IF(II.LT.JJ) GO TO 92
      TEMP=TEMP*SQRT(DFLOAT(IX+1)/DFLOAT(IY+1))*PHASEF((IX-IY)/2)
   90 CONTINUE
C
C    GAMMA BAND COUPLING.OR.BETA BAND COUPLING
C    OCTUPOLE BAND COUPLING AS WELL
C
      KLMM=KLAM(II)
      MU=IABS(KLAM(II)-KLAM(JJ))
      TEMP=TEMP*SQRT(DFLOAT((IX+1)*(ISY+1)))*VCC(IX,LL2,IY,-KLMM,MU)
      IPHAS=-LL2
      IF((DFLOAT(ISIGN(1,LTRT(II)))*PHASEF(JPRT(II))).LT.0.0)
     1  IPHAS=IPHAS+2
      IF((DFLOAT(ISIGN(1,LTRT(JJ)))*PHASEF(JPRT(JJ))).LT.0.0)
     1  IPHAS=IPHAS-2
      TEMP=TEMP*PHASEF(IPHAS/4)
C   THIS PHASE IS TO TAKE CARE OF THE DEEXCITATION OF THE EXCITED BAND
C   TO THE GS BAND. IF THE EXCITED BAND HAS K=0 THIS PHASE IS ALWAYS
C   POSITIVE
      IF(KLAM(II).EQ.0) TEMP=TEMP*PHASEF((IX+LL2-IY)/2)
   92 CONTINUE
      T1=MAX(DRF(II),DRF(JJ))
      T2=MIN(DRF(II),DRF(JJ))
      TEMP=TEMP*SQRT(T1/T2)**3
      IF(TEMP.EQ.0.0) GO TO 100
      IJ=IJ+1
      JKTAB(IJ)=I
      IKTAB(IJ)=J
      LKTLK(IJ)=(LK-1)*KMAX*2
      CTAB(IJ) = -TEMP*FMU(JJ)*DRF(JJ)**3/DRF(II)
  100 CONTINUE
  105 CONTINUE
  110 CONTINUE
  115 CONTINUE
      IF(IJ.LE.MAXIJ) GO TO 120
      WRITE(6,9101) IJ,MAXIJ
      STOP 111
  120 CONTINUE
C
C     ITERATION LOOP
C
      DO 800 N1=1,NLL
      NJ=N1+N1-1
      II=NTAB(N1)
C
C      SET UP INITIAL Z  VALUES
C
      NMM=0
      DO 180 N2 = 1,NLL
      NK=N2+N2-1
      JJ=NTAB(N2)
      DO 165 M=1,5
      CZ(NK  ,M)=0.D0
      CZ(NK+1,M)=0.D0
      IF(M.GT.2) GO TO 165
      ZI(NK  ,M)=0.D0
      ZI(NK+1,M)=0.D0
  165 CONTINUE
      IF(N1.EQ.N2) GO TO 170
      IF(INN(JJ,II).EQ.0) GO TO 180
  170 CONTINUE
      NMM=NMM+1
      NTBL(NMM)=N2
      FL=LTAB(N2)-ICON(19)
      FL=MAX(FL,0.0D0)
      M1=SQRT((FL*FL+FL)/12.0)
      EXPO=1.0/(2.0*FL+1.0)
      M2=((1.0D-16)**EXPO)*(2.0*FL/(2.718*FK(JJ)*DRF(JJ)))
      M1=MAX0(M1,M2)+1
      MI(NMM)=MIN0(M1,KMAX)
      IF(N1.NE.N2) GO TO 180
      MZ=MI(NMM)
      ZI(NK  ,2)=ETA1
      CZ(NK  ,5)=ETA1
  180 CONTINUE
C
C     CONSTRUCT SECONDARY TABLES
C
      IK=0
      IF(IJ.EQ.0) GO TO 196
      DO 195 I=1,NMM
      DO 190 J=1,NMM
      DO 185 K=1,IJ
      IF(IKTAB(K).NE.NTBL(I)) GO TO 185
      IF(JKTAB(K).NE.NTBL(J)) GO TO 185
      IK=IK+1
      IKTBL(IK)=K
      MZTBL(IK)=0
      IF(MI(I).LE.MI(J)) GO TO 185
      MZTBL(IK)=MI(I)*262144+K*512+IK
      IKTBL(IK)=0
  185 CONTINUE
  190 CONTINUE
  195 CONTINUE
  196 CONTINUE
      MZTBL(IK+1)=(KMAX+1)*262144
C
C     SORT STARTING POINTS
C
      IF(IK.EQ.0) GO TO 221
      DO 220 J=1,IK
      M1=KMAX
      DO 210 K=J,IK
      I=MZTBL(K)/262144
      IF(I.GT.M1) GO TO 210
      M1=I
      K1=K
  210 CONTINUE
      N2=MZTBL(K1)
      IF(K1.EQ.J) GO TO 206
      K1=K1-1
      DO 205 K=J,K1
      M2=K1-K+J
      MZTBL(M2+1)=MZTBL(M2)
  205 CONTINUE
  206 CONTINUE
      MZTBL(J)=N2
  220 CONTINUE
  221 CONTINUE
C
C      INTEGRATION SECTION
C
      IF(ICON(18).EQ.0) GO TO 240
C
      CALL NUMERV(ZI,CZ,W,V,X,NLL2)
      GO TO 250
C
  240 CONTINUE
      CALL STORMR(ZI,CZ,W,V,X,NLL2)
C
  250 CONTINUE
C
C     WRITE LAST TWO POINTS ON TAPE
C

C modified by JE,ME
      WRITE(8) (ZI(I,1),I=1,MAXA)
      WRITE(8) (ZI(I,2),I=1,MAXA)
  800 CONTINUE
C
C     END OF ITERATION LOOP
C
  980 CONTINUE
 1000 CONTINUE
C
C     FLUSH BUFFR
C
C modified by JE,ME
      WRITE(8) NLL
      IF(IWORD.EQ.IBUFF) GO TO 1001
      IWORD=IBUFF-1

 1001 CONTINUE
      REWIND 8
      RETURN
 9101 FORMAT(28H0TOO MANY COUPLING TERMS -- ,I4,13H  WITH LIMIT ,I4)
      END
      SUBROUTINE STORMR(ZI,CZ,W,V,X,NLL2)
      IMPLICIT REAL*8(A-H,O-Z)
C     FLOAT(III)=DFLOAT(III)
      LOGICAL COFSET
C     DOUBLE PRECISION CZ,ZI
C     DOUBLE PRECISION CII1,CII2,CF1,CF2,CF3,CF4,CF5
      DIMENSION ZI(NLL2,2),CZ(NLL2,5),W(1),V(1),X(1)
      COMMON/LOCAL/ FTAB(100),VTAB(100),NTAB(100),LTAB(100),JTAB(100)
     1      ,MTAB(100),NTBL(100),MI(100),IFAKE1(600),CTAB(510)
     2      ,IKTAB(510),JKTAB(510),LKTLK(510),IKTBL(510),MZTBL(512)
     3      ,ITEMP(8,8),IFAKE2(2616),DR2(8),KT,MZ,NMM,IK,BUFC(464)
      DATA MSW,COFSET/6,.FALSE./
C
      IF(COFSET) GO TO 10
      CF1=  19.D0/240.D0
      CF2=- 96.D0/240.D0
      CF3= 194.D0/240.D0
      CF4=-176.D0/240.D0
      CF5= 299.D0/240.D0
      COFSET=.TRUE.
   10 CONTINUE
      M1=1
      MX=1
      DO 600 M=1,KT
      MK=M+M-1
  320 CONTINUE
      IF(M.LT.MZTBL(M1)/262144) GO TO 321
      N2=MZTBL(M1)-262144*(MZTBL(M1)/262144)
      K1=N2-512*(N2/512)
      IF(K1.NE.0) IKTBL(K1)=N2/512
      M1=M1+1
      GO TO 320
  321 CONTINUE
      IF(M.EQ.MZ) GO TO 530
      IF(M.LT.MZ) GO TO 600
      IF(MX.GE.MSW) GO TO 500
      MX=MX+1
C
C      INTEGRATE U(R) BY N=2 STORMER EQUATION
C
      DO 410 NY=1,NMM
      N2=NTBL(NY)
      NK=N2+N2-1
C
      CII1  =2.0*ZI(NK  ,2)-ZI(NK  ,1)+CZ(NK  ,5)
      CII2  =2.0*ZI(NK+1,2)-ZI(NK+1,1)+CZ(NK+1,5)
C
C     STEP INTEGRATION TABLES BACK ONE
C
      DO 408 K=1,4
      CZ(NK  ,K)=CZ(NK  ,K+1)
      CZ(NK+1,K)=CZ(NK+1,K+1)
  408 CONTINUE
      ZI(NK  ,1)=ZI(NK  ,2)
      ZI(NK+1,1)=ZI(NK+1,2)
      ZI(NK  ,2)=CII1
      ZI(NK+1,2)=CII2
  410 CONTINUE
      GO TO 530
C
  500 CONTINUE
C
C     INTEGRATE U(R) BY N=5 STORMER EQUATION
C
      DO 510 NY=1,NMM
      N2=NTBL(NY)
      NK=N2+N2-1
      CII1  =2.0*ZI(NK  ,2)-ZI(NK  ,1)+CF1  *CZ(NK  ,1)+CF2  *CZ(NK  ,2)
     1+CF3  *CZ(NK  ,3)+CF4  *CZ(NK  ,4)+CF5  *CZ(NK  ,5)
      CII2  =2.0*ZI(NK+1,2)-ZI(NK+1,1)+CF1  *CZ(NK+1,1)+CF2  *CZ(NK+1,2)
     1+CF3  *CZ(NK+1,3)+CF4  *CZ(NK+1,4)+CF5  *CZ(NK+1,5)
C
C     STEP INTEGRATION TABLES BACK ONE
C
      DO 508 K=1,4
      CZ(NK  ,K)=CZ(NK  ,K+1)
      CZ(NK+1,K)=CZ(NK+1,K+1)
  508 CONTINUE
      ZI(NK  ,1)=ZI(NK  ,2)
      ZI(NK+1,1)=ZI(NK+1,2)
      ZI(NK  ,2)=CII1
      ZI(NK+1,2)=CII2
  510 CONTINUE
  530 CONTINUE
C
C      COMPUTE NEW CZ VALUE
C
C
C     COMPUTE DIAGONAL PART OF CZ
C
      DO 540 NY=1,NMM
      N2=NTBL(NY)
      NK=N2+N2-1
      JJ=NTAB(N2)
      NL=MTAB(N2)+M
      NM=NL+NL-1
      CII1  =FTAB(N2)/FLOAT(M*M)-DR2(JJ)*(W(NM  )+V(NL)*VTAB(N2))
      CII2  =                   -DR2(JJ)* W(NM+1)
      CZ(NK  ,5)=CII1  *ZI(NK  ,2)-CII2  *ZI(NK+1,2)
      CZ(NK+1,5)=CII1  *ZI(NK+1,2)+CII2  *ZI(NK  ,2)
  540 CONTINUE
C
C     COMPUTE NON-DIAGONAL PART OF CZ
C
      IF(IK.EQ.0) GO TO 591
      DO 590 IM=1,IK
      I=IKTBL(IM)
      IF(I.EQ.0) GO TO 590
      NK=IKTAB(I)+IKTAB(I)-1
      NL=JKTAB(I)+JKTAB(I)-1
      LK=LKTLK(I)+MK
      CII1  = X(LK  )*CTAB(I)
      CII2  = X(LK+1)*CTAB(I)
      CZ(NK  ,5)=CZ(NK  ,5)+ CII1  *ZI(NL  ,2)-CII2  *ZI(NL+1,2)
      CZ(NK+1,5)=CZ(NK+1,5)+ CII1  *ZI(NL+1,2)+CII2  *ZI(NL  ,2)
  590 CONTINUE
  591 CONTINUE
  600 CONTINUE
      RETURN
      END
      SUBROUTINE NUMERV(ZI,CZ,W,V,X,NLL2)
      IMPLICIT REAL*8(A-H,O-Z)
C     INTEGRATION BY THE NUMEROV ALGORITHM
C     CF. A.C.ALLISON, J.COMP.PHYS. 6, 378 (1970)
C     FLOAT(III)=DFLOAT(III)
C     ABS(XXX)=DABS(XXX)
C     DOUBLE PRECISION CZ,ZI
C     DOUBLE PRECISION CII1,CII2,QR,QI,DET
      DIMENSION ZI(NLL2,2),CZ(NLL2,5),W(1),V(1),X(1)
      COMMON/LOCAL/ FTAB(100),VTAB(100),NTAB(100),LTAB(100),JTAB(100)
     1      ,MTAB(100),NTBL(100),MI(100),IFAKE1(600),CTAB(510)
     2      ,IKTAB(510),JKTAB(510),LKTLK(510),IKTBL(510),MZTBL(512)
     3      ,ITEMP(8,8),IFAKE2(2616),DR2(8),KT,MZ,NMM,IK,BUFC(464)
C
      M1=1
      DO 700 M=1,KT
      MK=M+M-1
  320 CONTINUE
      IF(M.LT.MZTBL(M1)/262144) GO TO 321
      N2=MZTBL(M1)-262144*(MZTBL(M1)/262144)
      K1=N2-512*(N2/512)
      IF(K1.NE.0) IKTBL(K1)=N2/512
      M1=M1+1
      GO TO 320
  321 CONTINUE
      IF(M.LT.MZ) GO TO 700
      IF(M.EQ.MZ) GO TO 530
C
C     INTEGRATE NUMEROV AUXILLIARY FUNCTION
C
      DO 410 NY=1,NMM
      N2=NTBL(NY)
      NK=N2+N2-1
C
      CII1  =12.0*ZI(NK  ,2)-10.0*CZ(NK  ,5)-CZ(NK  ,4)
      CII2  =12.0*ZI(NK+1,2)-10.0*CZ(NK+1,5)-CZ(NK+1,4)
C
C     STEP INTEGRATION TABLES BACK
C
      ZI(NK  ,1)=ZI(NK  ,2)
      ZI(NK+1,1)=ZI(NK+1,2)
      CZ(NK  ,4)=CZ(NK  ,5)
      CZ(NK+1,4)=CZ(NK+1,5)
      CZ(NK  ,5)=CII1
      CZ(NK+1,5)=CII2
  410 CONTINUE
  530 CONTINUE
C
C     COMPUTE NEW ZI VALUE
C
C
C     COMPUTE DIAGONAL ELEMENTS
C
      DO 540 NY=1,NMM
      N2=NTBL(NY)
      NK=N2+N2-1
      JJ=NTAB(N2)
      NL=MTAB(N2)+M
      NM=NL+NL-1
      CII1  =FTAB(N2)/FLOAT(M*M)-DR2(JJ)*(W(NM  )+V(NL)*VTAB(N2))
      CII2  =                   -DR2(JJ)* W(NM+1)
      QR=1.0-CII1/12.0
      QI=   -CII2/12.0
      DET=QR*QR+QI*QI
      QR= QR/DET
      QI=-QI/DET
      CZ(NK  ,1)=QR
      CZ(NK+1,1)=QI
      CZ(NK  ,3)=0.D0
      CZ(NK+1,3)=0.D0
      ZI(NK  ,2)=QR*CZ(NK  ,5)-QI*CZ(NK+1,5)
      ZI(NK+1,2)=QR*CZ(NK+1,5)+QI*CZ(NK  ,5)
  540 CONTINUE
C
C     COMPUTE NON-DIAGONAL COUPLINGS
C
      IF(IK.EQ.0) GO TO 600
      DO 590 IM=1,IK
      I=IKTBL(IM)
      IF(I.EQ.0) GO TO 590
      NK=IKTAB(I)+IKTAB(I)-1
      NL=JKTAB(I)+JKTAB(I)-1
      LK=LKTLK(I)+MK
      CII1  = X(LK  )*CTAB(I)
      CII2  = X(LK+1)*CTAB(I)
      CZ(NK  ,3)=CZ(NK  ,3)+(CII1  *ZI(NL  ,2)-CII2  *ZI(NL+1,2))
      CZ(NK+1,3)=CZ(NK+1,3)+(CII1  *ZI(NL+1,2)+CII2  *ZI(NL  ,2))
  590 CONTINUE
  600 CONTINUE
      DO 620 NY=1,NMM
      N2=NTBL(NY)
      NK=N2+N2-1
      CII1  =CZ(NK  ,5)+CZ(NK  ,3)/12.0
      CII2  =CZ(NK+1,5)+CZ(NK+1,3)/12.0
      ZI(NK  ,2)=CII1*CZ(NK  ,1)-CII2*CZ(NK+1,1)
      ZI(NK+1,2)=CII1*CZ(NK+1,1)+CII2*CZ(NK  ,1)
  620 CONTINUE
  700 CONTINUE
      RETURN
      END
      SUBROUTINE SOLVE(AMAT,CMAT,D,NLL2)
      IMPLICIT REAL*8(A-H,O-Z)
C     SQRT(XXX)=DSQRT(XXX)
C     SIN(XXX)=DSIN(XXX)
C     COS(XXX)=DCOS(XXX)
C     FLOAT(III)=DFLOAT(III)
C     DOUBLE PRECISION BETA,AMAT,CMAT,TEMP,D1,D2,D3,D4,D5,D6,CII,ZI
C modified by (JE,ME)
C     USE THE NEXT 3 CARDS FOR 32-BIT MACHINES
      DOUBLE PRECISION X1,X2,ETAC,ZERO,FLM,F,FP,G,GP,S,VCC,YXFCT
      DOUBLE PRECISION ARG,ATAB,BTAB,FTAB,FACT,CMR,CMI,COEFF
      DOUBLE PRECISION AMAT,CMAT,TEMP,D1,D2,D3,D4,D5,D6,CII,ZI
      DIMENSION AMAT(NLL2,1),CMAT(NLL2,1),D(1)
      COMMON THETAN,THETA1,DTHETA,DRT,RMAX,ALPHA(15),IDAT(6)
     1,ICON(20),LMAX,KT,KMAX,LLCO,JOUT,NLTR,IBUFF,IWORD
     2,KLAM( 8),LTRT( 8),JTRT( 8),NADD( 8),LAM(16),ISP(16),JSP(16)
     3,ILK(16),JPRT( 8)
      COMMON EN( 8),FM( 8),Z( 8),FMA( 8),ZA( 8),RY( 8),FS( 8),ECM( 8)
     1,FMU( 8),RC( 8),FK2( 8),FK( 8),ETA( 8),AFACT( 8),DRF( 8),FN( 8)
     2,PNLOC( 8),DUM( 8),SIG( 8)
     3,IS( 8),NS( 8),NLI( 8),LKTAB(32),ICUP(32),JCUP(32)
     4,IN( 8),INN( 8, 8),INDTAB(10)
      COMMON/LOCAL/ F(600),FP(600),G(600),GP(600),S(600),ZI(200)
     1      ,ATAB(100),BTAB(100),FTAB(100),E(200),NTAB(100),LTAB(100)
     2      ,JTAB(100),IFAKE(300),CII(2),MAXTAB(8),BLUB(394)
      COMMON/BUFSPC/ BUFFR(800)
C modified by (JE,ME)
      SAVE
C
      IWORD=IBUFF
      DELR=0.1D0
      JMAX=LMAX
      LK=0
      IX=JTRT(1)
      MAX1=JTRT(1)+1
      MXS=MAX1*NS(1)
      NPAR=2
      IF(MXS.EQ.1) NPAR=1
      INDTAB(1)=0
      MAXL=MAX0(LMAX,3)
      IND=1
      DO 1100 I=1,NLTR
      SIG(I)=0.D0
      X2=DRF(I)*FLOAT(KT)*FK(I)
      X1=X2-DRF(I)*FK(I)
      IF(FK2(I).LT.0.0) GO TO 1050
      CALL COU(X1,X2,ETA(I),MAXL,DELR,F(IND),FP(IND),G(IND),GP(IND)
     1,S(IND))
      GO TO 1051
 1050 CONTINUE
      CALL HAN(X1,X2,ETA(I),MAXL,DELR,F(IND),FP(IND),G(IND),GP(IND)
     1,S(IND))
 1051 CONTINUE
      IND=IND+LMAX
      LKTEMP=(JTRT(I)+1)*NS(I)
      LK=LK+LKTEMP*MXS*LMAX
      MAXTAB(I)=LKTEMP
      INDTAB(I+1)=LK
 1100 CONTINUE
      MAX=LK+LK
C
C     CLEAR AMPLITUDE STORAGE
C
      DO 1110 I=1,MAX
 1110 D(I)=0.D0
      IF((ICON(6)+ICON(7)).EQ.0) GO TO 1112
      CALL CUDATE(IDAT)
      WRITE(6,9019)ALPHA,IDAT
      WRITE(6,9024)
      WRITE(6,9022)
 1112 CONTINUE
      JX1=(1.0-PHASEF(JTRT(1)+IS(1)))/2.0
C
C     J LOOP
C
      DO 2000 JA=1,JMAX
      DO 1900 JPAR=1,NPAR
C modified by (JE,ME)
      READ(8) NLL,NLI
     1       ,(NTAB(L),L=1,NLL),(LTAB(L),L=1,NLL),(JTAB(L),L=1,NLL)
      K=NLI(1)
      IF(K.EQ.0) GO TO 1900
      MAXA=NLL+NLL
      DO 1120 N1=1,NLL
      I=NTAB(N1)
      L=LTAB(N1)+1
      IND=(I-1)*LMAX
      ARG=S(IND+L)-S(IND+1)
      ATAB(N1)=COS(ARG)
      BTAB(N1)=SIN(ARG)
      DET=SQRT(DFLOAT(L+L-1)*FMU(I)*FK(1)/(FK(I)*FMU(1)))
     1*SQRT(DRF(I)/DRF(1))**3/FK(I)
      FTAB(N1)=DET
 1120 CONTINUE
C
C     SET UP AND INVERT MATRIX FOR SCATTERING AMPLITUDES
C     COEFFICIENT MATRIX IS SOLVED BY PARTITIONS
C     (A2*A1(INV)*H1-H2)*SMAT=-(A2*A1(INV)*F1-F2)
C
C     FORM A1(TR,INV)*A2(TR) = AMAT
C
      DO 1140 N2=1,NLL
      NK=N2+N2-1
C modified by (JE,ME)
      READ(8) (ZI(I),I=1,MAXA)
      DO 1130 N1=1,NLL
      NJ=N1+N1-1
      CMAT(NK  ,N1)=ZI(NJ  )
      CMAT(NK+1,N1)=ZI(NJ+1)
 1130 CONTINUE
C modified by (JE,ME)
      READ(8) (ZI(I),I=1,MAXA)
      DO 1135 N1=1,NLL
      NJ=N1+N1-1
      AMAT(NK  ,N1)=ZI(NJ  )
      AMAT(NK+1,N1)=ZI(NJ+1)
 1135 CONTINUE
 1140 CONTINUE
C
      CALL INVERT(NLL,NLL,CMAT,AMAT,NLL2)
C
C
C      TRANSPOSE AMAT INTO CMAT
C
      DO 1160 N1=1,NLL
      NJ=N1+N1-1
      DO 1150 N2=1,NLL
      NK=N2+N2-1
      CMAT(NK  ,N1)=AMAT(NJ  ,N2)
      CMAT(NK+1,N1)=AMAT(NJ+1,N2)
 1150 CONTINUE
 1160 CONTINUE
      DO 1200 N2=1,NLL
      I=NTAB(N2)
      L=LTAB(N2)+1
      IND=(I-1)*LMAX+L
      CII(1)=ATAB(N2)*FTAB(N2)
      CII(2)=BTAB(N2)*FTAB(N2)
      D1           =  CII(1)*G (IND)-CII(2)*F (IND)
      D2           =  CII(1)*F (IND)+CII(2)*G (IND)
      D3           =  CII(1)*GP(IND)-CII(2)*FP(IND)
      D4           =  CII(1)*FP(IND)+CII(2)*GP(IND)
      DO 1190 N1=1,NLL
      NJ=N1+N1-1
      AMAT(NJ  ,N2)=CMAT(NJ  ,N2)*D1-CMAT(NJ+1,N2)*D2
      AMAT(NJ+1,N2)=CMAT(NJ+1,N2)*D1+CMAT(NJ  ,N2)*D2
      IF(I.NE.1) GO TO 1189
      D5=-CMAT(NJ  ,N2)*F (L)
      D6=-CMAT(NJ+1,N2)*F (L)
      CMAT(NJ  ,N2)=D5*CII(1)-D6*CII(2)
      CMAT(NJ+1,N2)=D5*CII(2)+D6*CII(1)
 1189 CONTINUE
 1190 CONTINUE
      NK=N2+N2-1
      AMAT(NK  ,N2)=AMAT(NK  ,N2)-D3
      AMAT(NK+1,N2)=AMAT(NK+1,N2)-D4
      IF(I.NE.1) GO TO 1200
      CMAT(NK  ,N2)=CMAT(NK  ,N2)+CII(1)*FP(L)
      CMAT(NK+1,N2)=CMAT(NK+1,N2)+CII(2)*FP(L)
 1200 CONTINUE
C
      CALL INVERT(NLL,K  ,AMAT,CMAT,NLL2)
C
      JT=JA+JA-2+JX1
      FJ=JT+1
      DO 1600 N1=1,K
      NN=N1+N1-1
      E(NN  )=CMAT(NN  ,N1)
      E(NN+1)=CMAT(NN+1,N1)
      JX=JTAB(N1)
      LX=LTAB(N1)+LTAB(N1)
      FL=LTAB(N1)+LTAB(N1)+1
      DO 1500 N2=1,NLL
      NK=N2+N2-1
      JJ=NTAB(N2)
      JY=JTAB(N2)
      LZ=LTAB(N2)
      LY=LTAB(N2)+LTAB(N2)
      IY=JTRT(JJ)
      MAXI=JTRT(JJ)+1
      CII(1)=(ATAB(N2)**2-BTAB(N2)**2)/FK(JJ)
      CII(2)= 2.0*ATAB(N2)*BTAB(N2)   /FK(JJ)
      D1=CMAT(NK  ,N1)*CII(1)-CMAT(NK+1,N1)*CII(2)
      D2=CMAT(NK  ,N1)*CII(2)+CMAT(NK+1,N1)*CII(1)
C
C     REACTION AND TOTAL INELASTIC XSECT
C
      FACT=FJ*FLOAT(LZ+LZ+1)/FL
      CMR=CMAT(NK  ,N1)
      CMI=CMAT(NK+1,N1)
      TEMP=0.0
      IF(ABS(CMR).GT.1.0E-18) TEMP=CMR*CMR
      IF(ABS(CMI).GT.1.0E-18) TEMP=TEMP+CMI*CMI
      IF(JJ.EQ.1) GO TO 1290
      SIG(JJ)=SIG(JJ)+TEMP*FACT
      GO TO 1299
 1290 CONTINUE
      IF(N1.NE.N2) GO TO 1299
      SIG(1)=SIG(1)+(CMAT(NK+1,N1)-TEMP)*FACT
 1299 CONTINUE
      CMAT(NK  ,N1)=D1
      CMAT(NK+1,N1)=D2
C
C     STORE S-MATRIX ELEMENTS
C
      JR=NS(1)
      JS=NS(JJ)
      PHASE=PHASEF((LX+IS(1)+IX-LY-IS(JJ)-IY)/2)
      INDEX=MAXTAB(1)*MAXTAB(JJ)*LZ+INDTAB(JJ)
      INDEX=INDEX+INDEX+1
      IND=INDEX+MAX1*MAXI*JR*JS*2-2
      MM=-JTRT(1)
      IF(MM.EQ.0) GO TO 1310
      M1=(MAX1+1)/2
      MI=MAXI
      GO TO 1315
 1310 CONTINUE
      M1=1
      MI=(MAXI+1)/2
 1315 CONTINUE
      DO 1490 MX=1,M1
      MMS=-JTRT(JJ)
      DO 1480 MY=1,MI
      MS=-IS(1)
      DO 1470 M =1,JR
      MSP=-IS(JJ)
      DO 1460 MP=1,JS
      ML=MS+MM-MSP-MMS
      MLT=IABS(ML/2)
      IF(MLT.GT.LZ) GO TO 1458
      PHAS=1.D0
      IF(ML.LT.0) PHAS=PHASEF(MLT)
C
      COEFF=VCC(LX,IS(1),JX,0,MS)*VCC(JX,IX,JT,MS,MM)
     1*VCC(LY,IS(JJ),JY,ML,MSP)*VCC(JY,IY,JT,ML+MSP,MMS)
     2*EXP(0.5*YXFCT(LZ+MLT,LZ-MLT))*PHAS*FLOAT(LY+1)
C
      D(INDEX  )=D(INDEX  )+D1*COEFF
      D(INDEX+1)=D(INDEX+1)+D2*COEFF
C
C     FILL OUT D TABLE
C
      IF((JTRT(1)+JTRT(JJ)).EQ.0) GO TO 1458
      IF((M1.NE.MAX1).AND.(MM.EQ.0)) GO TO 1458
      IF((MI.NE.MAXI).AND.(MMS.EQ.0))GO TO 1458
      PHAS=PHASE*PHAS
      IF(ML.GT.0)PHAS=PHASE*PHASEF(MLT)
      D(IND  )=D(INDEX  )*PHAS
      D(IND+1)=D(INDEX+1)*PHAS
 1458 CONTINUE
      INDEX=INDEX+2
      IND=IND-2
      MSP=MSP+2
 1460 CONTINUE
      MS=MS+2
 1470 CONTINUE
      MMS=MMS+2
 1480 CONTINUE
      MM=MM+2
 1490 CONTINUE
 1500 CONTINUE
      IF(ICON(7).EQ.0) GO TO 1600
      K1=1
      K3=1
      DO 1590 I=1,NLTR
      IF(NLI(I).EQ.0) GO TO 1590
      K2=K1+NLI(I)+NLI(I)-1
      WRITE(6,9025)I,JT,LTAB(K3),(CMAT(M,N1),M=K1,K2)
      K1=K2+1
      K3=K3+NLI(I)
 1590 CONTINUE
 1600 CONTINUE
      IF(ICON(6).EQ.0) GO TO 1900
      I=1
      K2=K+K
      WRITE(6,9023)I,JT,LTAB(1),(E(M),M=1,K2)
      IF(ICON(6).NE.2) GO TO 1900
      DO 1610 M=1,K
      MK=M+M-1
      T1=E(MK+1)
      E(MK+1)=2.0*E(MK  )
      E(MK  )=1.0-2.0*T1
 1610 CONTINUE
      WRITE(6,9023)I,JT,LTAB(1),(E(M),M=1,K2)
 1900 CONTINUE
 2000 CONTINUE
      DO 2100 I=1,NLTR
      SIG(I)=SIG(I)*12.5663706/(FLOAT((JTRT(1)+1)*NS(1))*FK(I)**2)
 2100 CONTINUE
      IF(ICON( 8).EQ.0) GO TO 2610
C
C     WRITE OUT AMPLITUDES
C
      MAX1=JTRT(1)+1
      CALL CUDATE(IDAT)
      WRITE(6,9019)ALPHA,IDAT
      IND=1
      DO 2605 I=1,NLTR
      MAXI=JTRT(I)+1
      KST=NS(1)*MAX1*NS(I)*MAXI
      KST=KST+KST
      WRITE(6,9060)I
      DO 2590 L=1,LMAX
      LTEMP=L-1
      K1=IND
      K2=IND+KST-1
      WRITE(6,9061)LTEMP,(D(J),J=K1,K2)
      IF(I.EQ.ICON(8)) WRITE(2,9062)LTEMP,(D(J),J=K1,K2)
      IND=K2+1
 2590 CONTINUE
 2605 CONTINUE
 2610 CONTINUE
 3000 CONTINUE
      RETURN
 9019 FORMAT(1H1,17X,15A4,4X,I2,2(1H/,I2),I4,2(1H.,I2))
 9022 FORMAT(12H0CHN 2*J  L1)
 9023 FORMAT(3I4,10F12.7/(12X,10F12.7))
 9024 FORMAT(22H SCATTERING AMPLITUDES )
 9025 FORMAT(3I4,10E12.4/(12X,10E12.4))
 9060 FORMAT(5H0CHN=,I2,100(1H*))
 9061 FORMAT(5H  L2=,I3,2X,10E12.4/(10X,10E12.4))
 9062 FORMAT(I4,10E12.5/(4X,10E12.5))
      END
      SUBROUTINE HAN(R ,RP,E,L,H,F,FP,G,GP,S)
C modified by (JE,ME)
C      IMPLICIT REAL*8(A-H,O-Z)
C     USE THE NEXT 1 CARDS FOR 32-BIT MACHINES
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     ABS(XXX)=DABS(XXX)
      DIMENSION F(50),FP(50),G(50),GP(50),S(50)
      FF(X)=EXP(-X-E*LOG(2.0*X))
C modified by (JE,ME)
      SAVE
      DO 40 J=1,2
      FL=J-1
      T3=1.D0
      T4=1.D0
      T5=1.D0
      T6=1.D0
      G (J)=1.D0
      GP(J)=1.D0
      DO 30 I=1,20
      T3=T3*(FL+1.0-E-T4)*(FL+E+T4)/(2.0*T4)
      T5=T5/R
      T6=T6/RP
      G (J)=G (J)+T5*T3
      GP(J)=GP(J)+T6*T3
      T4=T4+1.D0
      TEST=ABS(T5*T3)
      IF(TEST.LT.1.0D-05) GO TO 35
   30 CONTINUE
      WRITE(6,9000)TEST
   35 CONTINUE
      G (J)=G (J)*FF(R )
      GP(J)=GP(J)*FF(RP)
   40 CONTINUE
      F (1)=0.D0
      F (2)=0.D0
      FP(1)=0.D0
      FP(2)=0.D0
      S(1)=0.D0
      S(2)=0.D0
      LL=L
      T1=E*E
      T2=1.D0
      T3=2.D0
      DO 50 I=3,LL
      T4=T2+T3
      T5=T2*T3
      T6=T3*SQRT(T2**2+T1)
      T7=T2*SQRT(T3**2+T1)
      G (I)=(T4*(E+T5/R )*G (I-1)+T6*G (I-2))/T7
      GP(I)=(T4*(E+T5/RP)*GP(I-1)+T6*GP(I-2))/T7
      T2=T2+1
      T3=T3+1
      F (I)=0.D0
      FP(I)=0.D0
      S(I)=0.D0
   50 CONTINUE
      RETURN
 9000 FORMAT(25H0BOUNDSTATE CONVERGES TO ,E12.3,8H IN HAN   )
      END
      SUBROUTINE XSECT(D,PLM,SR,SI)
      IMPLICIT REAL*8(A-H,O-Z)
C     SIN(XXX)=DSIN(XXX)
C     COS(XXX)=DCOS(XXX)
C     ALOG(XXX)=DLOG(XXX)
C     SQRT(XXX)=DSQRT(XXX)
C     FLOAT(III)=DFLOAT(III)
C     DOUBLE PRECISION BETA
      DIMENSION D(1),PLM(1),SR(1),SI(1)
      COMMON THETAN,THETA1,DTHETA,DRT,RMAX,ALPHA(15),IDAT(6)
     1,ICON(20),LMAX,KT,KMAX,LLCO,JOUT,NLTR,IBUFF,IWORD
     2,KLAM( 8),LTRT( 8),JTRT( 8),NADD( 8),LAM(16),ISP(16),JSP(16)
     3,ILK(16),JPRT( 8)
      COMMON EN( 8),FM( 8),Z( 8),FMA( 8),ZA( 8),RY( 8),FS( 8),ECM( 8)
     1,FMU( 8),RC( 8),FK2( 8),FK( 8),ETA( 8),AFACT( 8),DRF( 8),FN( 8)
     2,PNLOC( 8),DUM( 8),SIG( 8)
     3,IS( 8),NS( 8),NLI( 8),LKTAB(32),ICUP(32),JCUP(32)
     4,IN( 8),INN( 8, 8),INDTAB(10)
      COMMON/LOCAL/  TSIG(256),POL(9,256),SUMR(5,5),SUMI(5,5),POLX(9)
     1,BUFC(1781)
      COMMON/BUFSPC/ BUFFR(800)
      DATA NMAX/256/
C
      IF(ICON(5).EQ.0) GO TO 10
C
C     WRITE AMPLITUDES ON TAPE 4
C
      WRITE(4)THETAN,THETA1,DTHETA,ALPHA,IDAT,LMAX,NLTR,LTRT,JTRT,NADD
     1,JPRT,FS,FK,ETA,SIG,IS,NS,INDTAB
      N=INDTAB(NLTR+1)
      N=N+N
      WRITE(4)(D(I),I=1,N)
   10 CONTINUE
      JMAX=LMAX
      JMAX2=JMAX+JMAX
      NLTR1=NLTR+1
      NTHETA=NINT(THETAN)
      IF(NTHETA.EQ.0) GO TO 2100
      MAX1=JTRT(1)+1
      MAXM=0
      DO 40 I=1,NLTR
      MAXM=MAX0(MAXM,(JTRT(1)+JTRT(I)+IS(1)+IS(I))/2+1)
   40 CONTINUE
      REWIND 9
      NX=MAXM*LMAX
      IWORD=0
      THETA=THETA1
      DO 50 M=1,NTHETA
      CALL LGNDR(PLM,MAXM,LMAX,THETA)
C modified by (JE,ME)
      WRITE(9) (PLM(I),I=1,NX)
      THETA=THETA+DTHETA
   50 CONTINUE
C modified by (JE,ME)
      WRITE(9) NX
      IF(IWORD.EQ.IBUFF) GO TO 51
      IWORD=IBUFF-1
  51  CONTINUE
C
C     CHANNEL LOOP
C
      DO 1000 I=1,NLTR
      IF(FK2(I).LT.0.0) GO TO 1000
      CALL CUDATE(IDAT)
      WRITE(6,9019) ALPHA,IDAT
      WRITE(6,9022) I,FM(I),Z(I),FMA(I),ZA(I),EN(I),IS(I),LTRT(I)
      WRITE(6,9024)
      IF((ICON(13).EQ.9).OR.(ICON(13).EQ.I)) WRITE(7,9030) I,ALPHA
      REWIND 9
      IWORD=IBUFF
C
C     ANGLE LOOP
C
      THETA=THETA1
      DO 900 N=1,NTHETA
      IF(N.GT.NMAX) GO TO 910
C modified by (JE,ME)
      READ(9) (PLM(M),M=1,NX)
      IF(I.NE.1) GO TO 75
C
C     CALCULATE COULOMB AMPLITUDE FOR CHANNEL 1
C
      IF(ETA(1).EQ.0.0) GO TO 75
      SS=SIN(THETA/114.5915  )**2
      IF(SS.LE.1.0D-10) GO TO 75
      TL=LOG(SS)
      ARG=ETA(1)*TL
      CFACT=ETA(1)/(2.0*FK(1)*SS)
      CL=COS(ARG)*CFACT
      SL=SIN(ARG)*CFACT
      GO TO 76
   75 CONTINUE
      CL=0.D0
      SL=0.D0
   76 CONTINUE
      IND=INDTAB(I)
      IND=IND+IND
      MAXI=JTRT(I)+1
      KST=NS(1)*MAX1*NS(I)*MAXI
      DO 150 J=1,KST
      SR(J)=0.D0
      SI(J)=0.D0
  150 CONTINUE
      TSIG(N)=0.D0
      DO 155 M=1,9
      POL(M,N)=0.D0
  155 CONTINUE
      INC=IND+1
      JR=NS(1)
      JS=NS(I)
      DO 500 L=1,LMAX
      LZ=L-1
      IT=1
      MM=-JTRT(1)
      DO 490 MX=1,MAX1
      MMS=-JTRT(I)
      DO 480 MY=1,MAXI
      MS=-IS(1)
      DO 470 M =1,JR
      MSP=-IS(I)
      DO 460 MP=1,JS
      ML=MS+MM-MSP-MMS
      MLT=IABS(ML/2)
      INDX=MLT*LMAX+LZ+1
      SR(IT)=SR(IT)+D(INC  )*PLM(INDX)
      SI(IT)=SI(IT)+D(INC+1)*PLM(INDX)
      INC=INC+2
      IT=IT+1
      MSP=MSP+2
  460 CONTINUE
      MS=MS+2
  470 CONTINUE
      MMS=MMS+2
  480 CONTINUE
      MM=MM+2
  490 CONTINUE
  500 CONTINUE
      IT=1
      DO 790 MX=1,MAX1
      DO 780 MY=1,MAXI
      DO 580 M =1,5
      DO 580 MP=1,5
      SUMR(M,MP)=0.D0
      SUMI(M,MP)=0.D0
  580 CONTINUE
      DO 670 M =1,JR
      DO 660 MP=1,JS
      IF(I.NE.1) GO TO 610
      IF(M .NE.MP) GO TO 610
      IF(MX.NE.MY) GO TO 610
C
C     ADD COULOMB TERM TO CHANNEL 1 AMPLITUDE
C
      SR(IT)=SR(IT)-CL
      SI(IT)=SI(IT)+SL
  610 CONTINUE
      SUMR(MP,M)=SUMR(MP,M)+SR(IT)
      SUMI(MP,M)=SUMI(MP,M)+SI(IT)
      TSIG(N)=TSIG(N)+SR(IT)**2+SI(IT)**2
      IT=IT+1
  660 CONTINUE
  670 CONTINUE
C
C     CALCULATE POLARIZATION
C
      CALL POLFCT(POLX,SUMR,SUMI,JS,JR)
      DO 770 M=1,9
      POL(M,N)=POL(M,N)+POLX(M)
  770 CONTINUE
  780 CONTINUE
  790 CONTINUE
C
C
      IF(TSIG(N).EQ.0.0) GO TO 820
      DO 815 M=1,9
      POL(M,N)=POL(M,N)/TSIG(N)
  815 CONTINUE
      TSIG(N)=TSIG(N)/FLOAT(MAX1*NS(1))
      GO TO 830
  820 CONTINUE
      DO 825 M=1,9
      POL(M,N)=0.D0
  825 CONTINUE
  830 CONTINUE
      RATIO=0.D0
      IF(I.NE.1) GO TO 855
      IF(ETA(1).EQ.0.0) GO TO 855
      RATIO=1.0
      IF(SS.LT.1.0D-10) GO TO 855
      RATIO=TSIG(N)/(CFACT*CFACT)
  855 CONTINUE
      WRITE(6,9900) THETA,TSIG(N),RATIO,(POL(M,N),M=1,9)
      IF((ICON(13).EQ.9).OR.(ICON(13).EQ.I)) WRITE(7,9031) THETA,
     1  TSIG(N),(POL(M,N),M=1,9)
      IF(I.NE.1) GO TO 890
      IF(ETA(1).EQ.0.0) GO TO 890
      TEMP=TSIG(N)
      TSIG(N)=RATIO
      RATIO=TEMP
  890 CONTINUE
      THETA=THETA+DTHETA
  900 CONTINUE
  910 CONTINUE
      IF(I.EQ.1) WRITE(6,9904) SIG(I)
      IF(I.NE.1) WRITE(6,9905) SIG(I)
      IF(ICON(9).GT.5) GO TO 1000
      IF(ICON(9).EQ.0) ICON(9)=3
      N=MIN0(NTHETA,NMAX)
      CALL CUDATE(IDAT)
      WRITE(6,9019)ALPHA,IDAT
      WRITE(6,9901)I,LTRT(I)
      IF((I.NE.1).OR. (ETA(1).EQ.0.0)) WRITE(6,9028)
      IF((I.EQ.1).AND.(ETA(1).NE.0.0)) WRITE(6,9029)
      CALL DWPLOT(N,ICON(9),TSIG(1),DTHETA,THETA1)
 1000 CONTINUE
 2100 CONTINUE
      RETURN
 9019 FORMAT(1H1,17X,15A4,4X,I2,2(1H/,I2),I4,2(1H.,I2))
 9022 FORMAT(8H0CHANNEL,I3,4X,4HFM =,F8.4,5H  Z =,F5.1,3X,2HON,7H  FMA =
     1,F9.4,6H  ZA =,F5.1,4X,6HELAB =,F9.4,04X,8H2*SPIN =,I4,4X,8H2*JTRT
     2 =,I4)
 9024 FORMAT(7H0 THETA,4X,10HSIGMA F**2,4X,10HSIGMA/RUTH,7X,4HPOL.,6X,3H
     1T22,7X,3HT21,7X,3HT20,9X,4HA.P.,6X,3HT22,7X,3HT21,7X,3HT20,7X,7HSF
     2-PROB)
 9028 FORMAT(1H+,12X,10HSIGMA F**2)
 9029 FORMAT(1H+,12X,10HSIGMA/RUTH)
 9030 FORMAT(7HCHANNEL,I3,10X,15A4)
 9031 FORMAT(F6.2,1PE11.4,9(0PF7.4))
 9900 FORMAT(F7.2,2E14.4,2(2X,4F10.5),2X,F10.5)
 9901 FORMAT(8H0CHANNEL,I3,12X,10H   2*SPIN=,I3)
 9904 FORMAT(9H0REACSIG ,E12.4)
 9905 FORMAT(9H0TOTALSIG,E12.4)
      END
      SUBROUTINE INVERT(MAX,N,A,C,NLL2)
      IMPLICIT REAL*8(A-H,O-Z)
C     COMPLEX*16 A(40,40),C(40,40),B
C     COMPLEX    A(40,40),C(40,40),B
C     DO 100 I=1,MAX
C     B=1.0/A(I,I)
C     DO 10 K=1,N
C     C(I,K)=C(I,K)*B
C  10 CONTINUE
C     DO 20 J=I,MAX
C  20 A(I,J)=A(I,J)*B
C     DO 50 J=1,MAX
C     IF(I.EQ.J) GO TO 50
C     B=A(J,I)
C     DO 35 K=1,N
C     C(J,K)=C(J,K)-C(I,K)*B
C  35 CONTINUE
C     DO 40 K=I,MAX
C  40 A(J,K)=A(J,K)-A(I,K)*B
C
C     CODE TO HANDLE DOUBLE PRECISION COMPLEX ON THE DEC-10.
C     IF ABOVE CODING IS RESTORED, DIMENSIONS AND NLL2 MUST BE FIXED UP.
C
C     DOUBLE PRECISION A,C,AR,AI,BR,BI,CR,CI,TERM,FACT
      DIMENSION A(NLL2,1),C(NLL2,1)
      DO 100 I=1,MAX
      I1=I+I-1
      AR=A(I1  ,I)
      AI=A(I1+1,I)
      FACT=1.D0
      TERM=DMAX1(DABS(AR),DABS(AI))
      IF(TERM.LE.5.D18) GO TO 2
      FACT=TERM/5.D18
      GO TO 3
    2 CONTINUE
      IF(TERM.GE.1.D-10) GO TO 5
      FACT=TERM/1.D-10
    3 CONTINUE
      AR=AR/FACT
      AI=AI/FACT
    5 CONTINUE
      TERM=AR*AR+AI*AI
      BR= AR/TERM
      BI=-AI/TERM
      BR=BR/FACT
      BI=BI/FACT
      DO 10 K=1,N
      CR=C(I1  ,K)
      CI=C(I1+1,K)
      C(I1  ,K)=CR*BR-CI*BI
      C(I1+1,K)=CR*BI+CI*BR
   10 CONTINUE
      DO 20 J=I,MAX
      AR=A(I1  ,J)
      AI=A(I1+1,J)
      A(I1  ,J)=AR*BR-AI*BI
      A(I1+1,J)=AR*BI+AI*BR
   20 CONTINUE
      DO 50 J=1,MAX
      IF(I.EQ.J) GO TO 50
      J1=J+J-1
      BR=A(J1  ,I)
      BI=A(J1+1,I)
      DO 35 K=1,N
      CR=C(I1  ,K)
      CI=C(I1+1,K)
      C(J1  ,K)=C(J1  ,K)-CR*BR+CI*BI
      C(J1+1,K)=C(J1+1,K)-CR*BI-CI*BR
   35 CONTINUE
      DO 40 K=I,MAX
      AR=A(I1  ,K)
      AI=A(I1+1,K)
      A(J1  ,K)=A(J1  ,K)-AR*BR+AI*BI
      A(J1+1,K)=A(J1+1,K)-AR*BI-AI*BR
   40 CONTINUE
   50 CONTINUE
  100 CONTINUE
      RETURN
      END

	SUBROUTINE CIOGIT (PROMPT,ITEM,ITEML,*,*,*,*)
C++
C TITLE:  CIOGIT
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Get and examine next item from current input buffer.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	CIOAIF, CIOPUR, CIOLIT, CIOQLU, CIOQSH, CIOERL, CIOHLP
C	CIOGBF, CIOPRM, INDEX,  STR__UPCASE
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 30-jan-1981 Made item extraction a separate routine.
C PAK 13-may-1981 Implemented qualifiers.
C FUNCTIONAL DESCRIPTION:
C	  The next item from the input buffer is located by a call to CIOLIT.
C	If the inputbuffer is empty, CIOPRM is called to prompt for
C	input (in some cases it doesn't), and CIOGBF is called to read input.
C	  After an unquoted item is extracted, it it examined to see if it
C	equals one of the special characters. If so, the corresponding
C	alternate return is taken.
C	  If the item starts with an @-sign it is considered to be the
C	specification for an alternate input file. CIOAIF is called
C	to open this file, the current inputbuffer is purged, and
C	reading continues on the alternate input file.
C CALLING SEQUENCE: (only for internal use by CIO)
C	CALL CIOGIT (PROMPT,ITEM,ITEML,*,*,*,*)
C INPUT PARAMETERS:
C	PROMPT	characterstring to be used as prompt in case input
C		buffer is empty, no continuation symbol was present,
C		and new input is required.
C OUTPUT PARAMETERS:
C	ITEM	character string receiving the extracted item.
C	ITEML	integer receiving the nr of characters returned
C		in ITEM.
C ALTERNATE RETURNS:
C	1	item is 'keep-current-value' character.
C	2	item is 'take-default' character.
C	3	item is 'show-parameters' character.
C	4	item is 'flow-control' character.
C--

	INCLUDE 'ciocom.inc'

	CHARACTER*(*)	ITEM,PROMPT
      INTEGER           ITEML

      LOGICAL           LQUOTE,LQUALERR
      CHARACTER*4       CTEMP
      INTEGER           IRET
      INTEGER           I1, I2

C Extract next item from input buffer.

C      write (*,*) '?????? ciogit called, inbufc=', INBUFC

	LQUALERR = .FALSE.		! clear qualifier error flag.

   10	IRET = 0				! Assume normal return.
	CALL CIOLIT (INPTR, I1, I2, LQUOTE, *550) ! Locate next item. If buffer
                                        ! empty, go prompt and get new.
C      write (*,*) 'TEST OUTPUT'
      ITEM = INBUF(I1:I2)               ! Extract it,
      ITEML = I2 - I1 + 1               ! also save length.

	ITPTR1 = I1			! Save location of item so
	ITPTR2 = I2			! CIOERL can mark it if it wishes.

C See if item is a qualifier.
C If qualifier, lookup in qualifier list and update associated variable.
C If no qualifiers allowed, complain and simply go back for next item.
C If unknown or ambiguous qualifier then complain and go get new line in
C inputbuffer, but don't prompt. Then go back for next item.
C This give the user the choise of either re-entering the qualifier or
C simply omit it.

	CALL CIOQLU (I1, I2, *24, *10, *22)	! See if qual. and handle it.
      GOTO 10                           ! Good qualifier, try next item.
  22	LQUALERR = .TRUE.			! Qualifier error, remember
	GOTO 560				! and get new input, no prompt.
  24	CONTINUE				! Not a qualifier.

C Quoted non-qualifier items get no further examination.
C They are returned literally.

	IF (LQUOTE) RETURN

C Examine 1 character item. It may be a control character.
C Check this, and set IRET to take the appropriate return.
C IRET will take one of the following values:
C 	0	single character, unquoted, and non-special
C	1	keep-current-value character (=)
C	2	take-default-value character (*)
C	3	show-parameters character    (?)
C	4	any flow-control character   (< > ^ $)

	IF (ITEML.EQ.1) THEN
	  IRET = MIN (4, INDEX (S_CHAR, ITEM(1:1)))
	  GOTO 100
	ENDIF

C Item longer than 1 character.
C If last character of the item is a colon (:), ignore the item,
C it is an intermixed comment string. Go extract next item.

	IF (INBUF(I2:I2) .EQ. ':') GOTO 10

C If item equals the 4-character string HELP (in either upper or lower case)
C call on-line HELP routine, then go get next item.

	CALL STR__UPCASE (CTEMP, ITEM(1:4))
	IF (ITEML.EQ.4.AND.CTEMP.EQ.'HELP') THEN
	  CALL CIOHLP			! get help
	  IF (LQUALERR) THEN		! if just had qualifier error
	    GOTO 560			! get input, don't prompt
	  ELSE				! else
	    GOTO 10			! go get next item.
	  ENDIF
	ENDIF

C If item starts with an @-sign assume it is an alternate filename. Open
C the alternate file, purge the current inputbuffer, then read a new
C buffer from the alternate file.

	IF (ITEM(1:1).EQ.'@') THEN
	  CALL CIOAIF (ITEM(2:ITEML), *510, *520)
	  CALL CIOPUR
	  GOTO 550
	ENDIF

C Item extracted and analysed.
C If it is the questionmark in response to a qualifier error, react by
C displaying the legal qualifiers, then go get next item.

  100	IF (IRET.EQ.3 .and. LQUALERR) THEN
	  CALL CIOQSH			! show legal qualifiers
	  GOTO 560			! get input, don't prompt
	ENDIF

C In all other cases take the appropriate return.

	RETURN IRET

C Alternate file nesting too deep or file-open error.
C Complain, invalidate inputbuffer and alternate files, then
C join code below for prompting and reading new inputbuffer.

  510	CALL CIOERL ('alternate file nesting too deep')
	GOTO 550
  520	CALL CIOERL ('open error on alternate input file')

C Come here if inputbuffer exhausted. Prompt, then read new buffer.

  550	CALL CIOPRM (PROMPT)		! prompt
	LQUALERR = .FALSE.		! clear qualifier error flag.
  560	CALL CIOGBF			! read input buffer.
	GOTO 10
	END

	SUBROUTINE CIOAIF (FILALT,*,*)
C++
C TITLE:  CIOAIF
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Switch to alternate input file, referred to by
C	file-specification.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	CIOLUNGET, CIOLUNFREE
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C 26-jan-1981 PAK, Replaced call to LUNGET by call to LIB$GET_LUN
C 28-apr-1981 PAK, Combined CIOAIF, CIOAIC.
C FUNCTIONAL DESCRIPTION:
C	A new lun is obtained by a call to CIOLUNGET and the
C	specified file is opened for the new lun.
C	The logical unit nr (lun) of the current CIO input device
C	is pushed on an internal stack (if the stack is full
C	alternate return 1 is taken), then input is switched to
C	the new lun.
C	CIO now proceeds reading input from the alternate lun until
C	end-of-file is encountered.
C	Input is then switched back to the lun most recently pushed
C	on the stack by a call to CIOAIC.
C CALLING SEQUENCE:
C	CALL CIOAIF (FILALT,*,*)
C INPUT PARAMETERS:
C	FILALT	the filespecification for the file from which CIO
C	should read input until end-of-file is detected.
C ALTERNATE RETURNS:
C	1	no more room on the stack (i.e. alternate file
C		nesting too deep) or process wide LUN pool exhausted.
C	2	Open failure on alternate file.
C--

	INCLUDE 'ciocom.inc'
	CHARACTER	FILALT*(*)
	INTEGER		IST
	INTEGER		LUN

C Allocate a logical unit number.
C If no more available take error return.
	CALL CIOLUNGET (LUN, IST) !???g77
	IF (IST.ne.1) GOTO 810	!???g77 status test

C Open the specified file on the allocated unit number.
C If file-open-error take alternate return.

C???g77	OPEN (UNIT=LUN, NAME=FILALT, TYPE='OLD', READONLY, SHARED ,ERR=900)

C Switch further CIO input to the new logical unit nr.
C The negative LUN indicates that we allocated it through LIB$GET_LUN.
C If the stack is full, invalidate the input buffer and
C close all open alternate files, then take alternate return.

	IF (LUNSTP.GE.LSTKSZ) GOTO 800

C Push current lun on the stack, including its sign which indicates
C whether this lun was allocated by CIOLUNGET (sign negative) or not.

	LUNSTP = LUNSTP + 1
	LUNSTK(LUNSTP) = LUNIS

C Then make the new /lun/ the current one.
C Also save the new negated LUN in LUNIS.

	LUNI = LUN
	LUNIS =  - LUN
	RETURN

C Too deep nesting of alternate files.
C We must close the file we just opened.
  800	CLOSE (UNIT=LUN)

C Process wide LUN pool exhausted.
  810	RETURN 1

C OPEN of alternate file fails.
  900	RETURN 2

	ENTRY CIOAIC (*)
C++
C ENTRY:  CIOAIC
C ABSTRACT: Close currently open alternate file (if one is open)
C	and let input proceed from previous level file.
C FUNCTIONAL DESCRIPTION:
C	Close the currently open alternate input file.
C	Then deallocate the lun for the file and proceed input from
C	the lun most recently pushed on the lun-stack.
C CALLING SEQUENCE:  (only for internal use by CIO)
C	CALL CIOAIC (*)
C ALTERNATE RETURNS:
C	1	Current file is the zero level input file.
C--

C If no more alternate files open (stack empty) take alternate return
	IF (LUNSTP.EQ.0) RETURN 1

C Close alternate file. Deallocate LUN if allocated by CIOLUNFREE
	CLOSE (UNIT=LUNI)
	IF (LUNIS.LT.0) THEN
	  CALL CIOLUNFREE (-LUNIS, IST)	!???g77
	  IF (IST.ne.1) STOP 1	!???g77 status test
	ENDIF

C Pop previous LUN from the stack.
	LUNIS = LUNSTK(LUNSTP)
	LUNI = IABS (LUNIS)
	LUNSTP = LUNSTP - 1

	RETURN
	END

	SUBROUTINE CIOGBF
C++
C TITLE:  CIOGBF
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Get input buffer from current input file, and process
C	end-of-file and read-error conditions.
C ENVIRONMENT:  FORTRAN-77 except for the use of the Q format specifier.
C PROCEDURES CALLED:
C	CIOAIC, CIOERR, CIOMSG, CIOPAB
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 29-jan-1981 Added check for comment field and continuation character
C			by call to CIOPAB.
C PAK 11-feb-1981 Repaired faulty logic around current-item pointers
C FUNCTIONAL DESCRIPTION:
C	  The next record from the device with logical unit nr LUNI
C	is read into the internal inputbuffer INBUF.
C	  If no special condition occurs, CIOPAB is called to pre-analyse
C	the buffer (total length, length excl. comment, continuation symbol).
C	  If an end-of-file is detected, a message is displayed
C	and CIOAIC is called in order to switch input back to
C	the previous level alternate file if it exists.
C	  If the zero level file is reached, and the program runs
C	in non-interactive mode, a message is issued and the
C	program is aborted.
C	  If a read error occurs, a message is displayed. Then, if
C	in non-interactive mode, the program is aborted, if in
C	interactive mode, al alternate files are closed, the
C	inputbuffer is purged and input proceeds from the zero
C	level input device.
C CALLING SEQUENCE: (only for internal use by CIO)
C	CALL CIOGBF
C IMPLICIT OUTPUTS:
C	INBUF, INBUFL, INBUFC, INPTR, ITPTR1, ITPTR2 and LCONTIN in common.
C--

	INCLUDE 'ciocom.inc'

C Reset input-buffer-pointer. Read next buffer from current
C input file and if no EOF or error, call CIOPAB to pre-analyse the input.
C i.e. find the part before the comment field, and determine
C whether a continuation symbol is present. Then return to caller.

C Linux/f77 doesn't support the 'Q' format code. In OpenVMS Fortran
C this provides the number of characters remaining in to be transferred
C in an input record, so that we know how much will be read into INBUF.
C The main purpose is to detect that the input record is longer than
C will fit in INBUF, and issue a warning if needed.
C
C In Linux, we remove the Q. As a result, too long input records go
C undetected. Also, as we don't know the length of the actual content
C of INBUF, we rely on CIOPAB() to remove the trailing spaces.
C A bit expensive, but good enough for the time being.

C 100	READ (LUNI,'(Q,A)', END=200, ERR=300) INBUFL,INBUF
C	IF (INBUFL .GT. INBSIZ) THEN
C	   CALL CIOMSG (0,'warning - input line truncated')
C	   INBUFL = INBSIZ
C	ENDIF

  100	READ (LUNI,'(A)', END=200, ERR=300) INBUF
	INBUFL = LEN(INBUF)
	CALL CIOPAB	! Pre-analyse buffer.
	RETURN

C End-of-file encountered.
C Issue an informative message. (CIOMSG will indicate the alternate
C file level if other than zero).
C Then attempt to fall back to previous alternate-file level, and if
C it exists, proceed reading from that file.

  200	INBUFL = 0
	INBUFC = 0
	INPTR = 0
	ITPTR1 = 0
	ITPTR2 = 0
	LCONTIN = .FALSE.
	CALL CIOMSG (0,'end-of-file')
	CALL CIOAIC (*210)
	RETURN		!???? misschien beter GOTO 100
			!???? maar dan prompten we niet meer, dus toch niet??

C The end-of-file occurred at zero level input. If input not from
C a terminal, this is fatal; complain and abort.Otherwise simply ignore.

  210	IF (MODI.GT.0) THEN
	  CALL CIOMSG (1,'This is fatal in non-interactive mode')
	ELSE
	  RETURN
	ENDIF

C Read error on current input file.
C We issue a warning message. If not at the zero level input, CIOERR
C will show the alternate-file-level at which the error occured.
C Then we fall back to the zero level input.

  300	CALL CIOERR ('CIO - read error')
	RETURN
	END

	SUBROUTINE PARCOR(PHI,T)
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES PARTICLE-PARTICLE ANGULAR CORRELATIONS
C  CONVENTIONS OF FINKEL ET.AL.,PHYS.REV.C19(1979)1782 ARE FOLLOWED
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	INCLUDE 'ANGCOR.INC'
	REAL AN1(MAX_EXP),PH1(MAX_EXP),C1(MAX_EXP),EC1(MAX_EXP),
     1  TH1(MAX_EXP)
	COMMON /CROSS/   N1, AN1, PH1, C1,EC1, TH1
	COMMON /FISSION/ KA, KB1, XKA, XKB, XKJ
        REAL TI(INTER_CH),SQRS(INTER_CH-1)
        COMMON /INTCRO/  NCH, TI, SQRS
	DIMENSION PH2(MAX_EXP)
	WRITE(LUNOUT,100)
	IF(ICO(1).EQ.1.OR.ICO(1).EQ.2) THEN
	  LMAX=LDEC(1,1)+1
	  DO 1 J=1,NCH
	  WRITE(LUNOUT,101) J
	  WRITE(LUNOUT,102) DELTA(J,1),DELTA(J,2),DELTA(J,3)
	  DO 1 I=1,NLDEC(J)
	  LMAX=MAX0(LMAX,LDEC(J,I)+1)
1	  CONTINUE
	ENDIF
	IF (N1 .LE. 0 ) GO TO 2
	DO 3 I=1,N1
	PH2(I) = PH1(I)/57.295779
	IF(ICO(1).EQ.3) THEN
	  CALL FISCOR(AN1(I),PH2(I),T,TH1(I))
	ELSE
	  CALL PARP(AN1(I),PH2(I),LMAX,T,TH1(I))
	ENDIF
3	CONTINUE
2	CONTINUE
	IF(ICO(8) .EQ.0) THEN
	  ANGP=-DANGP
	  DO 4 NP=1,NANGP
	  ANGP=ANGP+DANGP
	  IF(ICO(1).EQ.3) THEN
	    CALL FISCOR(ANGP,PHI,T,SIGMA)
	  ELSE
	    CALL PARP(ANGP,PHI,LMAX,T,SIGMA)
	  ENDIF
	  SIG(NP)=SIGMA
4	  CONTINUE
	ENDIF
	RETURN
100	FORMAT(1H ,////,'   PARCOR ENTERED ')
101	FORMAT(1H ,'  INTERMEDIATE STATE =',I3)
102	FORMAT(1H ,' DELTA(1) =',F9.4,'   DELTA(2) =',F9.4,
     1  '   DELTA(3) =',F9.4)
	END

	SUBROUTINE CIOQSH
C++
C TITLE:  CIOQSH
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Show the legal qualifiers
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C PROCEDURES CALLED: none
C CREATION DATE:  13-may-1981
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C	Display the legal qualifiers.
C	Dynamic formatting is used to adapt the nr of qualifiers displayed
C	per line to the length of the qualifiers in characters.
C CALLING SEQUENCE:
C	CALL CIOQSH
C--

	INCLUDE		'ciocom.inc'
	INTEGER		I

	IF (Q_NR.GT.0) WRITE (LUNO,9000) (Q_NAMES(I),I=1,Q_NR)
 9000	FORMAT(T8,'qualifiers ..........',(T30,<50/(QUASIZ+3)>('/',A,:,2X)))
	END

	SUBROUTINE CIOWRT (STRING)
C++
C TITLE:  CIOWRT
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Buffers STRING till a later call to one of the entries
C	in CIOX. The buffered strings will then be displayed by the
C	routine CIOPRM before the prompt specified in the CIOX call.
C	If the CIOX call returns without having prompted for input
C	(since the inputbuffer still contained data) the buffered
C	strings are purged.
C	The use of this procedure is at those places where the amount
C	and the nature of the text to be used as prompt for input,
C	cannot properly be handled by the PROMPT parameter in the
C	various CIO calls. E.g. in the case the prompt text occupies
C	more than one line of text.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C 26-jan-1981 PAK, Replaced call to LUNGET by call to LIB$GET_LUN
C FUNCTIONAL DESCRIPTION:
C	STRING is stored in an internal promptbuffer (PRBUF).
C	If, however, this internal buffer is full, a scratch file
C	is opened and STRING is written to the scratch file.
C	Subsequent calls of this routine also write STRING to this file
C	until CIOX closes the file (with deletion) and purges the
C	internal promptbuffer.
C CALLING SEQUENCE:
C	CALL CIOWRT (STRING)
C INPUT PARAMETERS:
C	STRING	character string to be displayed.
C--
	INCLUDE 'ciocom.inc'
	CHARACTER*(*)	STRING
	INTEGER			STATUS

C Once-only initialize CIO package.
	CALL CIO1ST

C If room in the promptstring buffer (PRBUF) store STRING there.
C Append a @ sign for later truncation of trailing blanks.
	IF (IPBPTR.LT.PRBLEN) THEN
	  IPBPTR = IPBPTR + 1
	  PRBUF(IPBPTR) = STRING // '@'

	ELSE
C If no room in the promptstringbuffer then
C open a scratch file if not already open
	  IF (LUNPRF.EQ.0) THEN
	    CALL CIOLUNGET(LUNPRF, STATUS)	!???g77 status testen
C	    OPEN (UNIT=LUNPRF, NAME='CIO.TM1', TYPE='SCRATCH')
C???g77	    OPEN (UNIT=LUNPRF, NAME='CIO.TM1', DISPOSE='DELETE')
	  ENDIF

C And write the promptstring to the file.

	  WRITE (LUNPRF,9000) STRING
 9000	  FORMAT(A,'@')

	ENDIF

	RETURN
	END

	FUNCTION RK(XL1,XL2,XJ1,XJ2,XK)
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES THE GAMMA RAY MIXING COEFFICIENTS

	N=NINT(1.+XJ1-XJ2+XL2-XL1-XK)
	RK=PAR(N)*SQRT((2.*XJ1+1.)*(2.*XL1+1.)*(2.*XL2+1.))
	RK=RK*CG(XL1,1.D0,XL2,-1.D0,XK,0.D0)*W(XJ1,XJ1,XL1,XL2,XK,XJ2)
	RETURN
	END

	SUBROUTINE CIOCMD (PROMPT,KEYTBL,NKEYS,KEYVAL)
C++
C TITLE:  CIOCMD
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Prompt for and read commandline, extract keyword and decode.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	CIOCMX, CIOERL
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 10-apr-1981 Moved most of the job to CIOCMX.
C FUNCTIONAL DESCRIPTION:
C	Calls CIOCMX to prompt for and accept a command.
C	Procedure repeats in case of erroneous input.
C CALLING SEQUENCE:
C	CALL CIOCMD (PROMPT,KEYTBL,NKEYS,KEYVAL)
C INPUT PARAMETERS:
C	PROMPT	prompt string to be displayed.
C	KEYTBL	character array containing the command repertoire.
C	NKEYS	nr of commands in KEYTBL.
C OUTPUT PARAMETERS:
C	KEYVAL	entry nr of the command in KEYTBL.
C--

	CHARACTER*(*)	PROMPT,KEYTBL(1)

C Let CIOCMX do all the work. Request purge internal inputbuffer.
C Note that the qualifier definition list is not purged since we may
C wish to define qualifiers before a command is prompted for.

    5	CALL CIOCMX (PROMPT,KEYTBL,NKEYS,KEYVAL,'P')
	IF (KEYVAL) 10,20,30
   10	CALL CIOERL ('unknown command')
	GOTO 5
   20	CALL CIOERL ('ambiguous command')
	GOTO 5
   30	RETURN		! Ok. return.
	END

	SUBROUTINE PLM(THET,LPLUS,MPLUS)
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES ASSOCIATED LEGENDRE POLYNOMIALS

	INCLUDE 'ANGCOR.INC'

	THETA=THET /57.295779
	Y=COS(THETA)
	Z=SIN(THETA)
	DO 1 M=1,MPLUS
	LX=M-1
	L2=0
	P3=1.
	FL1=LX
	IF(LX.EQ.0) GO TO 2
	DO 3 LT=1,LX
	FL1=FL1+1.
	P3=P3*FL1*Z/2.0
3	CONTINUE
2	CONTINUE
	P2=0.
	FL2=FL1+1.
	FL3=1.
	DO 4 LT=1,LPLUS
	IF(L2-LX)5,7,6
5	PL(LT,M)=0.
	GO TO 8
6	P3=(FL2*Y*P2-FL1*P1)/FL3
	FL1=FL1+1.
	FL2=FL2+2.
	FL3=FL3+1.
7	PL(LT,M)=P3
	P1=P2
	P2=P3
8	L2=L2+1
4	CONTINUE
1	CONTINUE
	RETURN
	END

	SUBROUTINE DJMK(ANGP,PHI,PSI,IJ,IK,DJ)
	IMPLICIT REAL*8(A-H,O-Z)
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	PARAMETER (MAX_SUBST = 21)	!Number of populated substates; maximum
					!of JB(i)+1 or JTRMAX+1 (JTRMAX is
					!twice maximum transferred angular
					!momentum)
	COMPLEX*16 DJ(MAX_SUBST)

	IF(IJ.EQ.0) THEN
	  DJ(1)=(1.,0.)
	  RETURN
	ENDIF
	THETA=ANGP/114.591558
	Y=COS(THETA)
	Z=SIN(THETA)
	PSIT=-IK*PSI/2.
	JPK=IJ+IK
	JMK=IJ-IK
	LF=IJ+1
	M=-IJ
	DO 1 M21=1,LF
	XD=0.
	IF(ANGP.EQ.0.) THEN
	  IF(M.EQ.IK) XD=1.
	  GO TO 2
	ELSEIF(ANGP.EQ.180.) THEN
	  IF(M.EQ.-IK) XD=PAR((IJ-M)/2)
	  GO TO 2
	ENDIF
	PHIT=-M*PHI/2.
	JPM=IJ+M
	JMM=IJ-M
	IS2=MIN0(IJ-M,IJ+IK)
	IS1=MAX0(0,IK-M)
	IS1=IS1+1
	IS2=IS2+1
	DO 3 IS=IS1,IS2,2
	PHAS=PAR((IS-1)/2)
	I1=JPK-IS+1
	I2=JMM-IS+1
	T=BINOM(JMM/2,(IS-1)/2)*BINOM(JPK/2,(IS-1)/2)
     1  *BINOM(JPM/2,I1/2)*BINOM(JMK/2,I2/2)
	T=PHAS*SQRT(T)
	IT1=(IS-1)+(M-IK)/2
	T=T*(Y**(IJ-IT1))*(Z**IT1)
	XD=XD+T
3	CONTINUE
2	DJ(M21)=XD*DCMPLX(COS(PHIT),SIN(PHIT))*
     1  DCMPLX(COS(PSIT),SIN(PSIT))
	DJ(M21)=DJ(M21)*PAR((IK-M)/2)
	M=M+2
1	CONTINUE
	RETURN
	END

	SUBROUTINE CIOLIT (IP, I1, I2, LQUOTE, *)
C++
C TITLE:  CIOLIT
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Locate next item in current input buffer.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	INDEX, LIB$SCANC, LIB$SPANC
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  30-jan-1981.
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C	The next item from the input buffer is located.
C	If the inputbuffer is empty, alternate return 1 is taken.
C	The item is assumed to begin at the first non-separator
C	character after the current position indicated by IP.
C	The item ends at the detection of a separator
C	or at the end of the inputbuffer.
C	An item may be enclosed in single or double quotes if it
C	contains embedded blanks or one of the special characters
C	In case of a quoted item LQUOTE is returned as .true..
C CALLING SEQUENCE: (only for internal use by CIO)
C	CALL CIOLIT (IP, I1, I2, LQUOTE, *)
C INPUT PARAMETERS:
C	IP	position in INBUF where search should start.
C OUTPUT PARAMETERS:
C	IP	position in INBUF where search ended.
C	I1, I2	indicate position in INBUF where the extracted item
C		is located (thus at INBUF(I1:I2))
C	LQUOTE	logical returned true if the item was quoted.
C ALTERNATE RETURNS:
C	1	buffer empty, no more items can be extracted.
C--

	INCLUDE 'ciocom.inc'

	INTEGER		IP, I1, I2, K
	LOGICAL		LQUOTE
	CHARACTER*1	DELIM

C External functions

	INTEGER LIB__SPANC
	INTEGER LIB__SCANC

C See if anything left in buffer

C      write (*,*) '?????? ciolit called IP, INBUFC', ip, inbufc
	IF (IP.GE.INBUFC) RETURN 1		! Buffer exhausted
	IP = IP + 1

C Skip over separators till the 1st non-separator.
C Take alternate return if only data left is separators.

C      write (*,*) '?????? ciolit before spanc'
	K = LIB__SPANC(INBUF(IP:INBUFC),C_TABLE,C_SEPA)	! Skip over all
	IF (K.EQ.0) THEN	! characters in the group of separators.
	  IP = INBUFC
	  RETURN 1
	ENDIF

C We are at the 1st character of an item. See if quoted or unquoted.

	I1 = IP + K - 1	! Point to 1st char of item.
	DELIM = INBUF(I1:I1)			! Get possible delimiter.
	LQUOTE = INDEX(S_DELM, DELIM) .NE. 0	! See if quoted item.

C Quoted item. Extract it.
C Item ends at the next occurance of the same delimiter.

	IF (LQUOTE) THEN	! Item is quoted.
	  I1 = I1 + 1		! Skip over 1st quote
	  K = INDEX (INBUF(I1:INBUFC), DELIM)	! Search 2nd.
	  IF (K.NE.0) THEN
	    I2 = K + I1 - 2	! Found, I2 is last char before quote.
	    IP = K + I1 - 1	! Update bufferpointer to 2nd quote.
	  ELSE
	    I2 = INBUFC		! Not found, assume EOL is delimiter
	    IP = INBUFC		! Update bufferpointer to EOL.
	  ENDIF

C Unquoted item. Extract it.
C Item ends at a separator or at the start of a qualifier.

	ELSE			! Item is unquoted.
				! Scan for a character in the group of
				! separators or qualifier-prefix(es).
	  K = LIB__SCANC (INBUF(I1+1:INBUFC), C_TABLE, C_SEPA+C_QUAL)
	  IF (K.NE.0) THEN
	    I2 = K + I1 - 1	! Found.
	  ELSE
	    I2 = INBUFC		! Not found. Assume EOL is separator.
	  ENDIF
	  IP = I2		! Update bufferpointer to end of item.
	ENDIF

C Item located in INBUF(I1:I2). Return substring limits to caller.
C IP pointer points at last character of item, or to the terminating quote
C of a quoted item.
C Note that quoted items may have a length of zero !!

	RETURN
	END

	SUBROUTINE CIOMOD
C++
C TITLE:  CIOMOD
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Determines whether the devices assigned to SYS$INPUT
C 	and SYS$OUTPUT are interactive terminals or not.
C ENVIRONMENT: VAX/VMS specific. Calls VMS system services.
C PROCEDURES CALLED:
C	SYS$GETDVIW
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK  3-jan-1983 Changed EXTERNAL's for SSDEF and IODEF to INCLUDES.
C PAK 22-feb-1984 Changed to use $GETDVI.
C FUNCTIONAL DESCRIPTION:
C	The characteristics of SYS$INPUT and SYS$OUTPUT are obtained
C	by calling SYS$GETDVIW and MODI and MODO are set accordingly.
C CALLING SEQUENCE:
C	CALL CIOMOD
C OUTPUT PARAMETERS:
C	MODI	type of device assigned to SYS$INPUT / STDIN
C	MODE	type of device assigned to SYS$OUTPUT / STDOUT
C	One of the follwing values is returned: 0 if the device is
C	a terminal, 1 if the device is not a terminal.
C--


	INCLUDE		'ciocom.inc'

	INTRINSIC	IsaTty

	if (IsaTty (LUNIDF)) then
		MODI = 0
	else
		MODI = 1
	endif

	if (IsaTty (LUNODF)) then
		MODO = 0
	else
		MODO = 1
	endif

D	WRITE (*,*) 'MODI=',MODI,' MODO=',MODO
	RETURN
	END

	SUBROUTINE CIOCMX (PROMPT,KEYTBL,NKEYS,KEYVAL,SPECST,*,*,*,*)
C++
C TITLE:  CIOCMX
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Prompt for and read commandline, extract keyword and decode.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	CIODSS	to decode specification string
C	CIOGIT	to get the next item in the internal inputbuffer.
C	CIOLUP	to lookup a command in a commandtable.
C	CIOERL	to display error message and incurring line.
C	CIOHLP	to offer on-line help.
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  10-apr-1981
C MODIFIED BY:
C PAK 19-feb-1984 In dynamic FORMAT labelled 9030 moved a call to LEN outside
C	the FORMAT statement. Caused a compiler crash with FORTRAN V4.0
C FUNCTIONAL DESCRIPTION:
C	CIOPRM is called to prompt for a command and read a commandline.
C	The first item in the line is assumed to be a keyword and is
C	looked up in a keyword table (KEYTBL (1...NKEYS)) through a
C	call to the procedure CIOLUP. If the command is found its
C	entrynumber in the table (KEYVAL).
C CALLING SEQUENCE:
C	CALL CIOCMX (PROMPT,KEYTBL,NKEYS,KEYVAL,SPECST [,alternate returns])
C INPUT PARAMETERS:
C	PROMPT	prompt string to be displayed.
C	KEYTBL	character array containing the command repertoire.
C	NKEYS	nr of commands in KEYTBL.
C	SPECST	specification string.
C OUTPUT PARAMETERS:
C	KEYVAL	receives entrynumber of the command in KEYTBL, or
C		0 if the command is ambigious, or
C		-1 if the command is not in KEYTBL, or
C		-2 if '=' was entered, or
C		-3 if '*' was entered.
C ALTERNATE RETURNS:
C	1 to 4 alternate returns, their number and sequence depending on
C	the precense of flow control characters in SPECST.
C	If any of the specified flow-control characters is entered,
C	the corresponding alternate return is taken.
C--

	INCLUDE 'ciocom.inc'
	CHARACTER*(*)	PROMPT,KEYTBL(1),SPECST
	INTEGER			NKEYS, KEYVAL
	CHARACTER*(80) 	DYNFMT
	INTEGER			I, K
	INTEGER			KRETUR
	INTEGER			STATUS

C Decode the specification string.
C Note that if the string contains a 'P' this will purge the internal
C input buffer.

	CALL CIODSS (SPECST)

C Prompt for a command line.
C Then extract the first item in the buffer, and call the
C command-table lookup routine.

   10	CALL CIOGIT (PROMPT,CWORK,K, *22, *23, *30, *100)
C				      =    *    ?   flow
	CALL CIOLUP (CWORK(:K),KEYTBL,NKEYS,KEYVAL)
	GOTO 700

C The item extracted is one of the special CIO characters '=' or '*'.
C Return a negative value which will normally be treated as a command
C that could not be found in the table.

   22	KEYVAL = -2			! = character
	GOTO 700
   23	KEYVAL = -3			! * character
	GOTO 700

C Come here if extracted item happens to be the 'show-current-value'
C symbol. In this procedure we act on it by showing the command
C repertoire, followed by the list of defined qualifiers.

C Dynamic formatting is used to adapt the nr of command displayed
C per line to the length of the commands in characters.
C ???g77 to be tested

   30	K = LEN(KEYTBL(1))
	WRITE (DYNFMT, 9030) 50/(K+2)
 9030 FORMAT (':,T8,''Commands ............'',(T30,',I2,'(A,:,2X)')
 	WRITE (LUNO,DYNFMT) (KEYTBL(I),I=1,NKEYS)

C 9030	FORMAT(:,T8,'Commands ............',(T30,<50/(K+2)>(A,:,2X)))

	CALL CIOQSH			! show defined qualifiers.
	WRITE (LUNO,'(1X)')		! terminate with blank line.
	GOTO 10

C CIO flow control character entered.
C See if alternate return has been specified for this control
C character. If so, take that return. If not complain, and
C invalidate input buffer and alternate files.

  100	I = INDEX (S_FLOW, CWORK(1:1))
	IF (KSPCTL(I).EQ.0) THEN
	  CALL CIOERL('you can''t go that way')
	  GOTO 10
	ELSE
	  KRETUR = KSPCTL(I)
	  GOTO 710
	ENDIF

C Come here just before returning to the caller in order to purge
C the internal promptbuffer, delete the possibly open prompt-
C scratchfile, and deallocate the corresponding logical unit number.
  700	KRETUR = 0
C Code for alternate returns caused by flow-control-char's joins here.
  710	IPBPTR = 0
	IF (LUNPRF .NE. 0) THEN
	  CLOSE (UNIT = LUNPRF)
	  CALL CIOLUNFREE (LUNPRF, STATUS) ! ???G77 status testen
	  LUNPRF = 0
	ENDIF
	RETURN KRETUR

	END

	SUBROUTINE PARDEC(XMB,XMC,XMS,NCH,PHI,A)
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES PARTICLE DECAY ANGULAR DISTRIBUTION RESULTING FROM AN
C  INTERMEDIATE M-POPULATION
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	INCLUDE 'ANGCOR.INC'
	COMPLEX*16 A,C

	XMJ=XMB-XMC
	XML=XMJ-XMS
	ML=NINT(XML)
	A=(0.,0.)
	DO 1 I=1,NLDEC(NCH)
	IF(DELTA(NCH,I).EQ.0.) GO TO 1
	L=LDEC(NCH,I)
	XL=L
	XJ=FLOAT(JDEC(NCH,I))/2.
	IF (ABS(XMJ).GT.XJ.OR.ABS(XML).GT.XL) GO TO 1
	A=A+DELTA(NCH,I)*CG(XL,XML,XS,XMS,XJ,XMJ)*CG(XJ,XMJ,XJC,XMC,
     1    XJB(NCH),XMB)*C(L,ML,PHI)*SQRT(DFLOAT(2*L+1))/3.5449077

C  THE ABOVE NORMALIZATION ENSURES THAT THE INTEGRATED ANGULAR
C  DISTRIBUTION OVER THETA AND PHI IS UNITY.

1	CONTINUE
	RETURN
	END

C++
C TITLE: CIOQENTRY
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Store a qualifier name in the qualifier table and set
C	Q_NR to the entry's index.
C PROCEDURES CALLED:
C	CIOMSG
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE: 21-sep-2006
C MODIFIED BY:
C--


	SUBROUTINE CIOQENTRY (QUALNAME)

	INCLUDE		'ciocom.inc'
	CHARACTER*(*)	QUALNAME
	INTEGER			K

	! Once only initialize

	CALL CIO1ST

	! If qualifier already defined before, redefine it,
	! otherwise add it. Abort if qualifier table full.

	DO K = 1, Q_NR
		IF (Q_NAMES(K).EQ.QUALNAME) GOTO 100	! found, redefine
	ENDDO

	! Qualifier not found, add it.
	K = Q_NR + 1
	IF (K.GT.QUAMAX) CALL CIOMSG (1, 'too many qualifiers defined')

	! Store qualifier string and pointer to associated variable
	! set global Q_NR to the qualifier index
  100	Q_NAMES (K) = QUALNAME
	Q_NR = K
	END

C++
C ENTRY: CIOQL, CIOQLX
C ABSTRACT: Define a qualifier of type /[NO]QUALIFIER
C FUNCTIONAL DESCRIPTION:
C CALLING SEQUENCE:
C	CALL CIOQL ( QUALNAME, IQUAL)
C	CALL CIOQLX (QUALNAME, IQUAL, IYES, INO)
C INPUTS:
C	QUALNAME	qualifier string
C
C	Following input arguments must either all be present or all be omitted.
C	If they are omitted they default to .true. and .false. respectively
C	and IQUAL is initialized to .true..
C	If they are present, IQUAL is initially not affected.
C
C	IYES	the value assigned to IQUAL if the positive form of the
C			qualifier is encountered in any input to CIO.
C	INO		the value assigned to IQUAL if the negative form of the
C			qualifier is encountered in any input to CIO.
C OUTPUTS:
C	IQUAL	the associated variable which receives the value of IYES or
C			INO on the occurance of respectively the positive or the
C			negative form of the qualifier.
C			IQUAL is initialized to .false. only if the IYES and INO
C			arguments are omitted.
C COMMENT:
C	IYES, INO and IQUAL may be of type LOGICAL, INTEGER or REAL,
C	however, they must be all of the same type.
C	However, this relies on the fact that these types have the same
C	size in memory, and that the compiler accepts that different
C	calls to the same function may have different argument types.
C--

	SUBROUTINE	CIOQL  (QUALNAME, LQUAL)

	INCLUDE		'ciocom.inc'

	CHARACTER*(*)	QUALNAME
	LOGICAL*4		LQUAL, LYES, LNO
	LOGICAL			XCALL

	XCALL = .false.
	GOTO 50

	ENTRY	CIOQLX (QUALNAME, LQUAL, LYES, LNO)

	XCALL = .true.
	GOTO 50

	! Store qualifier name or lookup if already defined
   50	CALL CIOQENTRY (QUALNAME)

  	Q_DATATYPE (Q_NR) = 1							! logical qualifier i.e. /QUAL or /NOQUAL form
	Q_XCALL    (Q_NR) = XCALL
	Q_PTR_DEST (Q_NR) = %LOC (LQUAL)

	IF (.NOT.XCALL) THEN					! if only 2 arguments specified
	  Q_L_YESVALUE (Q_NR) = .true.			! store .true. as yes-value
	  Q_L_NOVALUE  (Q_NR) = .false.		! store .false. as no-value.
	  LQUAL = .false.						! and init assoc.var. to false.
	ELSE									! if all arguments specified
	  Q_L_YESVALUE (Q_NR) = LYES 				! store yes-value
	  Q_L_NOVALUE  (Q_NR) = LNO  				! store no-value.
	ENDIF

  	RETURN
	END

C++
C ENTRY: CIOQI, CIOQIX
C ABSTRACT: Define a qualifier of type /QUALIFIER[=integer value]
C FUNCTIONAL DESCRIPTION:
C CALLING SEQUENCE:
C	CALL CIOQI ( QUALNAME, IQUAL ,ILOLIM, IHILIM)
C	CALL CIOQIX (QUALNAME, IQUAL ,ILOLIM, IHILIM, IDEF)
C INPUTS:
C	QUALNAME	qualifier string
C	ILOLIM		inclusive lower limit for the value assigned to the qualifier.
C	IHILIM		inclusive upper limit for the value assigned to the qualifier.
C				NOTE: these limits are checked only if ILOLIM .ne. IHILIM.
C
C	IDEFAULT	optional argument specifying a default value to be assigned
C				to IQUAL if the qualifier is encountered without a value
C				assigned to it (i.e. the form /QUALIFIER).
C				If omitted, a value must be assigned to the qualifier
C				i.e. only the form /QUALIFIER=integer is allowed.
C OUTPUTS:
C	IQUAL		the associated variable which receives the value assigned
C				to the qualifier, or the value of IDEFAULT in case the form
C				/QUALIFIER is encountered.
C--

	SUBROUTINE	CIOQI  (QUALNAME, IQUAL, ILOLIM, IHILIM)

	INCLUDE		'ciocom.inc'
	CHARACTER*(*)	QUALNAME
	INTEGER			IQUAL, ILOLIM, IHILIM, IDEFAULT
	LOGICAL			XCALL

	XCALL = .false.
	GOTO 50

	ENTRY	CIOQIX (QUALNAME, IQUAL, ILOLIM, IHILIM, IDEFAULT)
	XCALL = .true.
	GOTO 50

	! Store qualifier name or lookup if already defined
   50 CALL CIOQENTRY (QUALNAME)

	! Store address of the associated variable and its type.
  	Q_DATATYPE (Q_NR) = 2							! /QUALIFIER=integer
	Q_XCALL    (Q_NR) = XCALL
	Q_PTR_DEST (Q_NR) = %LOC (IQUAL)
	Q_I_LOLIM  (Q_NR) = ILOLIM
	Q_I_HILIM  (Q_NR) = IHILIM

	! If default is specified, store its value
	IF (XCALL) Q_I_DEFAULT (Q_NR) = IDEFAULT

  	RETURN
	END


C++
C ENTRY: CIOQF, CIOQFX
C ABSTRACT: Define a qualifier of type /QUALIFIER[=real value]
C FUNCTIONAL DESCRIPTION:
C CALLING SEQUENCE:
C	CALL CIOQF  (QUALNAME, AQUAL, ALOLIM, AHILIM)
C	CALL CIOQFX (QUALNAME, AQUAL, ALOLIM, AHILIM, ADEFAULT
C	arguments have a meaning similar to entry CIOQI.
C--

	SUBROUTINE	CIOQF (QUALNAME, AQUAL, ALOLIM, AHILIM)

	INCLUDE		'ciocom.inc'
	CHARACTER*(*)	QUALNAME
	REAL			AQUAL, ALOLIM, AHILIM, ADEFAULT
	LOGICAL			XCALL

	XCALL = .false.
	GOTO 50

	ENTRY	CIOQFX (QUALNAME, AQUAL, ALOLIM, AHILIM, ADEFAULT)
	XCALL = .true.
	GOTO 50

	! Store qualifier name or lookup if already defined
   50	CALL CIOQENTRY (QUALNAME)

  	Q_DATATYPE (Q_NR) = 3			! /QUALIFIER=real
	Q_XCALL    (Q_NR) = XCALL
	Q_PTR_DEST (Q_NR) = %LOC (AQUAL)
	Q_F_LOLIM  (Q_NR) = ALOLIM
	Q_F_HILIM  (Q_NR) = AHILIM

	! If default is specified, store its value
	IF (XCALL) Q_F_DEFAULT (Q_NR) = ADEFAULT

  	RETURN
	END

C++
C ENTRY: CIOQS
C ABSTRACT: Define a qualifier of type /QUALIFIER[=string]
C FUNCTIONAL DESCRIPTION:
C CALLING SEQUENCE:
C	CALL CIOQS  (QUALNAME, LENQUAL, SQUAL)
C	CALL CIOQSX (QUALNAME, LENQUAL, SQUAL, IFLAG)
C INPUTS:
C	QUALNAME	qualifier string
C OUTPUTS:
C	LENSQUAL	integer variable which, on occurance of the qualifier,
C				receives the length of the string assigned to SQUAL.
C	SQUAL		string variable which, on occurance of the qualifier,
C				receives the string assigned to SQUAL.
C	IFLAG		optional argument receiving an indication of the format
C				in which the qualifier was entered:
C				-1 if the qualifier was not encountered,
C				 0 if the /QUALIFIER form was encountered,
C				+1 if the /QUALIFIER=string form was encountered.
C				If omitted, a string must be assigned to the qualifier
C				i.e. only the form /QUALIFIER=string is allowed.
C				Note that if IFLAG = -1 or 0 the contents of SQUAL and
C				LENSQUAL are unaffected.
C--

	SUBROUTINE	CIOQS  (QUALNAME, LENSQUAL, SQUAL)

	INCLUDE		'ciocom.inc'
	CHARACTER*(*)	QUALNAME, SQUAL
	INTEGER			LENSQUAL, IFLAG
	LOGICAL			XCALL

	XCALL = .false.
	GOTO 50

	ENTRY	CIOQSX (QUALNAME, LENSQUAL, SQUAL, IFLAG)
	XCALL = .true.
	GOTO 50

	! Store qualifier name or lookup if already defined
   50	CALL CIOQENTRY (QUALNAME)

  	Q_DATATYPE (Q_NR) = 4			! /QUALIFIER=string
	Q_XCALL    (Q_NR) = XCALL
      Q_PTR_DEST (Q_NR) = %LOC (SQUAL)
      Q_PTR_LEN  (Q_NR) = %LOC (LENSQUAL)

	! If all arguments given set format flag to 'qualifier not specified'.
	! and store pointer to format indicator.

	IF (XCALL) THEN
	  IFLAG = -1
	  Q_PTR_FLAG (Q_NR) = %LOC(IFLAG)
	ENDIF

  	RETURN
	END

	SUBROUTINE CIOHLP
C++
C TITLE:  CIOHLP
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Procedure to give on-line help, using the
C		VMS help library facility.
C ENVIRONMENT:  FORTRAN-77. VMS V3.0 or higher
C PROCEDURES CALLED:
C	LBR$OUTPUT_HELP, LIB__GET_INPUT, LIB__PUT_OUTPUT
C	Condition handler: CIOHLPHAN
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  31-jan-1981.
C MODIFIED BY:
C PAK 16-mrt-1981 changed so that both a single help library as well as
C	a multi-module help library can be used.
C PAK 02-oct-1982 Use LBR$OUTPUT_HELP, available in VMS V3.0, which
C	makes this routine much easier.
C PAK 28-dec-1982 Increase size of LIBNAME to 80 char.
C FUNCTIONAL DESCRIPTION:
C	Before the 1st call to CIOHLP, CIOHLPINI must be called with the
C	specification of the helplibrary to be consulted, and, if more
C	programs share the same helplibrary, the name of the module in the
C	library containing the required help (usually the program name).
C ENTRIES: CIOHLP, CIOHLPINI
C CALLING SEQUENCE:
C	CALL CIOHLP
C	  to get on-line help.
C	CALL CIOHLPINI (library-filespecification, module_name)
C	  to specify the library and optionally the module to be consulted.
C	  If the library is a single program help library, the second argument
C	  must be a blank string.
C	  Note: If CIOHLPINI is not called, the default VMS helplibrary
C	  will be consulted.
C--

C Not implemented for this non-VMS version but their entries are
C preserved in order not to break existing code.

	INCLUDE 'ciocom.inc'
	CHARACTER*(*)	LIB, MOD		! Arguments for CIOHLPINI

C Just purges the CIO internal buffers and outputs a rudimentary
C message.

	CALL CIOPUR				! Purge CIO's internal buffer

	WRITE (LUNO,9100)
 9100	FORMAT(1X,T56,'...HELP function is not implemented...',/)

	RETURN

C -------------------------------------------------------------------
	ENTRY CIOHLPINI (LIB, MOD)
C -------------------------------------------------------------------

	END

	CHARACTER*3 FUNCTION CIOYNL (L)
C++
C TITLE:  CIOYNL
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Character function which returns the string 'YES' or 'NO'
C	corresponding to the value of its logical argument.
C ENVIRONMENT:  FORTRAN-77.
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C CALLING SEQUENCE:
C	STRING =  CIOYNL (L)
C INPUT PARAMETERS:
C	L	logical to be converted to a 'YES' or 'NO' string.
C--

	LOGICAL	L
	IF (L) THEN
	  CIOYNL = 'YES'
	ELSE
	  CIOYNL = 'NO'
	ENDIF
	RETURN
	END

	SUBROUTINE SIGMA(ANGP,PHI,KL,SIG1)
	IMPLICIT REAL*8(A-H,O-Z)

	INCLUDE 'ANGCOR.INC'
	COMMON /EXTRA/   ZW(MAX_LG), RKK(MAX_LG)

	COMPLEX*16 C
	SIG1=0.
	CALL PLM(ANGP,KL,KL)
	KK=-2
	XK=-2.
	DO 1 K=1,KL,2
	KK=KK+2
	XK=XK+2.
	IQ=2*K-1
	DO 1 KQ=1,IQ
	MQ=KQ-K
	KMQ=KK*KK+KK+MQ+1
	IF (KK.EQ.0) THEN
	  SIG1 = SIG1 + RHO(KMQ)*C(KK,MQ,PHI)
	ELSE
	  SIG1 = SIG1 +RHO(KMQ)*C(KK,MQ,PHI)*RKK(KK/2)*ZW(KK/2)
	ENDIF

1	CONTINUE
	RETURN
	END

	SUBROUTINE PLOT
	IMPLICIT REAL*8(A-H,O-Z)
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	INCLUDE 'ANGCOR.INC'

	DIMENSION ARRAY(26),STAR(4),STAR0(4),STAR1(4),STAR2(4)
	DATA BAR,BLNK,AXIS,PLUS,PLAX/4H|   ,4H    ,4H----,4H+   ,4H+---/
	DATA STAR /4H*   ,4H *  ,4H  * ,4H   */
	DATA STAR0/4H*---,4H-*--,4H--*-,4H---*/
	DATA STAR1/4H*   ,4H|*  ,4H| * ,4H|  */
	DATA STAR2/4H*---,4H+*--,4H+-*-,4H+--*/
	DATA ARRAY/26*4H    /
	N=0
	NN1=1
	IF(NPLOT.EQ.0)NPLOT=1
	DO 1 I=1,NANGP
	ISIG=SIG(I)+1.
1	NN1=MAX0(NN1,ISIG)
	NN1=NN1*NPLOT
	WRITE(LUNOUT,100) N,NN1
	B = 0.
	BASE = 0.
	IWORD=1
	XN=100./DFLOAT(NN1)
	DO 2 I=1,NANGP
	IF (I.EQ.1.OR.I.EQ.NANGP) THEN
	  ARRAY(1)=PLAX
	  ARRAY(26)=PLUS
	  DO 3 K=2,25
3	  ARRAY(K) = AXIS
	ELSE
	  ARRAY(1)=BAR
	  ARRAY(26)=BAR
	ENDIF
	IF( SIG(I).LT.BASE )  GO TO 4
	ARG = XN*SIG(I)
	J = NINT(ARG)
	IWORD=J/4 + 1
	IKAR=J - 4*(IWORD-1)
	IF (I.EQ.1.OR.I.EQ.NANGP) THEN
	  IF (IWORD.NE.1) THEN
	    ARRAY(IWORD)=STAR0(IKAR+1)
	  ELSE
	    ARRAY(1)=STAR2(IKAR+1)
	  ENDIF
	ELSE
	  IF(IWORD.NE.1) THEN
	    ARRAY(IWORD)=STAR(IKAR+1)
	  ELSE
	    ARRAY(1)=STAR1(IKAR+1)
	  ENDIF
	ENDIF
4	CONTINUE
	WRITE(LUNOUT,101) B,SIG(I),ARRAY
	ARRAY(IWORD)=BLNK
	IF(I.EQ.1) THEN
	  DO 5 K=2,25
5	  ARRAY(K)=BLNK
	ENDIF
	B = B + DANGP
2	CONTINUE
	RETURN

C  STAR (*) CARRIAGE CONTROL PRINTS OVER PAGE EDGE.

100	FORMAT(1H0,21X,4X,I3,97X,I3/4X,5HTHETA,6X,
     1  11HPROBABILITY,2X,1HI,99X,1HI)
101	FORMAT(1H*,F9.4,E14.4,4X,26A4)
	END

C ??? tbs


	SUBROUTINE CIO_COPY_I (SRC, DST)
	IMPLICIT NONE
	INTEGER SRC, DST
	DST = SRC
	END

	SUBROUTINE CIO_COPY_F (SRC, DST)
	IMPLICIT NONE
	REAL*4 SRC, DST
	DST = SRC
	END

	SUBROUTINE CIO_COPY_D (SRC, DST)
	IMPLICIT NONE
	REAL*8 SRC, DST
	DST = SRC
	END

	SUBROUTINE CIO_COPY_L (SRC, DST)
	IMPLICIT NONE
	LOGICAL SRC, DST
	DST = SRC
	END

	SUBROUTINE CIO_COPY_B (SRC, DST)
	IMPLICIT NONE
	LOGICAL*1 SRC, DST
	DST = SRC
	END

	SUBROUTINE CIO_COPY_S (SRC, SRCLEN, DST)
	IMPLICIT NONE
	INTEGER*1     SRC(*)	! passed by reference
	CHARACTER*(*) DST		! passed by descriptor ???
	INTEGER SRCLEN

	INTEGER K

	DO K = 1, LEN(DST)
		IF (K.LE.SRCLEN) THEN
			DST(K:K) = CHAR(SRC(K))
		ELSE
			DST(K:K) = ' '
		ENDIF
	ENDDO
	END

C++
C TITLE:  CIOLUNGET
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Allocate a LUN from the LUN pool
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	none
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  26-sep-2006
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C	Returns a free LUN from the LUN pool an marks that LUN as used.
C CALLING SEQUENCE:
C	CALL CIOLUNGET (LUN, STATUS)
C INPUT PARAMETERS:
C	none
C OUTPUT PARAMETERS:
C	LUN		integer receiving the allocated LUN.
C	STATUS	integer receiving status:
C			1 = LUN succesfully allocated
C			0 = no more LUNs available in pool
C--

	SUBROUTINE CIOLUNGET (LUN, STATUS)

	INCLUDE 'ciocom.inc'
	INTEGER LUN, STATUS
	INTEGER K

	DO K = LUNPOOLMIN, LUNPOOLMAX
		IF (.not.LUNPOOL(K)) THEN
			LUN = K
			STATUS = 1
			RETURN
		ENDIF
	END DO
	STATUS = 0	! no free lun found
	RETURN
	END

C++
C TITLE:  CIOLUNFREE
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Return a LUN to the LUN pool
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	none
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  26-sep-2006
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C	Returns a free LUN from the LUN pool an marks that LUN as used.
C CALLING SEQUENCE:
C	CALL CIOLUNFREE (LUN, STATUS)
C INPUT PARAMETERS:
C	LUN		integer containing the LUN to be freed.
C OUTPUT PARAMETERS:
C	STATUS	integer receiving status:
C			1 = LUN succesfully freed.
C			0 = LUN was already free, or LUN out of allowable range.
C--

	SUBROUTINE CIOLUNFREE (LUN, STATUS)

	INCLUDE 'ciocom.inc'
	INTEGER LUN, STATUS
	INTEGER K

	STATUS = 0	! assume failure
	IF (LUN.lt.LUNPOOLMIN .OR. LUN.GT.LUNPOOLMAX) RETURN
	IF (.NOT.LUNPOOL(LUN)) RETURN ! was already free
	LUNPOOL(LUN) = .FALSE.								! make it free
	STATUS = 1											! and return success
	RETURN
	END

	SUBROUTINE CIOTBE (LEMPTY)
C++
C TITLE:  CIOTBE
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Test if internal input buffer empty.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED: LIB__PANC
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  30-jan-1981.
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C CALLING SEQUENCE:
C	CALL CIOTBE (LEMPTY)
C OUTPUTS:
C	LEMPTY	logical, returned .true. if buffer empty and
C		no continuation symbol specified.
C--

	INCLUDE 'ciocom.inc'

C External functions

	INTEGER LIB__SPANC

	LOGICAL LEMPTY

C First complete scan for qualifiers. Otherwise possible qualifiers
C remaining on the line will indicate a non-empty buffer although
C the only items left are qualifiers.

	CALL CIOQCO

C Then set empty switch if all of the following is true:
C	- the line doesn't end on a continuation character,
C	- the pointer has not yet reached the end of the line or
C	  the comment field
C	- the only characters left are separators.

	LEMPTY =
	1 .not. LCONTIN .and.
	1 (INPTR.GE.INBUFC .or.
	1 LIB__SPANC(INBUF(INPTR+1:INBUFC), C_TABLE, C_SEPA) .eq. 0)	!???2006
	RETURN
	END

	SUBROUTINE GAMCOR(ANG,PHI)
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES PARTICLE-GAMMA ANGULAR CORRELATIONS
C  CONVENTIONS OF:1)RYBICKI ET.AL.,NUCL.PHYS.A146(1970)659
C		  2)ROSE AND BRINK,REV.OF MODERN PHYS. 39(1967)306
C  ARE FOLLOWED FOR THIS AND CONNECTED SUBROUTINES
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	INCLUDE 'ANGCOR.INC'
	COMMON /CASCADE/ LBC, LCD, JD2, LDE, JE2, NC, ARCDEL, ARCDELC,
     1 	ARCDELD
	REAL AN1(MAX_EXP),PH1(MAX_EXP),C1(MAX_EXP),EC1(MAX_EXP),
     1  TH1(MAX_EXP)
	COMMON /CROSS/   N1, AN1, PH1, C1,EC1, TH1
	COMMON /EXTRA/   ZW(MAX_LG), RKK(MAX_LG)
	DIMENSION RR(3,2*MAX_LG), UKB(MAX_LDEC,MAX_LG), RRC(3,2*MAX_LG),
     1  UKC1(MAX_LG), UKC2(MAX_LG), RRD(3,2*MAX_LG)
	DIMENSION PH2(MAX_EXP), TH2(MAX_EXP)	

	WRITE(LUNOUT,100)
	IF(ICO(1).EQ.0) THEN
	  KB = 2*LBC + 3
	  XLBC = FLOAT(LBC)
	  KL=MIN0(LF2(1),KB)
	ENDIF
	IF (NC.EQ.1) GO TO 1
	KC = 2*LCD + 3
	XLCD = FLOAT(LCD)
	XJD = FLOAT(JD2)/2.0
	KL=MIN0(LF2(1),LF3,KC)
	IF (NC.EQ.2) GO TO 1
	KD = 2*LDE + 3
	XLDE = FLOAT(LDE)
	XJE = FLOAT(JE2)/2.0
	KL=MIN0(LF2(1),LF3,JD2+1,KD)
1	CONTINUE
	KM = KL - 1
	CALL RHOKQ(KL)
	DO 2 K= 2, KM, 2
	XK = FLOAT(K)
	IF(ICO(1).EQ.0) THEN
	  RR(1,K) = RK(XLBC   ,XLBC   ,XJB(1),XJC,XK)
	  RR(2,K) = RK(XLBC   ,XLBC+1.,XJB(1),XJC,XK)
	  RR(3,K) = RK(XLBC+1.,XLBC+1.,XJB(1),XJC,XK)
	  IF(NC.EQ.1) GO TO 2
	  GO TO 3
	ELSE
	  DO 4 J=1,NLDEC(1)
	  UKB(J,K/2)=UK(XK,XJB(1),XJC,DFLOAT(JDEC(1,J))/2.)
4	  CONTINUE
	  GO TO 5
	ENDIF
3	UKB(1,K/2) =UK(XK,XJB(1),XJC,XLBC)
	UKB(2,K/2) = UK(XK,XJB(1),XJC,XLBC+1.)
5	RRC(1,K) = RK(XLCD   ,XLCD   ,XJC,XJD,XK)
	RRC(2,K) = RK(XLCD   ,XLCD+1.,XJC,XJD,XK)
	RRC(3,K) = RK(XLCD+1.,XLCD+1.,XJC,XJD,XK)
	IF(NC .EQ.2) GO TO 2
	UKC1(K/2) = UK(XK,XJC,XJD,XLCD)
	UKC2(K/2) = UK(XK,XJC,XJD,XLCD+1.)
	RRD(1,K) = RK(XLDE   ,XLDE   ,XJD,XJE,XK)
	RRD(2,K) = RK(XLDE   ,XLDE+1.,XJD,XJE,XK)
	RRD(3,K) = RK(XLDE+1.,XLDE+1.,XJD,XJE,XK)
2	CONTINUE
	T=RHO(1)
	V=57.29578
	IF(ICO(1).EQ.0) THEN
	  Z1 = ARCDEL/V
	  DEL = SIN(Z1)/COS(Z1)
	  D2=DEL*DEL
	ENDIF
	IF(NC.GT.1) THEN
	  Z1 = ARCDELC/V
	  DELC = SIN(Z1)/COS(Z1)
	  D2C = DELC*DELC
	  IF(NC.GT.2) THEN
	    Z1 = ARCDELD/V
	    DELD = SIN(Z1)/COS(Z1)
	    D2D = DELD*DELD
	  ENDIF
	ENDIF
	IF(ICO(8).EQ.0) THEN
	  IF(ICO(1).EQ.2) THEN
	    WRITE(LUNOUT,101)DELTA(1,1),DELTA(1,2),DELTA(1,3)
	  ELSE
	    WRITE(LUNOUT,102) DEL,ARCDEL
	  ENDIF
	  IF(NC.GT.1) THEN
	    WRITE(LUNOUT,103) DELC,ARCDELC
	    IF(NC.GT.2) WRITE(LUNOUT,104) DELD,ARCDELD
	  ENDIF
	ENDIF
	DO 6 K=2,KM,2
	IF(ICO(1).EQ.0) THEN
	  RKK(K/2)=(RR(1,K) + 2.0*DEL*RR(2,K) + D2*RR(3,K)) / (1.+D2)
	  IF(NC.EQ.1) GO TO 7
	  UBC =(UKB(1,K/2) + D2 * UKB(2,K/2))/( 1. + D2 )
	ELSE
	  UBC=0.
	  TOTD=0.
	  DO 8 J=1,NLDEC(1)
	  D2=DELTA(1,J)*DELTA(1,J)
	  TOTD=TOTD+D2
	  UBC=UBC+UKB(J,K/2)*D2
8	  CONTINUE
	  UBC=UBC/TOTD
	ENDIF
	RKK(K/2)=UBC*(RRC(1,K)+2.0*DELC*RRC(2,K)+D2C*RRC(3,K))/(1.+D2C)
	IF(NC.EQ.2) GO TO 7
	UCD =  (UKC1(K/2) + D2C * UKC2(K/2)) / (1. + D2C)
	RKK(K/2)=UBC*UCD*(RRD(1,K)+2.0*DELD*RRD(2,K)+D2D*RRD(3,K))/
     1  (1.+D2D)
7	CONTINUE
6	CONTINUE
	IF (N1 .LE. 0 ) GO TO 9
	DO 10 I=1,N1
	PH2(I) = PH1(I)/57.295779
	CALL SIGMA( AN1(I), PH2(I), KL,TH2(I) )
	TH1(I) = TH2(I)/T
10	CONTINUE
	IF(ICO(8).EQ.1) THEN
	  WRITE(LUNOUT,105) DEL
	  IF(NC.GT.1) THEN
	    WRITE(LUNOUT,106) DELC
	    IF(NC.EQ.3) WRITE(LUNOUT,107) DELD
	  ENDIF
	ENDIF
9	CONTINUE
	IF(ICO(8).EQ.0) THEN
	  ANGP=-DANGP
	  DO 11 NP=1,NANGP
	  ANGP=ANGP+DANGP
	  CALL SIGMA(ANGP,PHI,KL,SIG1)
	  SIG(NP)=SIG1/T
	  XJB1=FLOAT(LF2(1))
	  SQ = SQRT(XJB1)*RHO(1)
11	  CONTINUE
	  WRITE(LUNOUT,108) ANG,SQ
	ENDIF
	RETURN
100	FORMAT(1H0,' GAMCOR ENTERED')
101	FORMAT(1H0,' DELTA(1) =',F9.4,'   DELTA(2) =',F9.4,
     1  '   DELTA(3) =',F9.4)
102	FORMAT(1H0,' DELTA  =',F8.3,'  ARCTAN =',F7.1)
103	FORMAT(1H ,' DELTAC =',F8.3,'  ARCTAN =',F7.1)
104	FORMAT(1H ,' DELTAD =',F8.3,'  ARCTAN =',F7.1)
105	FORMAT(1H ,' DELTA  =',F8.3)
106	FORMAT(1H+,21X,'DELTAC =',F8.3)
107	FORMAT(1H+,41X,'DELTAD =',F8.3)
108	FORMAT(' PROJ. SCATT. ANG.= ',F5.1,'  TOTAL-SIGMA=',E12.4)
	END

	SUBROUTINE FISCOR(ANGP,PHI,T,SIGMA)
	IMPLICIT REAL*8(A-H,O-Z)
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	INCLUDE 'ANGCOR.INC'
	COMPLEX*16 FP,AI,X
	COMMON /FISSION/ KA, KB1, XKA, XKB, XKJ

	SIG1=0.
	XJBB1=FLOAT(LF2(1))
	CALL DJMK(ANGP,PHI,0.D0,JB(1),KB1,RHO(1))
	MA=-JA
	DO 1 M1=1,LF1
	XMA=FLOAT(MA)/2.
	IMSB=-ISB
	DO 2 MS=1,JS
	IMSA=-ISA
	DO 3 MR=1,JR
	X=(0.,0.)
	MT=0
	MB=-JB(1)
	DO 4 M21=1,LF2(1)
	XMB=FLOAT(MB)/2.
	MJ=MB-MA
	XMJ=XMB-XMA
	MX=IABS(MJ)/2+1
	IND=0
	AI=(0.,0.)
	IF(ICO(5).EQ.1) THEN
	  JIND=(M1-1)*M21+M21+MT
	  AI=SUM(MS,MR,JIND)
	ELSE
	  DO 5 LSJ=1,NLTR
	  IF(MX.GT.JTR(LSJ)/2+1) GO TO 6
	  XJ=FLOAT(JTR(LSJ))/2.
	  IND1=(MJ+JTR(LSJ))/2+1
	  FP=SUM(MS,MR,IND+IND1)
	  AI=AI+CG(XJA,XMA,XJ,XMJ,XJB(1),XMB)*CG(XJA,XKA,XJ,XKJ,XJB(1)
     1  ,XKB)*FP*SQRT(DFLOAT((JTR(LSJ)+1)*LF1)/XJBB1)
6	  IND=IND+JTR(LSJ)+1
5	  CONTINUE
	ENDIF
	X=X+AI*RHO(M21)
	MB=MB+2
4	CONTINUE
	SIG1=SIG1+DREAL(X)**2+DIMAG(X)**2
	IMSA=IMSA+2
3	CONTINUE
	IMSB=IMSB+2
2	CONTINUE
	MA=MA+2
1	CONTINUE
	SIG1=SIG1*XJBB1/2.
	SIGMA=SIG1/T
	RETURN
	END

	SUBROUTINE CIOMSG(ISEVER,MESSAG)
C++
C TITLE:  CIOMSG
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Procedure to display informative, warning and error
C	messages.
C ENVIRONMENT:  FORTRAN-77.
C	Calls VAX/VMS specific routine LIB$STOP for program abort
C	with traceback.
C PROCEDURES CALLED:
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 24-nov-1980.	Allow ISEVER = 2.
C PAK 22-feb-1985.	Change condition code for LIB$STOP to SS$_ABORT
C			instead of simply zero.
C PAK 10-sep-1985.	Modify outputformat of MESSAG to prevent output
C			statement overflow.
C FUNCTIONAL DESCRIPTION:
C	The string specified by MESSAG is displayed.
C	If CIO is currently reading from an alternate device, indicated
C	by LUNSTP.ne.0, the alternate device level is also displayed.
C	Whether the routine returns to the main program depends on
C	ISEVER as follows:
C	ISEVER = 0: return to calling program.
C	ISEVER = 1: abort program.
C	ISEVER = 2: if inputdevice is terminal, return, else abort.
C CALLING SEQUENCE: (only for internal use by CIO)
C	CALL CIOMSG (ISEVER,MESSAG)
C INPUT PARAMETERS:
C	ISEVER	severity of message. See above.
C	MESSAG	character string to be displayed.
C--

	INCLUDE 'ciocom.inc'

	CHARACTER*(*)	MESSAG
	INTEGER			ISEVER

	WRITE (LUNO,9010) MESSAG(:MIN(LEN(MESSAG),132))
	IF (LUNSTP.NE.0) THEN
	  WRITE (LUNO,9020) LUNSTP
	ENDIF
 9010	FORMAT(1X,T8,A)
 9020	FORMAT(1X,T8,'(alternate file level ',I2,')')

	IF (ISEVER.EQ.0) THEN
	  RETURN
	ELSE IF (ISEVER.EQ.1) THEN
	  STOP 1	!???g77
	ELSE IF (ISEVER.EQ.2) THEN
	  IF (MODI.EQ.0) THEN
	    RETURN
	  ELSE
	    STOP 1      !???g77
	  ENDIF
	ENDIF
	END

	SUBROUTINE RHOMM
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES STATISTICAL TENSORS FOR VARIOUS M-STATE POPULATIONS
C  OF INTERMEDIATE STATE B.
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	INCLUDE 'ANGCOR.INC'
	COMPLEX*16 FP,X,X1

	WRITE(LUNOUT,100)
	MB=-JB(1)
	DO 1 M=1,LF2(1)
	XMB=FLOAT(MB)/2.
	MB1=-JB(1)
	DO 2 M1=1,LF2(1)
	XMB1=FLOAT(MB1)/2.
	FPP(M,M1)=(0.,0.)
	MA=-JA
	DO 3 MM=1,LF1
	XMA=FLOAT(MA)/2.
	MJ=MB-MA
	MJ1=MB1-MA
	XMJ=FLOAT(MJ)/2.
	XMJ1=FLOAT(MJ1)/2.
	IMSB=-ISB
	DO 4 MS=1,JS
	IMSA=-ISA
	DO 5 MR=1,JR
	MI=IABS(MJ)/2+1
	IND=0
	X=(0.,0.)
	X1=(0.,0.)
	IF(ICO(5).EQ.1) THEN
	  JIND=(MM-1)*M+M
	  X=SUM(MS,MR,JIND)
	ELSE
	  DO 6 LSJ=1,NLTR
	  IF(MI.GT.JTR(LSJ)/2+1)GO TO 7
	  XJ=FLOAT(JTR(LSJ))/2.
	  IND1=(MJ+JTR(LSJ))/2+1
	  FP=SUM(MS,MR,IND+IND1)*SQRT(DFLOAT(JTR(LSJ)+1))
	  X=X+CG(XJA,XMA,XJ,XMJ,XJB(1),XMB)*FP
7	  IND=IND+JTR(LSJ)+1
6	  CONTINUE
	ENDIF
	MF=IABS(MJ1)/2+1
	IND=0
	IF(ICO(5).EQ.1) THEN
	  JIND1=(MM-1)*M1+M1
	  X1=SUM(MS,MR,JIND1)
	ELSE
	  DO 8 LSJ1=1,NLTR
	  IF(MF.GT.JTR(LSJ1)/2+1)GO TO 9
	  XJ1=FLOAT(JTR(LSJ1))/2.
	  IND1=(MJ1+JTR(LSJ1))/2+1
	  FP=DCMPLX(DREAL(SUM(MS,MR,IND+IND1)),-DIMAG(SUM(MS,MR,IND
     1  +IND1)))
	  FP=FP*SQRT(DFLOAT(JTR(LSJ1)+1))
	  X1=X1+CG(XJA,XMA,XJ1,XMJ1,XJB(1),XMB1)*FP
9	  IND=IND+JTR(LSJ1)+1
8	  CONTINUE
	ENDIF
	FPP(M,M1)=FPP(M,M1)+X*X1
	IMSA=IMSA+2
5	CONTINUE
	IMSB=IMSB+2
4	CONTINUE
	MA=MA+2
3	CONTINUE
	MB1=MB1+2
2	CONTINUE
	MB=MB+2
1	CONTINUE
	RETURN
100	FORMAT(1H0,' RHOMM  ENTERED')
	END

	PROGRAM ANGCOR
	IMPLICIT REAL*8(A-H,O-Z)
C++
C	Main program calling subroutine ANGCORM, which contains the original
C	program ANGCOR. This allows the subroutine ANGCORM to be used for
C	search on a number of parameters in a chi**2 minimization procedure
C	using MINUIT.
C--

C	INDANG is a variable that is used in ANGCORM to indicate that no
C	minimization using the CERN MINUIT package is done.

	PARAMETER (MINU_PAR = 30)
	COMMON /ANG/INDANG, ITIME, CHI, PARA(MINU_PAR), ERR(MINU_PAR)

	INDANG = 1
	CALL ANGCORM

	STOP
	END

c	PROGRAM MAIN
c
C	Minimizes the decay coefficients in ANGCOR
c
c	CALL MINNEW
c	END

	SUBROUTINE FCN(NPAR,G,CHISQ,HPAR,IFLAG)
	IMPLICIT REAL*8 (A-H,O-Z)

	PARAMETER (MINU_PAR = 30)	!Number of minuit parameters
	COMMON /PAREXT/ U(MINU_PAR),XNAM(MINU_PAR),WERR(MINU_PAR),MAXEXT,NU
	COMMON /ANG/ INDANG,ITIME,CHI,PAR(MINU_PAR),ERR(MINU_PAR)
	DIMENSION G(MINU_PAR),HPAR(MINU_PAR)

	INDANG = 0

	GO TO (10,20,30,40,50), IFLAG

C	IFLAG=1	Initialize.
C	     =2 Gradient.
C	     =3 Output.
C	     =4 Minimize.
C	     =5 Reserved.

C	First call from MINUIT.
10	CONTINUE

C	ITIME	Number of iterations.
	ITIME =0
	DO 11 I=1,MINU_PAR
11	ERR(I)=WERR(I)

12	ITIME=ITIME+1
	IF (ITIME.EQ.2.OR.ITIME.EQ.3) THEN
	  CHISQ=CHI
	  GO TO 20
	ENDIF

	DO 13 I=1,NU
13	PAR(I)=HPAR(I)
	IF (ITIME.EQ.1) THEN
	  CALL ANGCORM
	ELSE
	  CALL AGCRHLP
	ENDIF
	CHISQ=CHI
	WRITE(16,14) ITIME,CHI,(HPAR(KK),KK=1,NU)
14	FORMAT(1X,'Iteration No.',I3,3X,'CHI2',E11.4,3X,'Params.',7F10.4)
20	RETURN

C	Last call.
30	GO TO 12

C	Ordinary call.
40	GO TO 12

50	RETURN

	END

	program tcio1

C Test CIOCMD routine

	IMPLICIT NONE
	LOGICAL LGO
	CHARACTER*5 FULL
	CHARACTER*5 CMDTBL(24)
	CHARACTER*30 helplib
	INTEGER K, ICMD

	DATA CMDTBL/
	1 'MACRO','MICRO','MACRI','COBOL','PASEN','VEEL ',
	2 'MEER ','VEREN','VAREN','VOREN','VIER ','VIJF ',
	3 'FRANS','FRATS','ACU  ','ACUCL','RSCAL','PSCAL',
	4 'STOP ','START','GO   ','GO-ON','FIND ','TERMI'/

	CALL CIOS ('Enter name of help library',helplib,k)
	CALL CIOHLPINI (helplib(:k),' ')

   10	CALL CIOWRT ('*******************')
	CALL CIOCMD ('TCIO1>',CMDTBL,24,ICMD)
	WRITE (*,*) 'ENTRY NR IS ',ICMD
	WRITE (*,*) 'FULL COMMAND = ',CMDTBL(ICMD)

	CALL CIOLX ('Do you want to proceed',LGO,'D',.TRUE.)
	IF (LGO) GOTO 10
	STOP
	END

	SUBROUTINE CIOLUN (LI,LO)
C++
C TITLE:  CIOLUN
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Change logical unit numbers for zero level I/O.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	CIO1ST, CIOERR
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C	Assigns the logical unit numbers in the call to the internal
C	logical unit numbers for the zero level input device.
C CALLING SEQUENCE:
C	CALL CIOLUN (LI,LO)
C INPUT PARAMETERS:
C	LI	the new logical unit nr for CIO zero level input.
C	LO	the new logical unit nr for CIO output of prompts
C		and messages.
C--

	INCLUDE 'ciocom.inc'

	INTEGER	LI, LO

	CALL CIO1ST
	IF (LUNSTP.NE.0) THEN
	  CALL CIOERR(1, 'Call to CIOLUN illegal while alternate input active')
	ELSE
	  LUNI = LI
	  LUNIS = LI
	  LUNO = LO
	ENDIF
	RETURN
	END

	SUBROUTINE PARP(ANGP,PHI,LMAX,T,SIGMA)
	IMPLICIT REAL*8(A-H,O-Z)

	INCLUDE 'ANGCOR.INC'
	COMPLEX*16 FP,AI,AF,X
	REAL TI(INTER_CH),SQRS(INTER_CH-1)
	COMMON /INTCRO/  NCH, TI, SQRS


C  THE FOLLOWING STATEMENTS HAVE BEEN ADDED TO ENSURE NORMALIZATION OF
C  THE ANGULAR DISTRIBUTION TO UNITY
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	DTEMP=0
	IF (NCH.EQ.1) THEN
	  TI(1)=T
	  DTEMP=TI(1)
	ELSE
	  DO N=1,NCH
	    DTEMP=DTEMP+TI(N)
	  ENDDO
	ENDIF

	SIG1=0.
	CALL PLM(ANGP,LMAX,LMAX)
	MA=-JA
	DO 1 M1=1,LF1
	XMA=FLOAT(MA)/2.
	IMSB=-ISB
	DO 2 MS=1,JS
	IMSA=-ISA
	DO 3 MR=1,JR
	IMSC=-ISC
	DO 4 MSC=1,NSD
	XMS=FLOAT(IMSC)/2.
	MC=-JC
	DO 5 M3=1,LF3
	XMC=FLOAT(MC)/2.
	X=(0.,0.)
	MT=0
	DO 6 NNCH=1,NCH
	MB=-JB(NNCH)
	DO 7 M21=1,LF2(NNCH)
	XMB=FLOAT(MB)/2.
	MJ=MB-MA
	XMJ=XMB-XMA
	MX=IABS(MJ)/2+1
	IND=0
	AI=(0.,0.)
	IF(ICO(5).EQ.1) THEN
	  JIND=(M1-1)*M21+M21+MT
	  AI=SUM(MS,MR,JIND)
	ELSE
	  DO 8 LSJ=1,NLTR
	  IF(MX.GT.JTR(LSJ)/2+1)GO TO 9
	  IF(ICO(4).EQ.0)GO TO 10
	  IF(NNCH.NE.LSJ)GO TO 9
10	  XJ=FLOAT(JTR(LSJ))/2.
	  IND1=(MJ+JTR(LSJ))/2+1
	  FP=SUM(MS,MR,IND+IND1)
	  IF (NNCH.GT.1) FP=SQRS(NNCH-1)*FP
	  AI=AI+CG(XJA,XMA,XJ,XMJ,XJB(NNCH),XMB)*FP
     1        *SQRT(DFLOAT(JTR(LSJ)+1))
9	  IND=IND+JTR(LSJ)+1
8	  CONTINUE
	ENDIF
	CALL PARDEC(XMB,XMC,XMS,NNCH,PHI,AF)
	X=X+AI*AF
	MB=MB+2
7	CONTINUE
	MT=MT+LF1*LF2(NNCH)
6	CONTINUE
	SIG1=SIG1+DREAL(X)**2+DIMAG(X)**2
	MC=MC+2
5	CONTINUE
	IMSC=IMSC+2
4	CONTINUE
	IMSA=IMSA+2
3	CONTINUE
	IMSB=IMSB+2
2	CONTINUE
	MA=MA+2
1	CONTINUE
	SIGMA = SIG1/DTEMP
	RETURN
	END

	SUBROUTINE CIOQLU (I1, I2, *, *, *)
C++
C TITLE:  CIOQLU
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Test if item is qualifier and if so process it.
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C PROCEDURES CALLED:
C	CIOLUP, CIOERL, CIO_MOVL, STR__UPCASE, STR__COPY_DX
C CREATION DATE:  13-may-1981
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C	Check if item INBUF(I1:I2) is a qualifier, i.e. a slash followed by
C	at least one character. If not take alternate return 1.
C	If a qualifier, search its definition in the qualifier list.
C	If no qualifiers allowed (defined) complain, and also take return 2.
C	If not found or ambiguous, complain, and take alternate return 3.
C	If qualifier is legal, update its associated variable(s). Then return.
C CALLING SEQUENCE:
C	CALL CIOQLU (I1, I2, *, *, *)
C INPUT PARAMETERS:
C	I1, I2	pointers to begin and end of item in INBUF to be examined.
C ALTERNATE RETURNS:
C	normal	item is a qualifier and has successfully been processed.
C	1	item is not a qualifier,
C	2	item is a qualifier, but there are no qualifiers allowed,
C	3	item is a qualifier, but is unknown or ambiguous, a value
C		is required, missing or not allowed or a negative form is
C		given but not allowed.
C--

	INCLUDE		'ciocom.inc'
	LOGICAL*1	LNEGATE, LVALUE
	CHARACTER*(QUASIZ+2)	CTEMP	! allow for 'NO' prefix
	INTEGER		ILOLIM, IHILIM, ITEMP
	REAL		ALOLIM, AHILIM, ATEMP
	INTEGER		I1, I2, J1, J2, K, K1, K2, M
	LOGICAL		XCALL

C Check whether the item in INBUF(I1:I2) is a qualifier.
C If not take alternate return 1.
C If ok, copy item pointers to local variables, since we may modify them.

	IF (I2.LE.I1 .OR. INBUF(I1:I1).NE.'/') RETURN 1
	J1 = I1
	J2 = I2

C It is a qualifier. See if any qualifiers defined.

	IF (Q_NR.EQ.0) THEN
	  CALL CIOERL ('no qualifiers allowed')
	  RETURN 2
	ENDIF

C Check whether the /QUALIFIER or /QUALIFIER=value form.

	K = INDEX (INBUF(J1:J2), '=')	! locate the equal sign
	IF (K.EQ.0 .OR. K.EQ.J2-J1+1) THEN
		! no equal sign or nothing behind equal sign
	  LVALUE = .FALSE.
	ELSE				! equal sign present
	  LVALUE = .TRUE.
	  K1 = J1 + K			! K1 and K2 mark the value field
	  K2 = J2
	  J2 = K1 - 2			! Adjust the qualifier end pointer
	ENDIF

C Distinquish between /QUALIFIER AND /NOQUALIFIER form

	CALL STR__UPCASE (CTEMP, INBUF(J1:J1+2))
	IF (CTEMP(1:3) .EQ. '/NO') THEN
	  LNEGATE = .TRUE.
	  CTEMP = INBUF(J1+3:J2)	! extract part after /NO.
	ELSE
	  LNEGATE = .FALSE.
	  CTEMP = INBUF(J1+1:J2)	! extract part after /.
	ENDIF

C Lookup qualifier (with possible NO removed) in qualifier definition list

	CALL CIOLUP (CTEMP, Q_NAMES, Q_NR, M)

C Check result

	IF (M) 910, 920, 100	! unknown / ambiguous / found

C Qualifier is known. Get flag that indicates whether original call
C had the short or extended argument list.
C Then dispatch according to its datatype

  100	XCALL = Q_XCALL (M)
	GOTO (110, 120, 130, 140), Q_DATATYPE(M)

C Logical qualifier ( /QUAL or /NOQUAL).

  110	CONTINUE
	IF (LVALUE) GOTO 930				! A value is never allowed here
	IF (LNEGATE) THEN				! if /NO... form
	  CALL CIO_COPY_L (Q_L_NOVALUE(M),  %VAL(Q_PTR_DEST(M)))	! store no-value.
	ELSE						! if /... form
	  CALL CIO_COPY_L (Q_L_YESVALUE(M), %VAL(Q_PTR_DEST(M)))	! store yes-value.
	ENDIF
	RETURN

C Qualifier with an integer value assignement.

  120	CONTINUE
	IF (LNEGATE) GOTO 950							! Don't allow /NO form
	IF (.NOT.LVALUE) THEN
		! no value given, use default, but complain if it was
		! not specified.
		IF (.NOT.XCALL) GOTO 940	! error, value required
		CALL CIO_COPY_I (Q_I_DEFAULT(M), %VAL(Q_PTR_DEST(M)))
	ELSE
		! Value given, decode it, check against limits and store
		! in associated variable.
		READ (INBUF(K1:K2), 9120, ERR=960) ITEMP
C9120		FORMAT (I<K2-K1+1>)
 9120		FORMAT (I20)
		ILOLIM = Q_I_LOLIM(M)
		IHILIM = Q_I_HILIM(M)
		IF (ILOLIM.NE.IHILIM .and.
     +		(ITEMP.LT.ILOLIM .OR.ITEMP.GT.IHILIM)) GOTO 970
		CALL CIO_COPY_I (ITEMP, %VAL(Q_PTR_DEST(M)))
	ENDIF
	RETURN

C Qualifier with a real value assignement.

  130	CONTINUE
	IF (LNEGATE) GOTO 950							! Don't allow /NO form
	IF (.NOT.LVALUE) THEN
		! no value given, use default, but complain if it was
		! not specified.
		IF (.NOT.XCALL) GOTO 940	! error, value required
		CALL CIO_COPY_F (Q_F_DEFAULT(M), %VAL(Q_PTR_DEST(M)))	! use default
	ELSE
		! Value given, decode it, check against limits and store
		! in associated variable.
		READ (INBUF (K1:K2), 9130, ERR=960) ATEMP
C9130		FORMAT (F<K2-K1+1>.0)
 9130		FORMAT (F20.0)
		ALOLIM = Q_F_LOLIM(M)
		AHILIM = Q_F_HILIM(M)
		IF (ALOLIM.NE.AHILIM .and.
     +    	(ATEMP.LT.ALOLIM .OR.ATEMP.GT.AHILIM)) GOTO 970
		CALL CIO_COPY_F (ATEMP, %VAL(Q_PTR_DEST(M)))		! If ok, store value.
	ENDIF
	RETURN

C Qualifier with a string assignement.

  140	CONTINUE
	IF (LNEGATE) GOTO 950								! Don't allow /NO form
	IF (.NOT.LVALUE) THEN
		! No string value given. Error if value IS required.
		IF (.NOT.XCALL) GOTO 940
		! Else set flag to qualifier-without-value
	    CALL CIO_COPY_I (0, %VAL(Q_PTR_FLAG(M)))
	ELSE
		! String given. Copy it to associated string variable,
		! and copy length to assocated length variable.
		CALL CIO_COPY_S (INBUF(K1:K2), K2-K1+1, %VAL(Q_PTR_DEST))
	  	CALL CIO_COPY_I (K2-K1+1, %VAL(Q_PTR_LEN(M)))
		! and if indicator flag was given
		! then set it to indicate! qualifier-with-value.
	  	IF (XCALL) CALL CIO_COPY_I (1, %VAL(Q_PTR_FLAG(M)))
	ENDIF
	RETURN

C Various error messages.

  910	CALL CIOERL ('unknown qualifier')
	GOTO 990
  920	CALL CIOERL ('ambiguous qualifier')
	GOTO 990
  930	CALL CIOERL ('no value allowed on qualifier')
	GOTO 990
  940	CALL CIOERL ('value required on qualifier')
	GOTO 990
  950	CALL CIOERL ('qualifier has no negative form')
	GOTO 990
  960	CALL CIOERL ('bad syntax for qualifier value')
	GOTO 990
  970	CALL CIOERL ('illegal qualifier value')
	GOTO 990

  990	WRITE (LUNO,9990)
 9990	FORMAT(T8,'please re-enter or type <return> to proceed'/' _',$)
	RETURN 3

	END

	SUBROUTINE CIOBUF (USRBUF)
C++
C TITLE:  CIOBUF
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Supply input buffer to CIO.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED: CIO1ST, CIOPAB
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 29-jan-1981: Added stripping of comment field.
C PAK 11-feb-1981 Repaired faulty logic around current-item pointers
C ENTRIES:
C	CIOBUF, CIOPUR
C FUNCTIONAL DESCRIPTION:
C	CIOBUF:
C	  The supplied characterstring USRBUF is copied into CIO's
C	  internal inputbuffer.
C	CIOPUR:
C	  CIO's internal inputbuffer is purged. This forces CIO to
C	  read a new buffer from the input file when it requires input.
C CALLING SEQUENCE:
C	CALL CIOBUF (USRBUF)
C	CALL CIOPUR
C INPUT PARAMETERS:
C	USRBUF	the characterstring to be copied into CIO's internal
C		input buffer.
C--

	INCLUDE 'ciocom.inc'
	CHARACTER USRBUF*(*)

	CALL CIO1ST		!Perform once only code
	INBUF = USRBUF		!Copy user's buffer to internal buffer
	INBUFL = LEN(USRBUF)	!Copy actual length
	CALL CIOPAB		!Pre-analyse buffer.
	RETURN

C CIOPUR - purge CIO's internal input buffer.

	ENTRY CIOPUR

	CALL CIO1ST		!Perform once only code.
	INBUFL = 0		!Zero buffer length
	INBUFC = 0		!Zero content length
	INPTR = 0		!Zero buffer pointer
	ITPTR1 = 0		!Zero current item pointers
	ITPTR2 = 0
	LCONTIN = .FALSE.	!Clear continuation flag
	RETURN
	END

	SUBROUTINE CIOQPU
C++
C TITLE:  CIOQPU
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Purge qualifier definition list.
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE: 13-may-1981
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C	Remove all qualifier definitions.
C CALLING SEQUENCE:
C	CALL CIOQPU
C--
	INCLUDE		'ciocom.inc'
	Q_NR = 0

	RETURN
	END

	SUBROUTINE CIOLUP (KEYWRD,KEYTBL,NKEYS,KEYVAL)
C++
C TITLE:  CIOLUP
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Lookup (abbreviated) keyword in table and return its
C	entry number.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	INDEX, STR__UPCASE
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 26-jan-1981 Changed call to CIOCLU to STR__UPCASE.
C FUNCTIONAL DESCRIPTION:
C	KEYTBL(1...NKEYS) is scanned for the occurance of KEYWRD.
C	If an exact match is found, the entry nr is returned in KEYVAL.
C	If a partial match is found, the entry nr is remembered and
C	the scan continues. If another partial match is found, the
C	KEYWRD is ambigious and KEYVAL=0 is returned.
C	If an exact match is found, that entry is returned in KEYVAL.
C	If no further match is found the entry nr of the partial
C	match is returned in KEYVAL.
C	If no match is found at all, KEYVAL=-1 is returned.
C CALLING SEQUENCE:
C	CALL CIOLUP (KEYWRD, KEYTBL, NKEYS, KEYVAL)
C INPUT PARAMETERS:
C	KEYWRD	character string to be searched for in KEYTBL.
C		KEYWRD is converted to uppercase before the search.
C	KEYTBL	character array containing the lookup table.
C	NKEYS	dimension of (nr of elements in) KEYTBL.
C OUTPUT PARAMETERS:
C	KEYWRD	the original contents of KEYWRD with lowercase
C		characters converted to uppercase.
C	KEYVAL	entry nr of matching entry in KEYTBL, or
C		0 if KEYWRD is ambigious, or -1 if KEYWRD does not
C		occur in KEYTBL.
C--

	CHARACTER*(*)	KEYWRD,KEYTBL(1)
	LOGICAL*1	FOUND

C Determine length of KEYWRD and convert lower to upper case.
	LENKEY = INDEX (KEYWRD,' ') - 1
	IF (LENKEY.LE.0) LENKEY = LEN (KEYWRD)
	FOUND = .FALSE.
	CALL STR__UPCASE (KEYWRD(:LENKEY), KEYWRD(:LENKEY))

C Search table for exact or partial match.
	DO 10 I = 1,NKEYS
	IF (KEYWRD.EQ.KEYTBL(I)) THEN
	  KEYVAL = I
	  GOTO 20
	ENDIF
	IF (KEYWRD(:LENKEY).EQ.KEYTBL(I)(:LENKEY)) THEN
	  IF (.NOT.FOUND) THEN
	    FOUND = .TRUE.
	    KEYVAL = I
	  ELSE
	    KEYVAL = 0
	    RETURN
	  ENDIF
	ENDIF
   10	CONTINUE

C Whole table has been searched. See if partial match found.
	IF (.NOT.FOUND) THEN
	  KEYVAL = -1
	  RETURN
	ENDIF

C Succesful completion. Return entry number.
   20	RETURN
	END

	PROGRAM TCIO1

C Ad Hoc test for CIOI

	IMPLICIT NONE

	INTEGER			IVAR, IXVAR, IQUAL1, INT, INTOPT
	INTEGER			LENQVAR, LENQVAROPT, IQVAR, LSVAR
	REAL			FVAR, REALVAR, REALOPT
	DOUBLEPRECISION	DVAR
	LOGICAL			LVAR
	LOGICAL*1		BVAR
	CHARACTER*37	AVAR,SVAR,QVAR,QVAROPT
	REAL			ARRAY(100)
	character*30	helplib
	LOGICAL			LQUAL
	LOGICAL			LEMPTY
	INTEGER			I, K, N

	call cios ('name of help library',helplib,k)
	call ciohlpini (helplib(:k),' ')

    1	CALL CIOWRT('Dit komt via CIOWRT')
	CALL CIOWRT('Evenals dit')
	CALL CIOIX ('(1) Integer',      IVAR, 'QLH>$', -6, 18, *2, *20)
	CALL CIOIX ('(1a) Hex integer', IXVAR,'LHX',   -6, 18)

	CALL CIOQLX ('LOGFULL', IQUAL1, 7, 3)
	CALL CIOQL  ('LOGSHORT', LQUAL)

	CALL CIOQI ('INT', INT, 20, 30)
	CALL CIOQI ('INTOPT', INTOPT, 20, 30, 23)

	CALL CIOQF ('REAL', REALVAR, 20., 30.)
	CALL CIOQF ('REALOPT', REALOPT, 20., 30., 23.)

	CALL CIOQS ('STRING', LENQVAR, QVAR)
	CALL CIOQS ('STRINGOPT', LENQVAROPT, QVAROPT, IQVAR)

    2	CALL CIOFX ('(2) F-float',FVAR,'D<^>$',123.45,*1,*1,*3,*20)
    3	CALL CIODX ('(3) D-float',DVAR,'DL<^>$',0.01932,2.,*2,*1,*4,*20)
    4	CALL CIOLX ('(4) Logical',LVAR,'<^>$',*3,*1,*5,*20)
    5	CALL CIOLX ('(5) Boolean',BVAR,'D<^>$',.FALSE.,*4,*1,*6,*20)
    6	CALL CIOAX ('(6) Text',AVAR,'D<^>$','automatic',*5,*1,*7,*20)
    7	CALL CIOSX ('(7) String',SVAR,LSVAR,'D<^$','AbCdEfGh',
	1 *6,*1,*20)

	CALL CIOQCO		! complete qualifier scan

   10	CONTINUE

	WRITE (*,*) 'LOGFULL',IQUAL1
	WRITE (*,*) 'LOGSHORT',LQUAL
	WRITE (*,*) 'INT',INT
	WRITE (*,*) 'INTOPT',INTOPT
	WRITE (*,*) 'REAL',REALVAR
	WRITE (*,*) 'REALOPT',REALOPT
	WRITE (*,*) 'STRING',QVAR
	WRITE (*,*) 'STRINGOPT',QVAROPT
	WRITE (*,*) 'LENQVAR', LENQVAR
	WRITE (*,*) 'LENQVAROPT', LENQVAROPT
	WRITE (*,*) 'IQVAR',IQVAR

	WRITE (*,*) 1,IVAR, IXVAR
	WRITE (*,*) 2,FVAR
	WRITE (*,*) 3,DVAR
	WRITE (*,*) 4,LVAR
	WRITE (*,*) 5,BVAR
	WRITE (*,*) 6,AVAR
	WRITE (*,*) 7,LSVAR,SVAR

C Now test the CIOTBE entry
	write (*,*) '(''0Nu testen we CIOTBE''/)'

	DO 100 I=1,100
	CALL CIOFX ('Enter an element of ARRAY',ARRAY(I),'$',*20)
	N = I
	CALL CIOTBE (LEMPTY)
	IF (LEMPTY) GOTO 110
  100	CONTINUE
  110	WRITE (*,*) 'You entered',N,'elements. Their values are:'
	WRITE (*,*) (ARRAY(I),I=1,N)
	GOTO 1

   20	WRITE (*,*) 'You took the escape exit'
	GOTO 1
	END

	SUBROUTINE CIO1ST
C++
C TITLE:  CIO1ST
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Once-only initialization code for CIO package.
C	Also contains initialization data statement for common CIO003.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	CIOMOD	to obtain running mode (interactive or batch)
C	CIOINV	to invalidate input buffer contents.
C	CIOQPU	to purge the qualifier list.
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C	Performs initialization of various parameters and switches
C	in the CIO package. Then makes itself in active on further
C	calls.
C CALLING SEQUENCE:  (only for internal use by CIO)
C	CALL CIO1ST
C IMPLICIT OUTPUTS: Various parameters in CIO common blocks.
C--

	INCLUDE 'ciocom.inc'
	INCLUDE 'cio003ini.inc'
	LOGICAL*1	FIRST
	DATA		FIRST /.TRUE./
	INTEGER		K

C Lockout this code after the first time.
	IF (.NOT.FIRST) RETURN
	FIRST = .FALSE.

C Get device types for zero level input and output devices.
	CALL CIOMOD (MODI,MODO)

C Initialize the LUN pool so that all LUNs are available.

C      write (*,*) '?????? cio1st lunpool init'
	DO K = LUNPOOLMIN, LUNPOOLMAX
		LUNPOOL (K) = .FALSE.
	END DO

C Set input and output luns to their defaults and clear lun stack
C for alternate input devices.
	LUNI = LUNIDF
	LUNIS = LUNIDF
	LUNO = LUNODF
	LUNSTP = 0

C Reset promptbuffer pointer and clear lun for prompt-scratch-file
C indicating no file open.
	IPBPTR = 0
	LUNPRF = 0

C Invalidate inputbuffer and alternate files.
C      write (*,*) '?????? cio1st calls cioinv'
	CALL CIOINV

C Purge qualifier list
C      write (*,*) '?????? cio1st calls cioqpu'
	CALL CIOQPU

	RETURN
	END

	SUBROUTINE CIOINV
C++
C TITLE:  CIOINV
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Invalidate current input buffer and, if not at the zero
C	level input file, close all active levels of alternate files
C	so that input proceeds from the zero level input file.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED: CIOAIC
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 11-feb-1981 Repaired faulty logic around current-item pointers
C FUNCTIONAL DESCRIPTION:
C	Calls CIOAIC until all alternate files are closed and the
C	zero level input device is reached.
C	Also resets pointers so that effectively the internal
C	inputbuffer is purged.
C CALLING SEQUENCE: (only for internal use by CIO)
C	CALL CIOINV
C--

	INCLUDE 'ciocom.inc'

	INPTR = 0		!Kill current buffer.
	ITPTR1 = 0
	ITPTR2 = 0
	INBUFL = 0
	INBUFC = 0
	LCONTIN = .FALSE.

  100	CALL CIOAIC (*110)	!Drop back to zero level input medium.
	GOTO 100
  110	RETURN
	END

C	PROGRAM ANGCOR

	SUBROUTINE ANGCORM

	IMPLICIT REAL*8(A-H,O-Z)

C  Written by:  M.N. Harakeh and L.W. Put, Internal report KVI-67
C		Last modified 25 August 1985.
c Nov-2000 M.Yosoi   Rev. for IBM-xlf
c Sept-2009 R.G.T. Rev. for Linux 

C  Computes decay angular distributions from states excited by direct  
C  reactions. input amplitudes are read from DWUCK, CHUCK, or DWBA82
C  files.

C  DWUCK must be run with ICON(3) equal 0 or 1.

C  Reaction is defined by A(ma,mb)B* where B* decays into C+mc.

C  ICO(1)	.EQ.0  Particle-gamma angular correlations.
C		.EQ.1  Particle-particle angular correlations.
C		.EQ.2  Particle-particle-gamma angular correlations.
C		       The intermediate particle decay is not observed.
C		.EQ.3  Particle-fission angular correlation.

C  ICO(2)	.EQ.0  Do not print information from subroutines RHOKQ and
C		       RHOLSJ.
C		.EQ.1  Print.

C  ICO(3)	.EQ.0  Calculate RHOKQ from RHOMM.
C		.EQ.1  Calculate RHOKQ from RHOLSJ.

C  ICO(4)	.EQ.0  Only one intermediate state JB is excited.
C		.EQ.1  Two or more intermediate states JB are excited. this
C		       is only for particle decay. in this case only one JTR
C		       is allowed per  intermediate state.

C  ICO(5)	.EQ.0  M-state populations obtained from program DWUCK.
C		.EQ.1  M-state populations obtained from program CHUCK.
C		       In this case ICON(8) in  C H U C K  should be set
C		       equal to state number.
C		.EQ.2  M-state populations obtained from program DWBA82. In
C		       this case DWBA82 should be run once for every new
C		       ANGCOR calculation with a different scattering angle.

C  ICO(6)	.EQ.0  New DWUCK/CHUCK/DWBA82 information read in.
C		.EQ.1  Same DWUCK/CHUCK/DWBA82 information as in previous
C		       case. Card sets 3 and 4 should be deleted.

C  ICO(7)	.EQ.0  Do not print beta's/D-amplitudes/m-state population
C		       amplitude.
C		.EQ.1  Print.

C  ICO(8)	.EQ.0  Print angular correlation.
C		.EQ.1  Suppress printing angular correlation, only CHI2
C		       as function of delta will be printed.

C  ICO(9)	.EQ.0  Z-axis is the beam axis for cases where m-state
C		       population amplitudes are obtained from DWUCK or CHUCK
C		       or is the scattering axis if they are obtained from
C		       DWBA82.
C		.EQ.1  Z-axis is the recoil axis. In this case the recoil
C		       angle (RECANG) should be read on card 7.

C  NC		Number of cascades in case of gamma-ray decay.

C  M1		.GE.0  Number of experimental data.
C  		.LT.0  Same experimental data as in previous case,
C		       card set 9 should be deleted.

C  This program handles only the case where the spin transfer ISTR
C  is the same for all form factors in DWUCK.
C  Conventions of SATCHLER are followed. Nucl.Phys. 55(1964)1


	PARAMETER (MINU_PAR = 30)	!Number of minuit parameters
	INCLUDE 'ANGCOR.INC'
	COMMON /CASCADE/ LBC, LCD, JD2, LDE, JE2, NC, ARCDEL, ARCDELC,
     1 	ARCDELD
	REAL AN1(MAX_EXP),PH1(MAX_EXP),C1(MAX_EXP),EC1(MAX_EXP),
     1  TH1(MAX_EXP)
	COMMON /CROSS/   N1, AN1, PH1, C1,EC1, TH1
	COMMON /EXTRA/   ZW(MAX_LG), RKK(MAX_LG)
	COMMON /FISSION/ KA, KB1, XKA, XKB, XKJ
	REAL TI(INTER_CH),SQRS(INTER_CH-1)
	COMMON /INTCRO/  NCH, TI, SQRS
	REAL PARA(MINU_PAR), ERR(MINU_PAR)
	COMMON /ANG/     INDANG, ITIME, CHI, PARA, ERR
	COMPLEX*16 FL(MAX_DIM1,M_HALF), FLC(MAX_L*INTER_CH,MAX_DIM2), 
     1  F, SSQ,
     1  RSUM(MAX_MS,MAX_MS,M_HALF*MAX_LTR)
	COMPLEX*16 DJ(MAX_SUBST), DSA(MAX_MS), DSB(MAX_MS), XDJ, XDSB
	EQUIVALENCE (FL(1,1),FLC(1,1)), (RHO(1),DJ(1))
	DIMENSION DTEMP(INTER_CH), TS(M_HALF), ZQ(INTER_CH), 
     1  ZZQ(INTER_CH)
	DIMENSION ISTR(INTER_CH), NS(INTER_CH), XJBB(INTER_CH),
     1  XIS(INTER_CH), BLSJ(INTER_CH), TI_INT(INTER_CH), 
     1  RSCALE(INTER_CH-1)
     2  ,R(INTER_CH-1)
	DIMENSION HD(20), SIGTOT(MAX_TH), TH1TOT(MAX_EXP), S3(MAX_EXP)

	DO 1 K=1,INTER_CH
	NLDEC(K)=0
	DO 1 J=1,MAX_LDEC
1	DELTA(K,J)=0.
	XANG=-1.
	XFIS=1.
	INDROT=0
	LUNOUT=6

C  Read card 1.  Title.

2	READ(5,100,END=99) (HD(I), I=1,20)
	WRITE(LUNOUT,101)  (HD(I), I=1,20)

C  Read card 2. Control integers.

	READ(5,*) (ICO(I),I=1,NCONT), NC , M1
	NC=MIN(NC,N_GAM)
	M1=MIN(M1,MAX_EXP)
	IF (M1.GE.0) N1 = M1
	IF(ICO(1).NE.1) ICO(4)=0
	IF(ICO(4).EQ.0) THEN
	  NCH=1
	ELSE
	  READ(5,*) NCH
	ENDIF
	WRITE(LUNOUT,102) (ICO(I),I=1,NCONT)

C  Read card 3. Number of partial waves and spins of all particles
C		involved in the reaction.
C		All spins  and J transfers should be 2*actual value.
C		LP is no  of partial waves. Same as in DWUCK or CHUCK.

	IF (ICO(6) .EQ. 0) THEN
	  READ(5,*) LP,ISA,JA,ISB,(JB(N),N=1,NCH),(ISTR(N),N=1,NCH),
     2            (RSCALE(N),N=1,NCH-1)
	  LP = MIN(LP+1,MAX_L)
	  XJA=FLOAT(JA)/2.
	  DO 3 N=1,NCH
	  XJB(N)=FLOAT(JB(N))/2.
	  XIS(N)=FLOAT(ISTR(N))/2.
	  IF(TRIREL(ISA,ISTR(N),ISB).EQ.-1.)
     1  STOP ' SPINS OF ENTRANCE CHANNEL DONOT SATISFY SPIN STATISTICS'
3	  CONTINUE

C  Read card 4. L and J transfers.

	  READ(5,*) NLTR,(LTR(I),I=1,NLTR),(JTR(I),I=1,NLTR)
	  NLTR=MIN(NLTR,MAX_LTR)
	  IF(ICO(4).EQ.0) THEN
	    IF(ICO(5).EQ.2) NLTR=1
	  ELSE
	    NLTR=NCH
	  ENDIF
	  DO 4 I=1,NLTR
	  IF(ICO(4).EQ.0) THEN
	    ISTEMP=ISTR(1)
	    JBTEMP=JB(1)
	  ELSE
	    ISTEMP=ISTR(I)
	    JBTEMP=JB(I)
	  ENDIF
	  IF(TRIREL(2*LTR(I),ISTEMP,JTR(I)).EQ.-1.
     1  .OR.TRIREL(JA,JTR(I),JBTEMP).EQ.-1.)
     2  STOP ' SPINS OF ENTRANCE CHANNEL DONOT SATISFY SPIN STATISTICS'
4	  CONTINUE
	ENDIF

	WRITE(LUNOUT,103) LP-1,ISA,JA,ISB,NCH,(JB(N),N=1,NCH),
     1     (ISTR(N),N=1,NCH)
	WRITE(LUNOUT,104) NLTR,NLTR,(LTR(I),I=1,NLTR),(JTR(I),I=1,NLTR)

	IF(ICO(1).EQ.1.OR.ICO(1).EQ.2) THEN

C  Read cards 5a. Particle decay parameters.

	  READ(5,*) JC,ISC,(NLDEC(K),K=1,NCH)
	  DO K=1,NCH
	    NLDEC(K)=MIN(NLDEC(K),MAX_LDEC)
	  ENDDO
	  WRITE(LUNOUT,105)
	  WRITE(LUNOUT,106) JC,ISC,(NLDEC(K),K=1,NCH)
	  XS=FLOAT(ISC)/2.
	  DO 5 K=1,NCH
	  WRITE(LUNOUT,107) K
	  DO 5 I=1,NLDEC(K)
	  READ(5,*) LDEC(K,I),JDEC(K,I),DELTA(K,I)
	  IF(TRIREL(JDEC(K,I),2*LDEC(K,I),ISC).EQ.-1.)
     1  STOP ' SPINS OF EXIT CHANNEL DONOT SATISFY SPIN STATISTICS'
	  WRITE(LUNOUT,108) I, LDEC(K,I), JDEC(K,I)
5	  CONTINUE
	ENDIF
	IF(ICO(1).EQ.0.OR.ICO(1).EQ.2) THEN
	  WRITE(LUNOUT,109) NC
	  IF(ICO(1).EQ.2) THEN
	    NC=NC+1
	    GO TO 6
	  ENDIF
C  Read cards 5b. Gamma-ray decay parameters.

	  READ(5,*) LBC,JC2,ARCDEL
	  WRITE(LUNOUT,110) JC2,LBC,LBC+1
	  JC = JC2
	  ISC = 2
	  IF (NC.EQ.1) GO TO 7
6	  READ(5,*) LCD,JD2,ARCDELC
	  WRITE(LUNOUT,111) JD2,LCD,LCD+1
	  IF (NC.EQ.2) GO TO 7
	  READ(5,*) LDE,JE2,ARCDELD
	  WRITE(LUNOUT,112) JE2,LDE,LDE+1

C  Read card 6.	Geometrical attenuation coefficients
C		available only for gamma decay.

7	  READ(5,*) (ZW(I),I=1,MAX_LG)
	  WRITE(LUNOUT,113) (ZW(I),I=1,MAX_LG)

	ELSEIF(ICO(1).EQ.3) THEN

C  Read card 5c. Fission decay parameters
C		 spin projections are 2*actual value.

	  READ(5,*) KA,KB1
	  WRITE(LUNOUT,114)
	  WRITE(LUNOUT,115) KA,KB1
	  XKA=FLOAT(KA)/2.
	  XKB=FLOAT(KB1)/2.
	  XKJ=XKB-XKA
	ENDIF

	IF(ICO(6).EQ.0) THEN
	  JR=ISA+1
	  JS=ISB+1
	  LF1=JA+1
	  DO 8 N=1,NCH
	  NS(N)=ISTR(N)+1
	  XJBB(N)=JB(N)+1
	  LF2(N)=JB(N)+1
	  BLSJ(N)=SQRT(DFLOAT(NS(N))/DFLOAT(JR))
8	  CONTINUE
	  IF(NCH.GT.1) THEN
	    DO N=1,NCH-1
	      SQRS(N)=SQRT(RSCALE(N))
	    ENDDO
	  ENDIF

C  M2K.EQ.1 for 1/2 integer spin transfer.
	  M2K=NINT(1.0+PAR(NS(1)))/2

	ENDIF
	IF(ICO(1).LT.3) THEN
	  NSD=ISC+1
	  XJC=FLOAT(JC)/2.
	  LF3=JC+1
	  IF(ICO(1).EQ.0) THEN
	    IF(TRIREL(JC,JB(1),2*LBC).EQ.-1.)
     1    STOP ' SPINS OF EXIT CHANNEL DONOT SATISFY SPIN STATISTICS'
	  ELSEIF(ICO(1).EQ.1.OR.ICO(1).EQ.2) THEN
	    DO 9 J=1,NCH
	    DO 9 I=1,NLDEC(J)
	    IF(TRIREL(JC,JB(J),JDEC(J,I)).EQ.-1.)
     1    STOP ' SPINS OF EXIT CHANNEL DONOT SATISFY SPIN STATISTICS'
9	    CONTINUE
	  ENDIF
	ENDIF
	IF(ICO(6).EQ.0) THEN
	  IF (ICO(7).EQ.1) WRITE(LUNOUT,116)
	  IF(ICO(5).EQ.0) THEN

C  Read betas from file TAPE2 in DWUCK.

	    JTRMAX=JTR(1)
	    DO 10 KK=1,NLTR
	    KKIND=(KK-1)*JS*JR
	    MPLUS=JTR(KK)/2+1
	    JTRMAX=MAX0(JTR(KK),JTRMAX)
	    DO 10 J=1,JS
	    JIND=(J-1)*JR
	    DO 10 I=1,JR
	    IND=KKIND+JIND+I-1
	    LLI=IND*LP
	    DO 10 LL=1,LP
	    LLI=LLI+1
	    READ(2,117) L,(FL(LLI,K),K=1,MPLUS)
	    IF (ICO(7).EQ.1) WRITE(LUNOUT,117) L,(FL(LLI,K),K=1,MPLUS)
10	    CONTINUE

C  Read scattering amplitudes D from file TAPE2 in CHUCK.
C  ICON(8) in CHUCK should be equal to state number.

	  ELSEIF(ICO(5).EQ.1) THEN
	    KST1 = JR * LF1 * JS
	    DO 11 KK=1,NCH
	    KIND=KK-1
	    KST=KST1*(JB(NCH)+1)
	    LLI=KIND*LP
	    DO 11 LL=1,LP
	    LLI=LLI+1
	    READ(2,117) L,(FLC(LLI,K),K=1,KST)
	    IF (ICO(7).EQ.1) WRITE(LUNOUT,117) L,(FLC(LLI,K),K=1,KST)
11	    CONTINUE

C  Read m-state amplitudes from DWBA82.

	  ELSEIF(ICO(5).EQ.2) THEN
	    LLI=1
	    DO 12 KK=1,NLTR
	    MPLUS=2*(JTR(KK)+2)
	    DO 12 LL=1,MPLUS
	    READ(2,118) FL(LLI,1)
	    IF(ICO(7).EQ.1) WRITE(LUNOUT,118) FL(LLI,1)
	    LLI=LLI+1
12	    CONTINUE
	  ENDIF
	ENDIF

C  Read card 7. Polar angle for scat. partile and azimuthal and recoil angles
C		for decay particle.

	READ(5,*) ANG,PHID,RECANG,RECPHI,RECPSI
	XPHID=PHID
	XXANG=ANG

C  Read card 8. Polar and azimuthal opening angles for the ejectile detector
C		in the center of mass.

	READ(5,*) OPAN,STEPA,OPP,STEPP
	IF(RECANG.NE.0..OR.RECPHI.NE.0..OR.RECPSI.NE.0.) OPP=0.
	IF(STEPA.LT.1.0D-10) THEN
	  ICOUNT1 = 1
	ELSE
	  ICOUNT1 = 2*NINT(OPAN/(2*STEPA))
	  STEPA = OPAN/ICOUNT1
	ENDIF
	IF(STEPP.LT.1.0D-10) THEN
	  ICOUNT2 = 1
	ELSE
	  ICOUNT2 = NINT(OPP/STEPP) + 1
	  IF(OPP.EQ.360.) ICOUNT2=ICOUNT2-1
	ENDIF

C  Read cards 9. Experimental data.

	IF (M1.GT.0) READ(5,*) (AN1(I),PH1(I),C1(I),EC1(I),I=1,N1)

C  Read card 10. Vert. scale and horiz. scale for decay angular correlations.

	READ(5,*) NPLOT,NANGP
	NANGP=MIN(NANGP,181)
	WRITE(LUNOUT,121) NPLOT,NANGP
	DANGP=180./DFLOAT(NANGP-1)

	IF(INDANG.EQ.0.AND.ITIME.EQ.1) THEN
	  LUNOUT=1
	  OPEN(UNIT=1,STATUS='UNKNOWN',FILE='ANGCOR.LIS')
	  IPAR=0
	  DO N=1,NCH
	    DO I=1,NLDEC(N)
	      IPAR=IPAR+1
	      IF(ERR(IPAR).NE.0.0) THEN
		DELTA(N,I)=PARA(IPAR)
	      ELSE
		PARA(IPAR)=DELTA(N,I)
	      ENDIF
	    ENDDO
	  ENDDO
	  IF(NCH.GT.1) THEN
	    DO N=1,NCH-1
	      IPAR=IPAR+1
	      IF(ERR(IPAR).NE.0.0) THEN
		RSCALE(N)=PARA(IPAR)
	      ELSE
		PARA(IPAR)=RSCALE(N)
	      ENDIF
	    ENDDO
	  ENDIF
	  GO TO 1000
	ELSE
	  GO TO 1000
	ENDIF
	ENTRY AGCRHLP
	OPEN(UNIT=1,STATUS='UNKNOWN',FILE='ANGCOR.LIS')
	  IPAR=0
	  DO N=1,NCH
	    DO I=1,NLDEC(N)
	      IPAR=IPAR+1
	      DELTA(N,I)=PARA(IPAR)
	    ENDDO
	  ENDDO
	  IF(NCH.GT.1) THEN
	    DO N=1,NCH-1
	      IPAR=IPAR+1
	      RSCALE(N)=PARA(IPAR)
	    ENDDO
	  ENDIF
1000	CONTINUE

	IF (OPAN.GT.1.D-10) THEN
	  ANG=XXANG-OPAN*0.5
	  IF(ANG.LT.0.0) THEN
	    ANG=0.0
	    ICOUNT1=ICOUNT1/2
	  ENDIF
	  ANG=ANG+STEPA/2.

C  Remember STEPA has been changed to make ICOUNT1 even.

	  WRITE(LUNOUT,119) OPAN,STEPA
	ENDIF
	IF (OPP.GT.1.D-10) THEN
	  PHID=XPHID-OPP*0.5
	  WRITE(LUNOUT,120) OPP,STEPP
	ENDIF

	IF(ICO(1).EQ.1.OR.ICO(1).EQ.2) THEN
	  DO 13 K=1,NCH
	  IF(NLDEC(K).EQ.1) THEN
	    DELTA(K,1)=1.
	  ELSE
	    DTEMP(K)=0.
	    DO 14 I=1,NLDEC(K)
14	    DTEMP(K)=DTEMP(K)+DELTA(K,I)**2
	    DTEMP(K)=SQRT(DTEMP(K))
	    DO 15 I=1,NLDEC(K)
15	    DELTA(K,I)=DELTA(K,I)/DTEMP(K)
	  ENDIF
13	  CONTINUE
	ENDIF

	DO 16 I=1,NANGP
16	SIGTOT(I) = 0.
	DO 17 I=1,N1
17	TH1TOT(I) = 0.
	TTOT = 0.
	DO N=1,NCH
	  TI_INT(N) = 0.
	ENDDO
	SSINT = 0.

C  Begining of the loop to average over ejectile opening angle.

	DO 1001 IC=1,ICOUNT1

	WRITE(LUNOUT,116)
	ISKIP=0
	IF(ICO(6).EQ.1.AND.ANG.EQ.XANG) THEN
	  ISKIP=1
	  IF(INDROT.EQ.1.AND.ICO(9).EQ.0) ISKIP=0
	ENDIF
	IF(ICO(6).EQ.1.AND.ICO(5).EQ.2.AND.ANG.NE.XANG) STOP 'BY'
	XANG=ANG
	IF(ISKIP.EQ.1) GO TO 1002

	SINT=SIN(ANG/57.295779)
	DO 18 M=1,M_HALF*MAX_LTR
	DO 18 J=1,MAX_MS
	DO 18 I=1,MAX_MS
	SUM(J,I,M)=(0.,0.)
18	CONTINUE
	DO 19 M=1,M_HALF
	TS(M)=0.
19	CONTINUE
	T =0.
	T1=0.
	DO N=1,NCH
	  TI(N) = 0.
	ENDDO
	IF(ICO(5).EQ.0.OR.ICO(5).EQ.2) THEN
	  MT=0
	  IF(ICO(5).EQ.0) THEN
	    NPLUS=(JTRMAX+ISA+ISB)/2+1
	    CALL PLM(ANG,LP,NPLUS)
	  ENDIF
	  IND=0
	  IF (OPAN.LT.1.D-6) WRITE(LUNOUT,122)
	  DO 20 KK=1,NLTR
	  XJ=SQRT(DFLOAT(JTR(KK)+1))
	  MPLUS=JTR(KK)/2+1
	  BLSJK=BLSJ(1)
	  IF(ICO(4).EQ.1.AND.KK.EQ.2) BLSJK=BLSJ(2)
	  KKIND=(KK-1)*JS*JR
	  DO 21 M=1,MPLUS
	  MK=M+M-1
	  MM=MT+M
	  SQ=0.
	  ISS2=-ISB
	  DO 22 J=1,JS
	  JIND=(J-1)*JR
	  ISS1=-ISA
	  DO 23 I=1,JR

C  ML=M(Satchler)=MA-MB+Mma-Mmb

	  ML=(MK-1+M2K+ISS2-ISS1)/2
	  PHAS=1.
	  IF(ICO(5).EQ.0) THEN

C  IF(ML.GT.0) PHAS=PAR(ML)   [in DWUCK].
C  Notice that the following phase is different from DWUCK.
C  This phase gives the correct position of the symmetry axis.

	    IF(ML.LT.0) PHAS=PAR(ML)
	    ML=IABS(ML) + 1
	    F=(0.,0.)
	    IND=KKIND+JIND+I-1
	    LLI=IND*LP
	    DO 24 LL=1,LP
	    LLI=LLI+1
	    F=F+FL(LLI,M )*PL(LL,ML)
24	    CONTINUE
	    F=F*BLSJK/XJ

C   2			2
C  B    of DWUCK, also A   of Satchler, are proportional to
C   L0L			L0L
C  beta**2/(2*L+1) in vibrational model or beta**2*CG(JB,L,K,0,JA,K)**2
C  in rotational model, where beta is the deformation parameter.

	    SUM(J,I,MM)=SUM(J,I,MM)+F*PHAS

C						   M,MB,MA
C  SUM(J,I,MM) as defined here are the same as beta	  (ka,kb)
C						   LSJ
C  as defined by Satchler Nucl.Phys. 55(1964)1.


C  For DWBA82.

	  ELSE
	    IND=IND+1
	    IF(ISS2.LT.0) PHAS=PAR(ML)

C  Factor of SQRT(5) is to give same cross sections as DWBA82.

	    SUM(J,I,MM)=SQRT(5.)*PHAS*FL(IND,1)/XJ
	    F=SUM(J,I,MM)
	  ENDIF
	  IF (OPAN.LT.1.D-6) WRITE(LUNOUT,123) J,I,MM,SUM(J,I,MM)
	  SQ=SQ+DREAL(F)**2+DIMAG(F)**2
	  ISS1=ISS1+2
23	  CONTINUE
	  ISS2=ISS2+2
22	  CONTINUE

C  Assume each L,S transfer is different for different J transfers
C  sum over M incoherently.

	  IF(ICO(1).EQ.3) THEN
	    XJTR=DFLOAT(JTR(KK))/2.
	    XFIS=CG(XJA,XKA,XJTR,XKJ,XJB(1),XKB)*SQRT(DFLOAT(LF1)/
     1           XJBB(1))
	  ENDIF
	  IF(ICO(4).EQ.0) THEN
	    TS(M)=TS(M)+SQ*XJBB(1)*XFIS*XFIS
	  ELSE
	    IF(KK.EQ.1) THEN
	      TS(M)=TS(M)+SQ*XJBB(KK)
	    ELSE
	      TS(M)=TS(M)+SQ*XJBB(KK)*RSCALE(KK-1)
	    ENDIF
	  ENDIF
21	  CONTINUE
	  MT=MT+MPLUS
20	  CONTINUE
	ELSE
	  JBMAX=JB(1)
	  IF(NCH.GT.1) THEN
	    DO N=2,NCH
	      JBMAX=MAX0(JBMAX,JB(N))
	    ENDDO
	  ENDIF
	  NPLUS=JA+JBMAX+ISA+ISB
	  IF (OPAN.LT.1.D-6) WRITE(LUNOUT,124)
	  CALL PLM(ANG,LP,NPLUS)
	  MT=0
	  DO 25 KK=1,NCH
	  KIND=KK-1
	  IND = 1
	  MA=-JA
	  DO 26 MSA=1,LF1
	  MB=-JB(KK)
	  DO 27 MSB=1,LF2(KK)
	  SQ=0.
	  JIND=MSB*(MSA-1)+MSB+MT
	  IS1=-ISA
	  DO 28 I=1,JR
	  IS2=-ISB
	  DO 29 J=1,JS
	  ML=(IS1-IS2+MA-MB)/2

C  Notice that the following phase is extra to CHUCK m-state population
C  amplitudes. It gives the correct position of the symmetry axis.

	  PHAS = PAR(ML)
	  ML=IABS(ML)+1
	  F=(0.,0.)
	  LLI=KIND*LP
	  DO 30 LL=1,LP
	  LLI=LLI+1
	  F=F+FLC(LLI,IND)*PL(LL,ML)
30	  CONTINUE
	  SUM(J,I,JIND) = SUM(J,I,JIND) + F*PHAS
	  IF (OPAN.LT.1.D-6) WRITE(LUNOUT,125) MA,MB,IS1,IS2,
     1                                         SUM(J,I,JIND)
	  SQ=SQ+DREAL(F)**2+DIMAG(F)**2
	  IND=IND+1
	  IS2=IS2+2
29	  CONTINUE
	  IS1=IS1+2
28	  CONTINUE
	  TS(MSB)=TS(MSB)+SQ
	  MB=MB+2
27	  CONTINUE
	  MA=MA+2
26	  CONTINUE
	  MT=MT+LF1*LF2(KK)
25	  CONTINUE
	ENDIF
	IF(ICO(5).EQ.0.OR.ICO(5).EQ.2) THEN
	  MPLUS=JTRMAX/2+1
	  IF(ICO(5).EQ.2) THEN
	    MPLUS=JTR(1)/2+1
	    IF(ICO(4).NE.0) THEN
	      DO N=2,NCH
		MPLUS=MAX0(MPLUS,JTR(N)/2+1)
	      ENDDO
	    ENDIF
	  ENDIF
	  DO 31 M=1,MPLUS
	  SQ=0.
	  IF(ICO(4).NE.0) THEN
	    DO N=1,NCH
	      ZQ(N)=0.
	    ENDDO
	  ENDIF
	  DO 32 J=1,JS
	  DO 32 I=1,JR
	  IND=M
	  SSQ=(0.,0.)

C  Sum coherently over L,S for the same J transfer.

	  DO 33 LSJ=1,NLTR
	  ZZQ(LSJ)=0.
	  IF(M.LE.JTR(LSJ)/2+1) THEN
	    IF(ICO(1).EQ.3) THEN
	      XJTR=FLOAT(JTR(LSJ))/2.
	      XFIS=CG(XJA,XKA,XJTR,XKJ,XJB(1),XKB)
     1           *SQRT(DFLOAT(LF1)/XJBB(1))
	    ENDIF
	    SSQ=SSQ+SUM(J,I,IND)*XFIS
	    IF(ICO(4).NE.0) ZZQ(LSJ)=DREAL(SUM(J,I,IND))**2
     1 			    +DIMAG(SUM(J,I,IND))**2
	  ENDIF
	  IND=IND+JTR(LSJ)/2+1
33	  CONTINUE
	  SQ=SQ+DREAL(SSQ)**2+DIMAG(SSQ)**2
	  IF(ICO(4).NE.0) THEN
	    DO N=1,NCH
	      ZQ(N)=ZQ(N)+ZZQ(N)
	    ENDDO
	  ENDIF
32	  CONTINUE
	  SQ=SQ*XJBB(1)
	  IF(ICO(4).NE.0) THEN
	    ZQ(1)=ZQ(1)*XJBB(1)
	    DO N=2,NCH
	      ZQ(N)=ZQ(N)*XJBB(N)*RSCALE(N-1)
	    ENDDO
	  ENDIF

C  for M.NE.0 the m-state population cross section is double because
C  of alignment.

	  IF(M+M2K.NE.1) THEN
	    SQ=SQ+SQ
	    TS(M)=TS(M)+TS(M)
	    IF(ICO(4).NE.0) THEN
	      DO N=1,NCH
		ZQ(N)=ZQ(N)+ZQ(N)
	      ENDDO
	    ENDIF
	  ENDIF
	  T=T+SQ
	  T1=T1+TS(M)
	  IX=M-1

C  For the next 3 write statements (IX) is the projection of JTR the
C  total angular momentum transfer on the z-axis.

	  IF(ICO(4).NE.0) THEN
	    DO N=1,NCH
	      TI(N)=TI(N)+ZQ(N)
	    ENDDO
	  ENDIF
	  IF (ICO(8).EQ.0) THEN
	    WRITE(LUNOUT,126) IX,TS(M)
	    IF(ICO(4).NE.0) THEN
	      WRITE(LUNOUT,126) IX,(ZQ(N),N=1,NCH)
	    ELSE
	      WRITE(LUNOUT,126) IX,SQ
	    ENDIF
	  ENDIF
31	  CONTINUE
	ELSE
C+++++++This section has still to be checked to see if things are properly 
C	done concerning the calculation of M-substates for the various
C	intermediate channels calculated from D-amplitudes of CHUCK

	  MT=0
	  DO 34 KK=1,NCH
	  KIND=KK-1
	  MB=-JB(KK)
	  DO 35 MSB=1,LF2(KK)
	  SQ=0.
	  DO N=1,NCH
	    ZQ(2)=0.
	  ENDDO
	  DO 36 MSA=1,LF1
	  JIND=(MSA-1)*MSB+MSB+MT
	  DO 36 J=1,JS
	  DO 36 I=1,JR
	  F=SUM(J,I,JIND)
	  SQ=SQ+DREAL(F)**2+DIMAG(F)**2
36	  CONTINUE
	  T1=T1+TS(MSB)

C  For the next 3 write statements (MB) is the projection of JB the
C  spin of the intermediate state on the z-axis.

	  WRITE(LUNOUT,126) MB,TS(MSB)
	  IF(ICO(4).NE.0) THEN
	    ZQ(KK)=ZQ(KK)+SQ
	    DO N=1,NCH
	      TI(N)=TI(N)+ZQ(N)
	    ENDDO
	    WRITE(LUNOUT,126) MB,(ZQ(N),N=1,NCH)
	  ELSE
	    T=T+SQ
	    WRITE(LUNOUT,126) MB,SQ
	  ENDIF
	  MB = MB + 2
35	  CONTINUE
	  MT=MT+LF1*LF2(KK)
34	  CONTINUE
	ENDIF
C+++++++

1002	CONTINUE
	IF(ICO(4).NE.0) THEN
	  T=TI(1)
	  DO N=2,NCH
	    R(N-1)=TI(1)/TI(N)
	    T=T+TI(N)
	  ENDDO
	  IF (ICO(8).EQ.0) THEN
	    N=1
	    WRITE(LUNOUT,127) ANG,N,TI(N)
	    DO N=2,NCH
	      WRITE(LUNOUT,127) ANG,N,TI(N)
	      WRITE(LUNOUT,128) ANG,N,RSCALE(N-1),N,R(N-1)
	    ENDDO
	  ENDIF
	ENDIF

C  T  is   coherent sum of scattering amplitudes.
C  T1 is incoherent sum of scattering amplitudes.

	IF (ICO(8).EQ.0) THEN
	  WRITE(LUNOUT,129) ANG,T
	  WRITE(LUNOUT,129) ANG,T1
	ENDIF

	IF(ISKIP.EQ.1) GO TO 1003

C  Replaced the next line by the one following it because the next time
C  around the RSUM'S were not calculated (M.N.H. 19 September 1984).
C	IF(ICO(6).EQ.0.AND.ICO(5).NE.1) THEN

	IF(ICO(5).NE.1) THEN
	  MT=0
	  MTT=0
	  DO 37 KK=1,NLTR
	  LF=JTR(KK)+1
	  MJ=-JTR(KK)
	  DO 38 M2=1,LF
	  MX=IABS(MJ)/2+1
	  MXT=MX+MTT
	  MM2=M2+MT
	  MSB=-ISB
	  DO 39 J2=1,JS
	  MSA=-ISA
	  DO 40 I2=1,JR
	  IF(MJ.LT.0) THEN
	    MS2=(-MSB+ISB)/2+1
	    MS1=(-MSA+ISA)/2+1
	    PHAS=PAR((MJ+MSB-MSA+JTR(KK)+2*LTR(KK)+ISB-ISA)/2)
	  ELSE
	    MS2=J2
	    MS1=I2
	    PHAS=1.
	  ENDIF
	  RSUM(J2,I2,MM2)=SUM(MS2,MS1,MXT)*PHAS
	  MSA=MSA+2
40	  CONTINUE
	  MSB=MSB+2
39	  CONTINUE
	  MJ=MJ+2
38	  CONTINUE
	  MTT=MTT+JTR(KK)/2+1
	  MT=MT+LF
37	  CONTINUE
	  MT=MT+1
	  DO 41 M2=1,MT
	  DO 41 J2=1,JS
	  DO 41 I2=1,JR
	  SUM(J2,I2,M2)=RSUM(J2,I2,M2)
41	  CONTINUE
	ENDIF

1003	CONTINUE

C  This section rotates the m-state population amplitudes to the recoil
C  center of mass system.

	IF(ISKIP.EQ.0) THEN
	  IF(ICO(9).EQ.0) THEN
	    INDROT=0
	    GO TO 42
	  ENDIF
	ELSE
	  IF(INDROT.EQ.1.AND.ICO(9).EQ.1) THEN
	    WRITE(LUNOUT,130) RECANG
	    GO TO 42
	  ELSEIF(ICO(9).EQ.0) THEN
	    INDROT=0
	    GO TO 42
	  ENDIF
	ENDIF
	IF(ICO(5).EQ.2) THEN
	  RECTEMP=RECANG
	  RECANG=RECANG+ANG
	ENDIF
	MT=0
	RPHI=RECPHI/57.295779
	RPSI=RECPSI/57.295779
	DO 43 KK=1,NLTR
	LF=JTR(KK)+1
	IM=-JTR(KK)
	DO 44 M1=1,LF
	MM1=MT+M1
	CALL DJMK(-RECANG,RPHI,RPSI,JTR(KK),IM,DJ)
	IMB=-ISB
	DO 45 J1=1,JS
	CALL DJMK(-RECANG,RPHI,RPSI,ISB,IMB,DSB)
	IMA=-ISA
	DO 46 I1=1,JR
	CALL DJMK(-RECANG,RPHI,RPSI,ISA,IMA,DSA)
	RSUM(J1,I1,MM1)=(0.,0.)
	DO 47 M2=1,LF
	MM2=MT+M2
	XDJ=DCMPLX(DREAL(DJ(M2)),-DIMAG(DJ(M2)))
	DO 47 J2=1,JS
	XDSB=DCMPLX(DREAL(DSB(J2)),-DIMAG(DSB(J2)))
	DO 47 I2=1,JR
	RSUM(J1,I1,MM1)=RSUM(J1,I1,MM1)+SUM(J2,I2,MM2)
     1 *XDJ*XDSB*DSA(I2)
47	CONTINUE
	IMA=IMA+2
46	CONTINUE
	IMB=IMB+2
45	CONTINUE
	IM=IM+2
44	CONTINUE
	MT=MT+LF
43	CONTINUE
	DO 48 KK=1,MT
	DO 48 J2=1,JS
	DO 48 I2=1,JR
	SUM(J2,I2,KK)=RSUM(J2,I2,KK)
48	CONTINUE
	IF(ICO(5).EQ.2) RECANG=RECTEMP
	WRITE(LUNOUT,130) RECANG
	INDROT=1
42	CONTINUE

	IF(ICO(1).EQ.0.OR.ICO(1).EQ.2) THEN
	  CALL RHOMM
	  IF (OPAN.LT.1.D-6) THEN
	    MB=-JB(1)
	    DO 49 I=1,LF2(1)
	    SQ=FPP(I,I)

C  In the following write statement (M) is the projection of JB the
C  spin of the intermediate state on the z-axis.

	    WRITE(LUNOUT,131) MB,SQ
	    MB=MB+2
49	    CONTINUE
	  ENDIF
	ENDIF

	TSINT=T*SINT
	IF(IC.GT.1) PHID=XPHID-OPP*0.5
	DO 1004 JCC=1,ICOUNT2
	WRITE(LUNOUT,132) ANG,PHID
	PHI=PHID/57.295779
	IF(ICO(1).EQ.1.OR.ICO(1).EQ.3) THEN
	  CALL PARCOR(PHI,T)
	ELSEIF(ICO(1).EQ.0.OR.ICO(1).EQ.2) THEN
	  CALL GAMCOR(ANG,PHI)
	ENDIF

C  Weight the angular correlations with the cross section.

	DO 50 NP=1,NANGP
	SIGTOT(NP)=SIGTOT(NP)+SIG(NP)*TSINT
50	CONTINUE
	DO 51 NP=1,N1
	TH1TOT(NP)=TH1TOT(NP)+TH1(NP)*TSINT
51	CONTINUE
	PHID=PHID+STEPP
1004	CONTINUE
	TTOT=TTOT+ICOUNT2*TSINT
	SSINT=SSINT+ICOUNT2*SINT
	IF(ICO(4).NE.0) THEN
	  DO N=1,NCH
	    TI_INT(N)=TI_INT(N)+ICOUNT2*TI(N)*SINT
	  ENDDO
	ENDIF
	ANG=ANG+STEPA
1001	CONTINUE
	IF(ICOUNT1.GT.1.OR.ICOUNT2.GT.1) WRITE(LUNOUT,133)
	IF(SSINT.NE.0.) THEN
	  T = TTOT/SSINT
	  IF(ICO(4).NE.0) THEN
	    DO N=1,NCH
	      TI(N) = TI_INT(N)/SSINT
	    ENDDO
	  ENDIF
	ENDIF
	IF(ICO(4).EQ.0) THEN
	  WRITE(LUNOUT,134) T
	ELSE
	  WRITE(LUNOUT,135) TI(1),T
	  DO N=2,NCH
	    WRITE(LUNOUT,136) N,TI(N),N,TI(1)/TI(N)
	  ENDDO
	ENDIF
	IF(N1.EQ.0) GO TO 52
	IF(SSINT.NE.0.) THEN
	  DO 53 NP=1,N1
	  TH1(NP)=TH1TOT(NP)/TTOT
53	  CONTINUE
	ENDIF
	S1 = 0.
	S2 = 0.
	DO 54 I = 1, N1
	E = EC1(I) * EC1(I)
	S1 = S1 + C1(I) * TH1(I) / E
	S2 = S2 + TH1(I) * TH1(I) / E
54	CONTINUE
	C = S1 / S2
	CHI = 0.
	DO 55 I=1,N1
	S3(I) = (C1(I)-C*TH1(I))/EC1(I)
55	CHI = CHI + S3(I)*S3(I)
	IF (ICO(8).NE.0) THEN
	  IF(ICO(1).EQ.0.OR.ICO(1).EQ.2) THEN
	    IF(NC.EQ.1) THEN
	      WRITE(LUNOUT,137) CHI
	    ELSEIF(NC.EQ.2) THEN
	      WRITE(LUNOUT,138) CHI
	    ELSEIF(NC.EQ.3) THEN
	      WRITE(LUNOUT,139) CHI
	    ENDIF
	  ELSE
	    WRITE(LUNOUT,140) CHI
	  ENDIF
	ELSE
	  WRITE(LUNOUT,141) C,CHI
	  WRITE(LUNOUT,142) (AN1(I),PH1(I),C1(I),C*TH1(I),C1(I)/C,
     1  TH1(I),S3(I)*S3(I), I=1,N1)
	ENDIF
52	CONTINUE
	IF(SSINT.NE.0.) THEN
	  DO 56 NP=1,NANGP
	  SIG(NP)=SIGTOT(NP)/TTOT
56	  CONTINUE
	ENDIF

	CALL PLOT
	IF (INDANG.EQ.1) GO TO 2
	CLOSE(UNIT=1)
	RETURN
99	STOP

100	FORMAT(20A4)
101	FORMAT(1H1,20A4)
102	FORMAT(1H0,' 9*ICO = ',9I1)
103	FORMAT(1H0,' LMAX= ',I3,' ISA= ',I3,' JA= ',I3,' ISB= ',I3,
     1 ' [JB(N),ISTR(N)],N=1,',I1,' : ',10(I3,1H,))
104	FORMAT(1H0,I3,'*LTR,',I2,'*JTR = ',16(I3,1H,))
105	FORMAT(1H0,//,'   P A R T I C L E   D E C A Y',//)
106	FORMAT(1H0,' JC =',I3,'   ISC =',I3,'   NLDEC(1)=',I3,
     1 /23X,'NLDEC(2)=',I3)
107	FORMAT(1H0,' INTERMEDIATE STATE =',I3)
108	FORMAT(' NLDEC =',I3,'    LDEC =',I3,'   JDEC =',I3)
109	FORMAT(1H0,'GAMMA-RAY DECAY - - - CASCADE HAS',I3,
     1 '  TRANSITIONS')
110	FORMAT(1H0,'  JC =',I3,'     LBC =',I3,' AND',I3)
111	FORMAT(1H0,'  JD =',I3,'     LCD =',I3,' AND',I3)
112	FORMAT(1H0,'  JE =',I3,'     LDE =',I3,' AND',I3)
113	FORMAT(1H0,//,' ATTENUATION COEFFICIENTS :',//,' Q(2) =',F10.5,
     1 '    Q(4) =',F10.5,'    Q(6) =',F10.5)
114	FORMAT(1H0,//,'   F I S S I O N   D E C A Y',//)
115	FORMAT(1H0,'   KA =',I3,'    KB =',I3)
116	FORMAT('1')
117	FORMAT(I4,10E12.5/(4X,10E12.5))
118	FORMAT(2E12.5)
119	FORMAT(' OPENING POLAR ANGLE= ',F5.1,'  STEP SIZE
     1    = ',F7.3)
120	FORMAT(' OPENING AZIMUTHAL ANGLE = ',F5.1,'  STEP SIZE
     1    = ',F7.3)
121	FORMAT(1H0,' NPLOT= ',I3,' NANGP= ',I3)
122	FORMAT(1H0,'  J   I   M      REAL BETA     IMAG BETA')
123	FORMAT(3I4,2F15.6)
124	FORMAT(1H0,'  MA  MB IS1 IS2     REAL SIG      IMAG SIG')
125	FORMAT(4I4,2F15.6)
126	FORMAT(' M=',I3,'   SIGMA(M)=',5E12.4)
127	FORMAT(' PROJ. SCATT. ANG.= ',F5.1,'  CHAN ',I1,'-SIGMA=',E12.4)
128	FORMAT(' PROJ. SCATT. ANG.= ',F5.1,'  RSCALE(',I1,') = ',E12.4,
     1 '  SIG1/SIG',I1,' = ',E12.4)
129	FORMAT(' PROJ. SCATT. ANG.= ',F5.1,'  TOTAL-SIGMA=',E12.4)
130	FORMAT(1H0,'  ANGULAR CORRELATION TRANSFORMED TO THE RECOIL AXIS
     1  SYSTEM , RECOIL ANGLE = ',F7.2)
131	FORMAT(' M=',I3,'/2    SIGMA(M)=',E12.4)
132	FORMAT(//,' SCATT. ANGLE     = ',F5.1,'  AZIM. DECAY ANGLE = '
     1 ,F6.1)
133	FORMAT('1AVERAGE OVER ALL ANGLES')
134	FORMAT( ' SIGTOT = ',E12.4)
135	FORMAT( ' SIG1 = ',E12.4,' SIGTOT = ',E12.4)
136	FORMAT( ' SIG',I1,' = ',E12.4,' SIG1/SIG',I1,' = ',E12.4)
137	FORMAT(1H+,20X,'  CHI2 =',F8.3)
138	FORMAT(1H+,40X,'  CHI2 =',F8.3)
139	FORMAT(1H+,60X,'  CHI2 =',F8.3)
140	FORMAT(1H+,70X,'  CHI2 =',F8.3)
141	FORMAT(1H ,//,
     1 '   THETA      PHI      EXP      THEOR*C     EXP/C',
     1 '     THEOR     CHI2     C =',F10.3,'  CHI2TOT =',F7.3,/)
142	FORMAT(7F10.3)
	END

	program tciolink

C This is a non-functional program that merely serves to verify
C that linking against the cio library leaves no unresolved references.

	CALL CIO1ST	    	!cio1st.f
	CALL CIOD           !ciox.f
	CALL CIOIX          !ciox.f
	CALL CIOBX          !ciox.f
	CALL CIODX          !ciox.f
	CALL CIOI           !ciox.f
	CALL CIOB           !ciox.f
	CALL CIOAX          !ciox.f
	CALL CIOL           !ciox.f
	CALL CIOA           !ciox.f
	CALL CIOF           !ciox.f
	CALL CIOFX          !ciox.f
	CALL CIOS           !ciox.f
	CALL CIOX           !ciox.f
	CALL CIOLX          !ciox.f
	CALL CIOSX          !ciox.f
	CALL CIOQI          !cioqx.f
	CALL CIOQS          !cioqx.f
	CALL CIOQF          !cioqx.f
	CALL CIOQENTRY      !cioqx.f
	CALL CIOQLX         !cioqx.f
	CALL CIOQIX         !cioqx.f
	CALL CIOQFX         !cioqx.f
	CALL CIOQL          !cioqx.f
	CALL CIOQSX         !cioqx.f
	CALL CIOQCO         !cioqco.f
	CALL CIOQLU         !cioqlu.f
	CALL CIOPRM         !cioprm.f
	CALL CIODSS         !ciodss.f
	CALL CIOERL         !cioerl.f
	CALL CIOGBF         !ciogbf.f
	CALL CIOCMX         !ciocmx.f
	CALL CIO_COPY_I     !ciomov.f
	CALL CIO_COPY_D     !ciomov.f
	CALL CIO_COPY_L     !ciomov.f
	CALL CIO_COPY_S     !ciomov.f
	CALL CIOPAB         !ciopab.f
	CALL CIOMSG         !ciomsg.f
	CALL CIO_COPY_F     !ciomov.f
	CALL CIOQPU         !cioqpu.f
	CALL CIOAIF         !cioaif.f
	CALL CIOWRT         !ciowrt.f
	CALL CIOHLPINI      !ciohlp.f
	CALL CIOTBE         !ciotbe.f
	CALL CIOQSH         !cioqsh.f
	CALL CIOAIC         !cioaif.f
	CALL CIOERR         !cioerl.f
	CALL CIOYNL         !cioynl.f
	CALL CIOPUR         !ciobuf.f
	CALL CIOERS         !cioerl.f
	CALL CIOINV         !cioinv.f
	CALL CIOLUN         !ciolun.f
	CALL CIO_COPY_B     !ciomov.f
	CALL CIOLUP         !ciolup.f
	CALL CIOCMD         !ciocmd.f
	CALL CIOBUF         !ciobuf.f
	CALL CIOMOD         !ciomod.f
	CALL CIOGIT         !ciogit.f
	CALL CIOLIT         !ciolit.f
	CALL CIOHLP         !ciohlp.f
	CALL CIOLUNGET      !ciolunpool.f
	CALL CIOLUNFREE     !ciolunpool.f

	END

	SUBROUTINE FACTOR(L,M,F)
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES FACTOR [(L+M)!/(L-M)!]

	F=1.
	IF(M.EQ.0) RETURN
	I=L-M
	J=L+M
	F=FAC(J)/FAC(I)
c        write(*,*)'***',FAC(J),FAC(I),J,I
	RETURN
	END

	FUNCTION UK(XK,A,B,C)
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES U-COEFFICIENTS FOR UNOBSERVED TRANSITIONS

	UK=1.
	IF(XK.EQ.0.0)RETURN
	N=NINT(A+B-C)
	UK=PAR(N)*W(A,B,A,B,C,XK)*SQRT((2.*A+1.)*(2.*B+1.))
	RETURN
	END

	SUBROUTINE CIOQCO
C++
C TITLE:  CIOQCO
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Complete qualifier scan.
C PROCEDURES CALLED:
C	CIO1ST, CIOGBF, CIOLIT, CIOQLU, CIOQSH
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE: 13-may-1981
C MODIFIED BY:
C FUNCTIONAL DESCRIPTION:
C	Extract remaining qualifiers from the
C	input buffer until a non-qualifier is encountered.
C	If an undefined or ambiguous qualifier is found, display a message,
C	and proceed as usual (abort if batch, continue if interactive).
C	On errors try to recover.
C	Note that HELP and ? are intercepted in a slightly different
C	from the normal way.
C CALLING SEQUENCE:
C	CALL CIOQCO
C--

	INCLUDE		'ciocom.inc'
	LOGICAL		LQUOTE, LQUALERR
	CHARACTER*4	CTEMP
	INTEGER		INPTR_TMP, I1, I2

	CALL CIO1ST			! once only initialize.

C Extract items until non-qualifier or end-of-line found.

	LQUALERR = .FALSE.
  250	INPTR_TMP = INPTR			! Use temp INBUF pointer
	CALL CIOLIT (INPTR_TMP, I1, I2, LQUOTE, *299)	! Locate next item.
	ITPTR1 = I1				! Store pointers for CIOERL
	ITPTR2 = I2
	CALL CIOQLU (I1, I2, *270, *255, *260)	! See if item qualifier,
  255	LQUALERR = .FALSE.			! if yes, lookup and update
						! associated variable,
						! complain and return if
						! ambiguous or unknown qual.
	INPTR = INPTR_TMP			! On succes update pointer and
	GOTO 250				! loop to try next item.

C Item is a qualifier but some error occurred (unknown, ambiguous,
C value required, missing, not allowed or outside limits).

  260	LQUALERR = .TRUE.			! remember
	CALL CIOGBF				! get input, don't prompt
	GOTO 250				! get next item

C Item is not a qualifier. Only if we just had a qualifier error
C see if the item is a single question mark and if so show the legal
C qualifiers, else return and leave the item for later interpretation.

  270	IF (LQUALERR) THEN
	  IF (INBUF(I1:I1).EQ.'?') THEN
	    CALL CIOQSH
	    GOTO 260
	  ELSE
	    CALL STR__UPCASE (CTEMP, INBUF(I1:I1+3))
	    IF (CTEMP.EQ.'HELP') THEN
	      INPTR = INPTR_TMP	! move pointer beyond 'HELP'
	      CALL CIOHLP
	      GOTO 260
	    ENDIF
	  ENDIF
	ENDIF

  299	RETURN
	END

	SUBROUTINE CIOPAB
C++
C TITLE:  CIOPAB
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Find size of data in inputbuffer excluding possible comment field
C and continuation character. Sets flag if continuation character present.
C Reset bufferpointer and current item pointers
C ENVIRONMENT:  FORTRAN-77
C PROCEDURES CALLED:
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  29-jan-1981.
C MODIFIED BY:
C PAK 11-feb-1981 Repaired faulty logic around current-item pointers
C FUNCTIONAL DESCRIPTION:
C CALLING SEQUENCE: (only for internal use by CIO)
C	CALL CIOPAB
C IMPLICIT INPUTS AND OUTPUTS:
C	INBUF, INBUFL, INBUFC, INPTR, ITPTR1, ITPTR2 and LCONTIN in common.
C--

	INCLUDE 'ciocom.inc'

C External functions

	INTEGER LIB__SCANC

	INTEGER	K

      INPTR = 0         ! Reset inputbuffer pointer
	ITPTR1 = 0	! and current-item pointers
	ITPTR2 = 0

C      write (*,*) '?????? ciopab, inbufl, inbuf:', inbufl, inbuf

C Scan for first occurance of a comment character

	K = LIB__SCANC (INBUF(:INBUFL), C_TABLE, C_COMM)	!???g77
C      write (*,*) '?????? ciopab, k=scanc:', k
	IF (K-1) 20, 10, 30

C 1st character is comment character. No data or continuation symbol.
   10	INBUFC = 0
	LCONTIN = .FALSE.
	RETURN

C No comment symbol found.
   20	INBUFC = INBUFL
	GOTO 32

C Comment field starts at K which is not the 1st character.
   30	INBUFC = K - 1

C Trim trailing blanks and tabs from data field.
C Then if last character is continuation symbol, trim it and set flag.

C  32	CALL STR__TRIM (INBUF(:INBUFC), INBUF(:INBUFC), INBUFC)
C  replaced by:

   32 DO K = INBUFC, 1, -1
        IF (INBUF(K:K).NE.' ' .AND. INBUF(K:K).NE.CHAR(9)) GOTO 34
	END DO
   34	INBUFC = K

	LCONTIN = INBUF(INBUFC:INBUFC) .EQ. S_CONT
	IF (LCONTIN) INBUFC = INBUFC - 1

	RETURN
	END

	FUNCTION RL(N1,L1,N2,L2,L)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: RL
C FACILITY: Subprogram of RADME, TRAMP
C AUTHOR: M.N. Harakeh, KVI, Groningen, NL.
C COMMENT:
C   In this function, multiply RL by (A**(XL/6.))
C   to get the integral in units of (FM)**L
C   A = atomic mass of the nucleus
C--
C  
	N11=N1-1
	N22=N2-1
C 
	IF (PAR(L1+L2+L).NE.1.) THEN
	   RL = 0.D0
	   RETURN
	ENDIF
	S=0.D0
C  
	DO 10 K1=1,N1
	  K11=K1-1
	DO 10 K2=1,N2
	  K22=K2-1
	  T=BINOM(N11,K11)*BINOM(N22,K22)/DFAC(2*L1+2*K11+1)
	  T=T*DFAC(2*K11+2*K22+L1+L2+L+1)*PAR(K11+K22)
	  S=S+T/DFAC(2*L2+2*K22+1)
   10	CONTINUE
C  
	S=S*SQRT(DFAC(2*L1+2*N11+1)*DFAC(2*L2+2*N22+1))
	S=S/SQRT(FAC(N11)*FAC(N22))
	RL=S/SQRT(2.D0**(N11+N22+L))
	RETURN
	END
C  
	FUNCTION ANINEJ(A1,A2,A3,B1,B2,B3,C1,C2,C3)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: ANINEJ
C FACILITY: ALLJ
C PROCEDURES CALLED: SIXJ, PAR
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C  
	ANINEJ = 0.D0
C  
	X1 = MAX(ABS(A1-C3),ABS(B1-C2),ABS(A2-B3))
	X2 = MIN(A1+C3,B1+C2,A2+B3)
	N1=INT(X1)+1
	N2=INT(X2)+1
	IF (N2.LT.N1) RETURN
	AI=X1-1.
C  
	DO 10 I = N1,N2
	AI=AI+1.
	T = SIXJ(A1,B1,C1,C2,C3,AI)*SIXJ(A2,B2,C2,B1,AI,B3)
	1   *SIXJ(A3,B3,C3,AI,A1,A2)
	T = PAR(NINT(2.*AI))*(2.*AI+1.)*T
10	ANINEJ = ANINEJ+T
	RETURN
	END
C  
	FUNCTION SIXJ(A1,A2,A3,B1,B2,B3)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: SIXJ
C FACILITY: ALLJ, TRAMP
C PROCEDURES CALLED: TD
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
	SIXJ=PAR(NINT(A1+A2+B1+B2))*TD(A1,A2,A3,B1,B2,B3)
	RETURN
	END
C  
	FUNCTION W(A1,A2,B2,B1,A3,B3)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: W (RACAH COEFFICIENT)
C FACILITY: ALLJ
C PROCEDURES CALLED: TD
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
  
	W=TD(A1,A2,A3,B1,B2,B3)
	RETURN
	END
  
	FUNCTION TD(A1,A2,A3,B1,B2,B3)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: TD
C FACILITY: W, SIXJ
C PROCEDURES CALLED: BINOM, TRIREL, PAR
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C  
	D(J,L,M)=1./SQRT(BINOM(J,(J+L-M)/2)*BINOM((J+L+M)/2,J)
	1*((J+L+M)/2+1))
C  
	TD = 0.D0
	IF (MOD(A1+A2+A3,1.D0).GT.1.0E-6.OR.MOD(B1+B2+A3,1.D0)
	1 .GT.1.0E-6 .OR.MOD(A1+B2+B3,1.D0).GT.1.0E-6) RETURN
C  
	J1=NINT(2.*A1)
	J2=NINT(2.*A2)
	J3=NINT(2.*A3)
	L1=NINT(2.*B1)
	L2=NINT(2.*B2)
	L3=NINT(2.*B3)
	IF (TRIREL(J1,J2,J3).LT.0..OR.TRIREL(L1,L2,J3).LT.0.
	1 .OR.TRIREL(J1,L2,L3).LT.0..OR.TRIREL(L1,J2,L3).LT.0.) RETURN
C  
	N1=IABS(MIN(-J1-L1+J3+L3,-J2-L2+J3+L3,0))
	N2=MIN(J1+J2+L1+L2+2,J1+J2-J3,L1+L2-J3,J1+L2-L3,L1+J2-L3)
	IF (N2.LT.N1) RETURN
C  
	N1=N1/2+1
	N2=N2/2+1
	SUM = 0.D0
	JL12=(J1+L1+J2+L2)/2
C  
	DO 10 I=N1,N2
	I1=I-1
	T=BINOM((J1+J2-J3)/2,I1)*BINOM((L1+L2-J3)/2,I1)/BINOM
	1(JL12+2*I1+1,3*I1)*BINOM((J1+L2-L3)/2,I1)*BINOM((L1+J2-L3)/2
	2,I1)/BINOM(3*I1,I1)*BINOM((J2-L1+L3)/2+I1,(J1+J2-J3)/2)*BINOM
	3((L1-J2+L3)/2+I1,(L1+L2-J3)/2)/BINOM(2*I1,I1)*BINOM(L3+2*I1
	4,(J2-L1+L3)/2+I1)*BINOM(JL12-L3,(J1+L2-L3)/2)*BINOM(JL12+2*I1
	5,L3+2*I1)*(JL12+2*I1+1)
   10	SUM = SUM + PAR(I1) * T
C  
	TD=SUM*D(J1,J2,J3)*D(J1,L2,L3)*D(L1,J2,L3)*D(L1,L2,J3)
	RETURN
	END
C  
	FUNCTION TJ(A1,A2,A3,B1,B2,B3)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: TJ (3J COEFFICIENT)
C FACILITY: ALLJ, TRAMP
C PROCEDURES CALLED: TS
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C  
	TJ=PAR(NINT(A1-A2-B3))*TS(A1,B1,A2,B2,A3,-B3)
	RETURN
	END
C  
	FUNCTION CG(A1,B1,A2,B2,A3,B3)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: CG (CLEBSCH-GORDON COEFFICIENT)
C FACILITY: ALLJ
C PROCEDURES CALLED: TS
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C  
	CG=SQRT(2.*A3+1)*TS(A1,B1,A2,B2,A3,B3)
	RETURN
	END
C  
	FUNCTION TS(A1,B1,A2,B2,A3,B3)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: TS
C FACILITY: CG, TJ
C PROCEDURES CALLED: TRIREL, BINOM, PAR
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C  
	TS=0.D0
	IF (MOD(A1+A2+A3,1.D0).GT.1.0E-6) RETURN
	IF (MOD(A1-B1,1.D0).GT.1.0E-6.OR.MOD(A2-B2,1.D0).GT.
	1   1.0E-6.OR.MOD(A3-B3,1.D0).GT.1.0E-6) RETURN
	IF (MOD(2.*B3,1.D0).GT.1.0E-6) RETURN
C  
	J1=NINT(2.*A1)
	J2=NINT(2.*A2)
	J3=NINT(2.*A3)
	M1=NINT(2.*B1)
	M2=NINT(2.*B2)
	M3=NINT(2.*B3)
	IF (TRIREL(J1,J2,J3) .LT.0.) RETURN
	IF (M1+M2.NE.M3) RETURN
C  
	JM1=(J1-M1)/2
	JM2=(J2+M2)/2
	N1=IABS(MIN(J3-J2+M1,J3-J1-M2,0))
	N2=MIN(J1+J2-J3,J1-M1,J2+M2)
	IF (N2.LT.N1) RETURN
	N1=N1/2+1
	N2=N2/2+1
	S=0.D0
C  
	DO 10 I=N1,N2
	I1=I-1
	T=BINOM((J3+J1-J2)/2+I1,JM1)*BINOM((J3+J2-J1)/2+I1,JM2)/BINOM
	1(2*I1,I1)*BINOM(JM1,I1)*BINOM(JM2,I1)/BINOM(J3+2*I1,2*I1)*
	2BINOM((J1+J2-J3)/2,I1)*BINOM(J3+2*I1,(J3+J1-J2)/2+I1)
10	S=S+PAR(I1)*T
C  
	J123=(J1+J2+J3)/2
	T=BINOM(J123,J3)/(BINOM(J123,J1)*BINOM(J123,J2)*(J123+1))
	T=SQRT(T)/SQRT(BINOM(J1,(J1+M1)/2)*BINOM(J2,JM2)*BINOM
	1(J3,(J3+M3)/2))
	TS=T*S
	RETURN
	END
C  
	FUNCTION BINOM(N,M)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: BINOM
C FACILITY: ALLJ, RADME, TRAMP
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C  
	DIMENSION BN(50,25)
C  
	BINOM = 1.D0
	IF (N.EQ.0 .OR. N.EQ.M .OR. M.EQ.0) RETURN
C  
	IF (N-M.GT.M) THEN
	  I = M
	ELSE
	  I = N - M
	ENDIF
C  
	IF (N.GT.50) THEN
	  J=N-I
	  AI=0.D0
	  DO 10 K=1,I
	  AI=AI+1.D0
10	  BINOM=BINOM*(J+K)/AI
	  RETURN
	ENDIF
C  
	IF (BN(N,I).EQ.0.) THEN
	  J=N-I
	  AI=0.D0
	  DO 20 K=1,I
	  AI=AI+1.D0
20	  BINOM=BINOM*(J+K)/AI
	  BN(N,I)=BINOM
	ELSE
	  BINOM = BN(N,I)
	ENDIF
	RETURN
	END
C  
	FUNCTION FAC(N)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: FAC
C FACILITY: RADME, TRAMP
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C	
	DIMENSION F(50)
C  
	IF (N) 10,20,30
C  
10	FAC=0.D0
	RETURN
C  
20	FAC=1.D0
	RETURN
C  
30	IF (N.GT.50) THEN
	  FAC=1.D0
	  DO 31 I=1,N
31	  FAC=I*FAC
	  RETURN
	ENDIF
C  
	IF (F(N).EQ.0.) THEN
	  FAC=1.D0
	  DO 32 I=1,N
32	  FAC=I*FAC
	  F(N)=FAC
	ELSE
	  FAC=F(N)
	ENDIF
	RETURN
	END
C  
	FUNCTION DFAC(N)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: DFAC
C FACILITY: RADME, TRAMP
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C  
	DIMENSION F(50)
C  
	IF (N) 10,20,30
C  
10 	DFAC=0.D0
	RETURN 
C  
20	DFAC=1.D0
	RETURN
C  
30	IF (PAR(N).EQ.1.) GO TO 10
	IF (N.GT.50) THEN
	  DFAC=1.D0
	  DO 31 I=1,N,2
31	  DFAC=I*DFAC
	  RETURN
	ENDIF
C  
	IF (F(N).EQ.0.) THEN
	  DFAC=1.D0
	  DO 32 I=1,N,2
32	  DFAC=I*DFAC
	  F(N)=DFAC
	ELSE
	  DFAC=F(N)
	ENDIF
	RETURN 
	END
C  
	FUNCTION TRIREL(J1,J2,J3)
	IMPLICIT REAL*8(A-H,O-Z)
C++
C TITLE: TRIREL
C FACILITY: ALLJ, TRAMP
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C  
	IF (    J1+J2-J3 .LT. 0
	1 .OR.  J1-J2+J3 .LT. 0
	1 .OR. -J1+J2+J3 .LT. 0 ) THEN
	   TRIREL=-1.D0
	ELSE
	   TRIREL= 1.D0
	ENDIF
	RETURN
	END
C  
	FUNCTION PAR(N)
	IMPLICIT REAL*8(A-H,O-Z)
C--
C TITLE: PAR
C FACILITY: RADME, ALLJ, TRAMP
C AUTHOR: M.HARAKEH, KVI, GRONINGEN, NL.
C--
C  
	I=N/2
	I=2*I
	IF (I.EQ.N) THEN
	  PAR= 1.D0
	ELSE
	  PAR=-1.D0
	ENDIF
	RETURN
	END

	PROGRAM FORMF
	IMPLICIT REAL*8(A-H,O-Z)
C  
C	This program calculates the form factors for isoscalar dipole and
C	monopole transitions according to the various prescriptions of
C	Harakeh and Dieperink, Orlandini et al. and Satchler.
C	Written by M.N. Harakeh.
C  
C	COMMON R(3),AR(3),SR(3),L_MULT,AMASS,Z,A13,EPSILON
	COMMON AMASS,Z,A13,EPSILON,AR(3),R(3),SR(3),L_MULT
C	COMMON /DEF/ BETA(3),LDFRM(3),VBETA,GAMMA,BETACOR,XK
C	1           ,BETA0_DEF,BETA3_DEF
	COMMON /DEF/ VBETA,GAMMA,BETACOR,XK,BETA0_DEF,BETA3_DEF
	1           ,BETA(3),LDFRM(3)
C	Changed by JE 14.04.2010
	COMMON /INT/ DR,KR
	DIMENSION R2(3)
	CHARACTER DEF*1,KMD*2,TYPE(2)*7
	COMMON /DEFSR/ DEF
	DATA TYPE(1),TYPE(2) /'VOLUME ','SURFACE'/
	DATA LDFRM /2,4,6/
	DATA DEF /'N'/
	HBAR = 197.329
	AMU = 931.502
	PI = 3.1415927
	EPS = (4./65.+5./80.)*HBAR*HBAR/(3.*AMU)
	FACT = (3./4.)*(HBAR*HBAR/(AMU*41))**2
C  
C	Read input parameters.
C  
100	CALL CIOAX (' PR[oceed] or EX[it]:',KMD,'C',' ',)
	IF(KMD.EQ.'EX')STOP
    	CALL CIOF  (' MASS OF THE NUCLEUS :',AMASS)
	CALL CIOWRT(' WOODS-SAXON POTENTIAL;  1=VOLUME   :')
	CALL CIOI  ('                         2=SURFACE  :',INX)
	WRITE(6,1)
1	FORMAT('  DEPTH RADIUS AND DIFFUSENESS OF THE WOODS-SAXON
	1OPTICAL MODEL POTENTIAL')
	CALL CIOF  (' V or W:',V)
	CALL CIOF  (' RR/(A**1/3):',RR)
	CALL CIOF  (' AR:',ARR)
	CALL CIOF  (' MAXIMUM INTEGRATION RADIUS :',RMAX)
	CALL CIOF  (' INTEGRATION STEP :',DR)
C  
	KR=NINT(RMAX/DR)
	A13=AMASS**0.33333333
	EPSILON=EPS/(A13*A13) 
	R(2)=RR*A13
	AR(2)=ARR
	VR=V/R(2)
	VA=V/AR(2)
	VRA=VR/AR(2)
C  
	WRITE(6,2)AMASS
	WRITE(9,2)AMASS
2	FORMAT('1','                 NUCLEUS',
	1         /'              MASS :',F8.1)
	WRITE(6,3)TYPE(INX),V,RR,ARR,RMAX,DR
	WRITE(9,3)TYPE(INX),V,RR,ARR,RMAX,DR
3	FORMAT(//1X,A7,' WOODS-SAXON POTENTIAL PARAMETERS',
	1     /' DEPTH V :',F9.4,' MeV'
	2     /' RR/(A**1/3) :',F9.4,' Fm,   AR :',F6.4,' Fm'
	3     /' MAX. INTEG. RADIUS :',4X,F8.3,'   INTEG. STEP :',F5.3)
	IF(INX.EQ.1) THEN
	  CALL RFERMI(R(2),AR(2),2,R2(2))
	ELSE
	  CALL RFERMI(R(2),AR(2),1,R2_1)
	  CALL RFERMI(R(2),AR(2),-1 ,R_1)
	  R2(2)=2*R2_1/R_1
	ENDIF
C  
C	Write out form factor of Harakeh and Dieperink for isoscalar dipole
C	transition.
C  
	FX=6.
	IF(INX.EQ.2) FX=7.
	WRITE(6,4)
	WRITE(9,4)
4	FORMAT(/1X,' Harakeh-Dieperink dipole form factor for DWUCK
	1 or CHUCK'/)
	PWR=1.
	VTEMP=-VR*10
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
5	FORMAT('  FX =',F4.1,'  PWR =',F4.1,'   V =',F13.5)
	PWR=0.
	FX=FX+1.
	VTEMP=VRA*((5./3.)*R2(2)-4.*EPSILON)
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
	PWR=2.
	VTEMP=-VRA*3.
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
	PWR=1.
	FX=FX+1.
	VTEMP=-VRA*EPSILON/ARR
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
C  
C	Write out form factor of Orlandini et al. for isoscalar dipole
C	transition.
C  
	FX=6.
	IF(INX.EQ.2) FX=7.
	WRITE(6,6)
	WRITE(9,6)
6	FORMAT(/1X,' Orlandini et al. dipole form factor for DWUCK
	1 or CHUCK'/)
	PWR=1.
	VTEMP=VR*5
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
	PWR=0.
	FX=FX+1.
	VTEMP=VRA*(20./3.)*R2(2)
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
	PWR=2.
	VTEMP=-VRA*3.
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
	FACTOR=FACT*A13*A13
	PWR=-2.
	VTEMP=VRA*2*FACTOR
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
	PWR=-1.
	FX=FX+1.
	VTEMP=-VTEMP/ARR
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
C  
C	Write out form factor of Satchler (Version I) for isoscalar monopole
C	transition.
C  
	FX=6.
	IF(INX.EQ.2) FX=7.
	WRITE(6,7)
	WRITE(9,7)
7	FORMAT(/1X,' Satchler (Version I) monopole form factor for DWUCK
	1 or CHUCK'/)
	PWR=0.
	VTEMP=-V*3
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
	PWR=1.
	FX=FX+1.
	VTEMP=-VA
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
C  
C	Write out form factor of Satchler (Version II) for isoscalar monopole
C	transition.
C  
	FX=6.
	IF(INX.EQ.2) FX=7.
	WRITE(6,8)
	WRITE(9,8)
8	FORMAT(/1X,' Satchler (Version II) monopole form factor for DWUCK
	1 or CHUCK'/)
	PWR=0.
	X=(PI*AR(2)/R(2))**2
	X=(3+X)/(1+X)
	VTEMP=-V*X
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
	FX=FX+1.
	VTEMP=-VA*R(2)
	WRITE(6,5)FX,PWR,VTEMP
	WRITE(9,5)FX,PWR,VTEMP
	GO TO 100
	END

	SUBROUTINE SUMRUL
	IMPLICIT REAL*8(A-H,O-Z)
C
C    THIS SUBROUTINE CALCULATES THE ISOSCALAR SUM RULES FOR THE
C    MONOPOLE,DIPOLE AND HIGHER MULTIPOLE OPERATORS.
C
	COMMON AMASS,Z,A13,EPSILON,AR(3),R(3),SR(3),L_MULT
	DIMENSION R2(3),R4(3),RLN(3)
C   
C    GENERAL PARAMETERS
C
	PARAMETER (TWOPI = 6.283185D0)
	PARAMETER (HBARC2 = 38927.29D0)
	PARAMETER (MC2 = 938.256D0)
C
C
	Z2A=Z*Z/AMASS
C
C    GO HERE FOR MONOPOLE TRANSITIONS
C
	IF(L_MULT.EQ.0)THEN
	TEMP=HBARC2*Z2A/(2*MC2)
	DO 1 I=1,3
   	CALL RFERMI(R(I),AR(I),2,R2(I))
   1	SR(I)=TEMP*R2(I)
C
C    GO HERE FOR DIPOLE TRANSITIONS
C
	ELSE IF(L_MULT.EQ.1)THEN
	EGQR=65./A13
	EGMR=80./A13
	EPSILON=(4./EGQR+5./EGMR)*HBARC2/(3.*MC2*AMASS)
	TEMP=3.*HBARC2*Z2A/(16.*MC2*TWOPI)
	DO 2 I=1,3
   	CALL RFERMI(R(I),AR(I),2,R2(I))
   	CALL RFERMI(R(I),AR(I),4,R4(I))
   2	SR(I)=TEMP*(11.*R4(I)-(25./3.)*R2(I)*R2(I)-10.*EPSILON*R2(I))
C
C    GO HERE FOR L_MULT.GE.2
C
	ELSE IF(L_MULT.GE.2)THEN
	XL=FLOAT(L_MULT)
	LN=2*L_MULT-2
	TEMP=XL*(2.*XL+1.)*(2.*XL+1.)*HBARC2*Z2A/(4.*TWOPI*MC2)
	DO 3 I=1,3
   	CALL RFERMI(R(I),AR(I),LN,RLN(I))
   3	SR(I)=TEMP*RLN(I)
	ENDIF
	RETURN
	END
  
	SUBROUTINE RFERMI(RR,AR,N,RN)
	IMPLICIT REAL*8(A-H,O-Z)
C
C    THIS SUBROUTINE CALCULATES THE MEAN TO THE Lth POWER OF THE RADIUS 
C    FOR A FERMI OR A UNIFORM MASS DISTRIBUTION {i.e.<R**L>}.
C
	CHARACTER DEF*1
C	Changed by JE 14.04.2010
C	COMMON /DEFSR/ DEF
	COMMON /INT/ DR,KR
	DIMENSION U(500)
	DATA DEF /'N'/
	IF (AR.EQ.0.) THEN
  
C   UNIFORM DISTRIBUTION
  
	  RN=(3./(3.+FLOAT(N)))*RR**N
	ELSE
  
C  FERMI DISTRIBUTION
  
	  R=0.D0
	  SUM1=0.D0
	  SUM2=0.D0
	  IF(DEF.EQ.'Y') THEN
	    CALL POTENT(U,'GR',0,1,RR,AR)
	  ELSE
	    F2=EXP(-DR/AR)
	    F1=EXP(RR/AR)
	  ENDIF
	  DO 1 M=1,KR
	  R=R+DR	
	  RPWR=R**(N+2)
	  R2=R*R
	  X=1.D0
	  IF(M.EQ.1.OR.M.EQ.KR)X=0.5D0
	  IF(DEF.EQ.'Y') THEN
	    TEMP=X*U(M)
	  ELSE
	    F1=F1*F2
	    TEMP=X*F1/(1.0+F1)
	  ENDIF
	  SUM1=SUM1+TEMP*R2
	  SUM2=SUM2+TEMP*RPWR
  1  	  CONTINUE
	  RN=SUM2/SUM1
	ENDIF
	RETURN
	END
  
	SUBROUTINE INTEG(BAND,L_MULT,NX,RR,AR,MEL,MELCOR)
	IMPLICIT REAL*8(A-H,O-Z)
C
C   SUBROUTINE TO CALCULATE TRANSITION MATRIX ELEMENTS FROM THE GROUND 
C   STATE TO STATES OF THE GROUND STATE, GAMMA, BETA AND OCTUPOLE BANDS
C
	COMMON /DEF/ VBETA,GAMMA,BETACOR,XK,BETA0_DEF,BETA3_DEF 
	1           ,BETA(3),LDFRM(3)
	COMMON /INT/ DR,KR
	DIMENSION U(500),V(500)
	CHARACTER BAND*2
	REAL*8 MEL,MELCOR
	PARAMETER (FOURPI=12.56637062D0)
C
C   GROUND STATE IS ASSUMED TO HAVE SPIN AND PARITY  0+
C
	XI = 0.D0
	XJ = L_MULT
	XKI = 0.D0
	XKJ=XK
	XLAM = XJ
  
C   THE SIGN SHOULD BE TAKEN POSITIVE TO CONFIRM WITH THE OTHER CONVENTIONS
  
	TEMP=+SQRT((2.*XJ+1.)/(2.*XI+1.))
	IF (BAND.EQ.'GA') TEMP=TEMP*GAMMA*BETA(1)
	IF (BAND.EQ.'BE'.OR.BAND.EQ.'OC') TEMP=TEMP*VBETA
  
	IF(BAND.EQ.'GR')THEN
C
C   GROUND STATE ROTATIONAL TRANSITION DENSITY
C
	  IF(XKJ.NE.XKI) TEMP=0.D0
	  TEMP=TEMP*CG(XJ,XKJ,XLAM,0.D0,XI,XKI)*PAR(NINT(XJ-XI))
C
C   GAMMA, BETA OR OCTUPOLE BAND TRANSITION DENSITY
C
	ELSE 
	  TEMP=TEMP*CG(XJ,-XKJ,XLAM,XKJ,XI,0.D0)*PAR(L_MULT)
	ENDIF
  
	CALL POTENT(U,BAND,L_MULT,NX,RR,AR)
	INX=NX
	IF(BAND.NE.'GR') INX=NX-1
	CALL POTENT(V,'GR',0,INX,RR,AR)
	L = L_MULT + 2
	IF(L_MULT.EQ.0) L=4
	IF(L_MULT.EQ.1) L=5
	R =0.D0
	MEL = 0.D0
	MELCOR = 0.D0
	SUM=0.D0
	DO 2 I=1,KR
	R=R+DR
	RPWR= R**L
	R2=R*R
	X=1.D0
	IF(I.EQ.1.OR.I.EQ.KR) X=0.5D0
	MEL=MEL+X*RPWR*U(I)
	IF(L_MULT.GT.1) GO TO 3
	MELCOR=MELCOR+X*RPWR*U(I)/R2
  3	SUM=SUM+X*R2*V(I)
  2	CONTINUE
	MEL=TEMP*MEL/(FOURPI*SUM)
	MELCOR=TEMP*MELCOR/(FOURPI*SUM)
	IF(L_MULT.EQ.0) THEN
  
C   THE MONOPOLE TRANSITION IS CALCULATED FOR THE OPERATOR (1/2)*R**2
  
	MEL=MEL*SQRT(FOURPI)/2.
	MELCOR=MELCOR*1.772454
	ELSE IF(L_MULT.EQ.1) THEN
  
C   THE DIPOLE TRANSITION IS CALCULATED FOR THE OPERATOR (1/2)*R**3*Y1
  
	MEL=MEL*0.5
	MELCOR=MELCOR*0.5
	ENDIF
	RETURN
	END
  
	SUBROUTINE POTENT(U,BAND,LAM,NX,RR,AR)
	IMPLICIT REAL*8(A-H,O-Z)
C
C    DEFORMED VOLUME,SURFACE OR SECOND DERIVATIVE POTENTIAL BY YLM
C    EXPANSION
C
	COMMON /DEF/ VBETA,GAMMA,BETACOR,XK,BETA0_DEF,BETA3_DEF
	1           ,BETA(3),LDFRM(3)
	COMMON /INT/ DR,KR
	DIMENSION U(500)
	DIMENSION CN(16),YLAM(16),CP(16),FACTR(3),X(8),W(8)
	CHARACTER BAND*2
	DATA X/0.0950125098D0,0.2816035507D0,0.4580167776D0,0.6178762444
	1D0,0.7554044083D0,0.8656312023D0,0.9445750230D0,0.9894009439D0/
	DATA W/0.1894506104D0,0.1826034150D0,0.1691565193D0,0.1495959888
	1D0,0.1246289712D0,0.0951585116D0,0.0622535239D0,0.0271524594D0/
	DATA SQRPI/1.772453851D0/
C
	IND=0
	DO 6 I=1,KR
  6	U(I) = 0.D0
	XLAM=LAM
  
C  FOR UNIFORM DENSITY AR MUST BE FINITE
	IF (AR.EQ.0.) AR=0.03*RR/1.2
  
	F2=EXP(-DR/AR)
	VR = 1.D0
	IF(BAND.NE.'GR') VR=RR/AR
	GO TO 11
  10	CONTINUE
	IND=1
	VR=VR*BETACOR
  11	CONTINUE
	IF(BAND.EQ.'GR'.OR.BAND.EQ.'GA') GO TO 12
	IF(IND.EQ.0.AND.(BETA0_DEF.EQ.1..OR.BETA3_DEF.EQ.1.)) GO TO 70
  12	CONTINUE
     	DO 1 I=1,3
	FACTR(I)=SQRT(DFLOAT(LDFRM(I)+LDFRM(I)+1))*BETA(I)/(SQRPI*2.)
  1	CONTINUE
	LMAX=MAX(LAM,LDFRM(3))+1
	LTEMP=2
 	IF(BAND.EQ.'OC') LTEMP=3
	IF(IND.EQ.1.AND.BAND.EQ.'BE') LTEMP=0
	IF(IND.EQ.1.AND.BAND.EQ.'OC') LTEMP=1
	XTEMP=LTEMP
	IF(BAND.NE.'GR') LMAX=MAX(LAM+LTEMP,LDFRM(3))+1
	DO 3 I=1,8
	YLAM(I  )=0.D0
  3	YLAM(I+8)=0.D0
	T2=(-1.)**LAM
	T1=(-1.)**LDFRM(1)
	DO 9 I=1,8
	CN(I  )=0.D0
	CN(I+8)=0.D0
	P2=0.D0
	P3=1.D0
	Z=X(I)
	DO 8 M=1,LMAX
	L=M-1
	XL = L
	FL=XL-1.
	IF(L.EQ.0)GOTO 2
	P3=((2.*FL+1.)*Z*P2-FL*P1)/(FL+1.)
  2	CONTINUE
	DO 4 J=1,3
	IF(L.NE.LDFRM(J)) GO TO 4
	CN(I  )=CN(I  )+P3*FACTR(J)
	CN(I+8)=CN(I+8)+P3*FACTR(J)*T1
  4	CONTINUE
	IF(BAND.EQ.'GR') GO TO 5
	IF(IABS(L-LAM).GT.LTEMP.OR.L+LAM.LT.LTEMP) GOTO 7
	T3=SQRT((2.*XTEMP+1.)*(2.*XL+1.)/(2.*XLAM+1.))*0.5/SQRPI
	1*CG(XL,0.D0,XTEMP,0.D0,XLAM,0.D0)*CG(XL,0.D0,XTEMP,XK,XLAM,XK)
	2 *P3*W(I)*SQRT(2.*XL+1.)*SQRPI
	YLAM(I  )=YLAM(I  )+T3
	YLAM(I+8)=YLAM(I+8)+T3
	GOTO 7
  5	IF(L.NE.LAM)GOTO 7
	YLAM(I  )=P3*W(I)*SQRT(2.*XL+1.)*SQRPI
	YLAM(I+8)=YLAM(I  )*T2
  7	CONTINUE
	P1=P2
	P2=P3
  8	CONTINUE
  9	CONTINUE
	F1=1.D0
	DO 35 J=1,16
  35	CP(J)=EXP((1.+CN(J))*RR/AR)
	IF(LAM.EQ.0.AND.BAND.EQ.'GR') VR=VR/(2.*SQRPI)
	DO 60 M=1,KR
	VTEMP=0.D0
	F1=F1*F2
	DO 55 J=1,16
	F3=F1*CP(J)
	GO TO (40,45,50),NX
  40	VTEMP=VTEMP+YLAM(J)*VR*F3/(1.+F3)
	GO TO 55
  45	VTEMP=VTEMP-YLAM(J)*VR*(F3/(1.+F3))/(1.+F3)
	GO TO 55
  50	VTEMP=VTEMP+YLAM(J)*VR*(F3/(1.+F3))*((1.-F3)/(1.+F3))/(1.+F3)
  55	CONTINUE
	U(M)=U(M)+VTEMP
  60	CONTINUE
  70	CONTINUE
	IF(BAND.EQ.'GR'.OR.BAND.EQ.'GA') RETURN
	IF(IND.EQ.0) GO TO 10
	RETURN
	END

	SUBROUTINE RHOLSJ(K,MQ,F)
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES STATISTICAL TENSORS FOR VARIOUS L,S,J TRANSFERS
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	INCLUDE 'ANGCOR.INC'
	COMPLEX*16 F1,F2,F(2*MAX_LG,2*MAX_LG)

	XK=K
	XMQ=MQ
	IND1=0
	DO 1 I=1,NLTR
	XI=FLOAT(JTR(I))/2.
	IND2=0
	JTR1=JTR(I)+1
	IMI=-JTR(I)
	DO 2 J=1,NLTR
	XJ=FLOAT(JTR(J))/2.
	F(I,J)=(0.,0.)
	DO 3 MI=1,JTR1
	MIMI=(IMI+JTR(I))/2+1
	XMI=FLOAT(IMI)/2.
	IMSB=-ISB
	DO 4 MSB=1,JS
	IMSA=-ISA
	DO 5 MSA=1,JR
	F1=SUM(MSB,MSA,MIMI+IND1)
	MJ=IMI-2*MQ
	MJMJ=(MJ+JTR(J))/2+1
	F2=DCMPLX(DREAL(SUM(MSB,MSA,MJMJ+IND2)),
     1  -DIMAG(SUM(MSB,MSA,MJMJ+IND2)))
	F(I,J)=F(I,J)+PAR((JTR(J)-IMI+2*MQ)/2)*F1*F2*CG(XI,XMI,XJ,
     1  XMQ-XMI,XK,XMQ)
	IMSA=IMSA+2
5	CONTINUE
	IMSB=IMSB+2
4	CONTINUE
	IMI=IMI+2
3	CONTINUE
	IND2=IND2+JTR(J)+1

	IF(ICO(2).EQ.1) WRITE(LUNOUT,100)I,J,F(I,J)

2	CONTINUE
	IND1=IND1+JTR(I)+1
1	CONTINUE
	RETURN
100	FORMAT(2I4,2F15.6)
	END

	SUBROUTINE CIOX
C++
C TITLE:  CIOX
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: This module contains several entries which do free
C	format input with optional prompt, default, lower and
C	upper limits, and special characters which may control
C	the flow of a program.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	CIODSS, CIOERL, CIOGIT, CIOINV, CIOMSG, CIOYNL,
C	CIOLUNFREE, INDEX, STR__UPCASE
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 28-nov-1980.	Added CIOS and CIOSX entries.
C PAK 26-jan-1981.	Changed call to LUNFREE to LIB$FREE_LUN.
C			Changed call to CIOCLU to STR__UPCASE.
C			Other F77 related changes.
C			Included HELP option.
C PAK 27-feb-1981.	Added option to specify default radix in specification
C			string for CIOI and CIOIX.
C PAK 13-may-1981.	Implemented qualifiers.
C PAK 25-jan-1984.	Allow TRUE and FALSE as valid input for CIOL(X)
C F.Z. 30-Aug-1990.	Fixed bug in CIOBX, which did not used the BDEFAULT
C			argument but the LDEF argument of CIOLX.
C F.Z. 13-Dec-1993.	Adapt to AXP. Used IARGCOUNT instead of NOARG.
C FUNCTIONAL DESCRIPTION:
C ENTRIES:
C	CIOI	Integer input
C	CIOIX	Idem, extended calling sequence.
C	CIOF	Floating (real) input
C	CIOFX	Idem, extended calling sequence.
C	CIOD	Double precision (real*8) input
C	CIODX	Idem, extended calling sequence.
C	CIOB	Boolean (logical*1) input
C	CIOBX	Idem, extended calling sequence.
C	CIOL	Logical (logical*4) input
C	CIOLX	Idem, extended calling sequence.
C	CIOA	Alphanumeric (character) input
C	CIOAX	Idem, extended calling sequence.
C	CIOS	Alphanumeric (character) input; returns string length.
C	CIOSX	Idem, extended calling sequence.
C
C CALLING SEQUENCE: See separate documentation.
C--

	INCLUDE 'ciocom.inc'
	CHARACTER	FORMAT*25,C*1
	CHARACTER	PROMPT*(*)
	CHARACTER	SPECST*(*)
	CHARACTER	CIOYNL*3
	INTEGER		IARG1, IARG2, IARG3
	REAL*4		FARG1, FARG2, FARG3
	REAL*8		DARG1, DARG2, DARG3
	INTEGER		IVALUE, ITEMP, ILOLIM, IHILIM, IDEFAULT
	REAL*8		FVALUE
	REAL*8		DVALUE, DTEMP, DLOLIM, DHILIM, DDEFAULT
	LOGICAL		LVALUE, LTEMP, LDEFAULT, LDFTMP
	LOGICAL*1	BVALUE, BDEFAULT
	INTEGER		IALEN
	LOGICAL*1	LIALEN
	CHARACTER*(*)	AVALUE,ADEF
	CHARACTER*(*) POSTIV, NEGTIV
	PARAMETER	(POSTIV	= 'YESJATRUE')
	PARAMETER	(NEGTIV	= 'NONEENFALSE')
	INTEGER		NARG
Cg77	INTRINSIC	IARGCOUNT
	INTEGER		KEY1, KEY2
	INTEGER		ITEML
	INTEGER		I, J
	INTEGER		KRETUR
	INTEGER		STATUS

	CHARACTER*(*) TXCUR, TXDEF, TXLOW, TXHIGH, TXSIZ
	PARAMETER	(TXCUR	= 'current value (=) ...')
	PARAMETER	(TXDEF	= 'default value (*) ...')
	PARAMETER	(TXLOW	= 'lower limit .........')
	PARAMETER	(TXHIGH	= 'upper limit .........')
	PARAMETER	(TXSIZ	= 'maximum stringsize ..')

	CHARACTER*4	CTEMP,DSFLOW
	DATA		DSFLOW /S_FLOW/


C----------------------------------------------------------------------
C CIOI, CIOIX
C----------------------------------------------------------------------

	ENTRY CIOI (PROMPT,IVALUE)
	CALL CIODSS (' ')
	GOTO 1000

	ENTRY CIOIX (PROMPT,IVALUE,SPECST,IARG1,IARG2,IARG3,*,*,*,*)

	CALL CIODSS (SPECST)
	! KEY1 is the label where we go if an invalid flow control char is typed
 1000	ASSIGN 1050 TO KEY1
C Extract low, high and default if specified.
 1010	GOTO (1011,1012,1013), KSPLOW
	GOTO 1020
 1011	ILOLIM = IARG1
	GOTO 1020
 1012	ILOLIM = IARG2
	GOTO 1020
 1013	ILOLIM = IARG3
 1020	GOTO (1021,1022,1023), KSPHIG
	GOTO 1030
 1021	IHILIM = IARG1
	GOTO 1030
 1022	IHILIM = IARG2
	GOTO 1030
 1023	IHILIM = IARG3
 1030	GOTO (1031,1032,1033), KSPDEF
	GOTO 1040
 1031	IDEFAULT = IARG1
	GOTO 1040
 1032	IDEFAULT = IARG2
	GOTO 1040
 1033	IDEFAULT = IARG3
 1040	CONTINUE

C Extract item from input buffer.
 1050	ITEMP = IVALUE
 1055	CALL CIOGIT (PROMPT,CWORK,ITEML,*1060,*1070,*1080, *100)
C	alternate returns:		 =     *     ?    flow

C Examine first character on 'O' for octal, 'X' for hex or 'D' for
C decimal conversion.
C If none of these, assume radix as specified in specification string.
	CALL STR__UPCASE (C, CWORK(1:1))
	IF (C.EQ.'O') THEN		! user prefixed value by 'O'
	  goto 1056
	ELSE IF (C.EQ.'X') THEN		! user prefixed value by 'X'
	  C = 'Z'
	  goto 1056
	ELSE IF (C.EQ.'D') THEN		! user prefixed value by 'D'
	  C = 'I'
 1056	  CWORK = CWORK(2:ITEML)	! remove the radix indicator
	  ITEML = ITEML - 1
	ELSE				! no prefix
	  C = CSPRDX			! use default radix.
	ENDIF

C Construct the proper format, then decode the item.
	WRITE (FORMAT,91050) C,ITEML
91050	FORMAT('(',A,I2,')')
	READ (CWORK,FORMAT,ERR=300) ITEMP
C Check against limits if specified.
 1060	IF (KSPLOW.GT.0) THEN
	  IF (ITEMP.LT.ILOLIM) GOTO 400
	ENDIF
	IF (KSPHIG.GT.0) THEN
	  IF (ITEMP.GT.IHILIM) GOTO 400
	ENDIF
C Give value to caller and join common return code.
 1065	IVALUE = ITEMP
	GOTO 700
C Use default if specified, then go check agains limits if specified.
 1070	IF (KSPDEF.EQ.0) GOTO 500
	ITEMP = IDEFAULT
	GOTO 1060
C Show current, default and limits as far as specified,
C and radix if not decimal.
C Then join common code to display the defined path's.
 1080	WRITE (FORMAT,91080) CSPRDX		! encode dynamic format
91080	FORMAT ('(1X,:,T8,A,T30,',A,'12)')	! according to default radix.
	WRITE(LUNO,FORMAT) !blank line
	WRITE(LUNO,FORMAT) TXCUR,IVALUE
	IF (KSPDEF.GT.0) WRITE(LUNO,FORMAT) TXDEF,IDEFAULT
	IF (KSPLOW.GT.0) WRITE(LUNO,FORMAT) TXLOW,ILOLIM
	IF (KSPHIG.GT.0) WRITE(LUNO,FORMAT) TXHIGH,IHILIM
	IF (CSPRDX.EQ.'O') THEN
	  WRITE (LUNO,'(T8,''input in radix ......        octal'')')
	ELSEIF (CSPRDX.EQ.'Z') THEN
	  WRITE (LUNO,'(T8,''input in radix ......  hexadecimal'')')
	ENDIF
	GOTO 600

C----------------------------------------------------------------------
C CIOF, CIOFX
C----------------------------------------------------------------------

	ENTRY CIOF (PROMPT,FVALUE)
	CALL CIODSS (' ')
	GOTO 2000

	ENTRY CIOFX (PROMPT,FVALUE,SPECST,FARG1,FARG2,FARG3, *,*,*,*)

	CALL CIODSS (SPECST)
 2000	CONTINUE
	! KEY1 is the label where we proceed on invalid input
	ASSIGN 2050 TO KEY1
	! KEY2 is the label where we proceed on valid input
	ASSIGN 2065 TO KEY2
C Extract low, high and default if specified.
 2010	GOTO (2011,2012,2013), KSPLOW
	GOTO 2020
 2011	DLOLIM = FARG1
	GOTO 2020
 2012	DLOLIM = FARG2
	GOTO 2020
 2013	DLOLIM = FARG3
 2020	GOTO (2021,2022,2023), KSPHIG
	GOTO 2030
 2021	DHILIM = FARG1
	GOTO 2030
 2022	DHILIM = FARG2
	GOTO 2030
 2023	DHILIM = FARG3
 2030	GOTO (2031,2032,2033), KSPDEF
	GOTO 2040
 2031	DDEFAULT = FARG1
	GOTO 2040
 2032	DDEFAULT = FARG2
	GOTO 2040
 2033	DDEFAULT = FARG3
 2040	CONTINUE

C Copy current value to temporary.
C Then join the code for double precision conversion.
 2050	DTEMP = FVALUE
	GOTO 3055

C Give value to caller and join common return code.
 2065	FVALUE = DTEMP
	GOTO 700

C----------------------------------------------------------------------
C CIOD, CIODX
C----------------------------------------------------------------------

	ENTRY CIOD (PROMPT,DVALUE)
	CALL CIODSS (' ')
	GOTO 3000

	ENTRY CIODX (PROMPT,DVALUE,SPECST,DARG1,DARG2,DARG3,*,*,*,*)

	CALL CIODSS (SPECST)
 3000	CONTINUE
	! KEY1 is the label where we proceed on invalid input
	ASSIGN 3050 TO KEY1
	! KEY2 is the label where we proceed on valid input
	ASSIGN 3065 TO KEY2
C Extract low, high and default if specified.
 3010	GOTO (3011,3012,3013), KSPLOW
	GOTO 3020
 3011	DLOLIM = DARG1
	GOTO 3020
 3012	DLOLIM = DARG2
	GOTO 3020
 3013	DLOLIM = DARG3
 3020	GOTO (3021,3022,3023), KSPHIG
	GOTO 3030
 3021	DHILIM = DARG1
	GOTO 3030
 3022	DHILIM = DARG2
	GOTO 3030
 3023	DHILIM = DARG3
 3030	GOTO (3031,3032,3033), KSPDEF
	GOTO 3040
 3031	DDEFAULT = DARG1
	GOTO 3040
 3032	DDEFAULT = DARG2
	GOTO 3040
 3033	DDEFAULT = DARG3
 3040	CONTINUE

C Copy current value to temporary.
 3050	DTEMP = DVALUE
C Extract item from input buffer and decode it.
C The single-floating (CIOF) code joins us here.
 3055	CALL CIOGIT (PROMPT,CWORK,ITEML,*3060,*3070,*3080, *100)
C	alternate returns:		 =     *     ?    flow
	WRITE (FORMAT,93050) ITEML
93050	FORMAT('(F',I2,'.0)')
	READ (CWORK,FORMAT,ERR=300) DTEMP
C Check against limits if specified.
 3060	IF (KSPLOW.GT.0) THEN
	  IF (DTEMP.LT.DLOLIM) GOTO 400
	ENDIF
	IF (KSPHIG.GT.0) THEN
	  IF (DTEMP.GT.DHILIM) GOTO 400
	ENDIF
C Give value to caller and join common return code.
C The single-floating (CIOF) code leaves us here again.
 3062	GOTO KEY2,(2065,3065)
 3065	DVALUE = DTEMP
	GOTO 700
C Use default if specified, then go check agains limits if specified.
 3070	IF (KSPDEF.EQ.0) GOTO 500
	DTEMP = DDEFAULT
	GOTO 3060
C Show current, default and limits as far as specified.
C Then join the common code to display the defined path's.
 3080	WRITE(LUNO,93080) !blank line
	WRITE(LUNO,93080) TXCUR,DVALUE
	IF (KSPDEF.GT.0) WRITE(LUNO,93080) TXDEF,DDEFAULT
	IF (KSPLOW.GT.0) WRITE(LUNO,93080) TXLOW,DLOLIM
	IF (KSPHIG.GT.0) WRITE(LUNO,93080) TXHIGH,DHILIM
93080	FORMAT(1X,:,T8,A,T30,G16.6)
	GOTO 600

C----------------------------------------------------------------------
C CIOB, CIOBX, CIOBXD
C----------------------------------------------------------------------

	ENTRY CIOB (PROMPT,BVALUE)
	CALL CIODSS (' ')
	GOTO 4000

	ENTRY CIOBX  (PROMPT,BVALUE,SPECST,BDEFAULT,*,*,*,*)

	CALL CIODSS (SPECST)
 4000	CONTINUE
	! KEY1 is the label where we proceed on invalid input
	ASSIGN 4050 TO KEY1
	! KEY1 is the label where we proceed on valid input
	ASSIGN 4065 TO KEY2

C Copy current value and default to temporaries.
C Then join code for LOGICAL*4 (CIOL)
 4050	LTEMP  = BVALUE
	LDFTMP = BDEFAULT
	GOTO 5055

C Give value to caller and join common return code.
 4065	BVALUE = LTEMP
	GOTO 700

C----------------------------------------------------------------------
C CIOL and CIOLX
C----------------------------------------------------------------------

	ENTRY CIOL (PROMPT,LVALUE)
	CALL CIODSS (' ')
	GOTO 5000

	ENTRY CIOLX (PROMPT,LVALUE,SPECST,LDEFAULT, *,*,*,*)

	CALL CIODSS (SPECST)
 5000	CONTINUE
	! KEY1 is the label where we go on invalid input
	ASSIGN 5050 TO KEY1
	ASSIGN 5065 TO KEY2

C Copy current value and default to temporaries.
 5050	LTEMP  = lVALUE
	LDFTMP = LDEFAULT

C Extract item from input buffer and decode it.
 5055	CALL CIOGIT (PROMPT,CWORK,ITEML,*5060,*5070,*5080, *100)
C	alternate returns:		 =     *     ?    flow
C Translate CWORK in either .TRUE. or .FALSE.
C First translate CWORK from lower to upper case.
	CALL STR__UPCASE (CWORK(:ITEML), CWORK(:ITEML))	!??? g77
	IF (INDEX(POSTIV,CWORK(:ITEML)).NE.0) THEN
	  LTEMP = .TRUE.
	ELSEIF (INDEX(NEGTIV,CWORK(:ITEML)).NE.0) THEN
	  LTEMP = .FALSE.
	ELSE
	  GOTO 300
	ENDIF
C Give value to caller and join common return code.
 5060	GOTO KEY2,(4065,5065)
 5065	LVALUE = LTEMP
	GOTO 700
C Use default if specified.
 5070	IF (KSPDEF.EQ.0) GOTO 500
	LTEMP = LDFTMP
	GOTO 5060
C Show current and default as far as specified.
C Then join the common code to display the defined path's.
 5080	WRITE(LUNO,95080) !blank line
	WRITE(LUNO,95080) TXCUR,CIOYNL(LVALUE)
	IF (KSPDEF.GT.0) WRITE(LUNO,95080) TXDEF,CIOYNL(LDEFAULT)
95080	FORMAT(1X,:,T8,A,T30,A)
	GOTO 600

C----------------------------------------------------------------------
C CIOS and CIOSX
C----------------------------------------------------------------------

	ENTRY CIOS (PROMPT, AVALUE, IALEN)
	LIALEN = .TRUE.
	GOTO 6001

	ENTRY CIOA (PROMPT, AVALUE)
	LIALEN = .FALSE.
 6001	CALL CIODSS (' ')
	GOTO 6000

	ENTRY CIOSX (PROMPT, AVALUE, IALEN, SPECST, ADEF,*,*,*,*)
	LIALEN = .TRUE.
      GOTO 6002

	ENTRY CIOAX (PROMPT, AVALUE, SPECST, ADEF, *,*,*,*)
	LIALEN = .FALSE.
 6002	CALL CIODSS (SPECST)

 6000	CONTINUE
	! KEY1 is the label where we go on invalid input
	ASSIGN 6050 TO KEY1

C Extract item from input buffer and decode it.
 6050	CALL CIOGIT (PROMPT,CWORK,ITEML,*6090,*6070,*6080, *100)
C	alternate returns:		 =     *     ?    flow
C Check if callers string is long enough to contain CWORK.
	IF (ITEML.GT.LEN(AVALUE)) THEN
	  ITEML = LEN(AVALUE)
	  CALL CIOMSG(0,'warning - string truncated to')
	  CALL CIOMSG(0,CWORK(:LEN(AVALUE)))
	ENDIF
C Give value to caller and join common return code.
 6060	AVALUE = CWORK(:ITEML)
	GOTO 6072
C Use default if specified and join common return code.
 6070	IF (KSPDEF.EQ.0) GOTO 500
	AVALUE = ADEF
	ITEML = LEN (ADEF)
C Convert to upper case if caller requested.
 6072	IF (KSPCNV.NE.0) CALL STR__UPCASE (AVALUE, AVALUE)
C If called via CIOAL or CIOALX return string length to caller.
	IF (LIALEN) IALEN = ITEML
C Join common return code.
	GOTO 700
C Show current and default as far as specified.
C Then join the common code to display the defined path's.
 6080	WRITE(LUNO,96080) !blank line
	WRITE(LUNO,96080) TXCUR,AVALUE
	IF (KSPDEF.GT.0) WRITE(LUNO,96080) TXDEF,ADEF
	WRITE(LUNO,96081) TXSIZ,LEN(AVALUE)
96080	FORMAT(1X,:,T8,A,T30,A)
96081	FORMAT(1X,:,T8,A,T30,I5)
	GOTO 600
C Come here when equal sign entered. For CIOS and CIOSX entries
C we now must find out the length of the string currently in
C AVALUE, since the users expects us to return the length.
 6090	DO 6092 ITEML = LEN(AVALUE), 1, -1
	IF (AVALUE(ITEML:ITEML).NE.' ') GOTO 6072
 6092	CONTINUE
	ITEML = 0
	GOTO 6072

C----------------------------------------------------------------------
C This section is common to all entries in this module.
C----------------------------------------------------------------------

C Come here if CIO control character typed.
C See if alternate return has been specified for this control
C character. If so, take that return. If not complain, and
C invalidate input buffer and alternate files.

  100	I = INDEX (S_FLOW, CWORK(1:1))
	IF (KSPCTL(I).EQ.0) THEN
	  CALL CIOERL('you can''t go that way')
	  GOTO KEY1
	ELSE
	  KRETUR = KSPCTL(I)
	  GOTO 710
	ENDIF

C Come here if decode error
C Complain and invalidate inputbuffer and alternate files.
  300	CALL CIOERL ('bad input')
	GOTO KEY1

C Come here if limits exceeded
C Complain and invalidate inputbuffer and alternate files.
  400	CALL CIOERL ('value outside limits')
	GOTO KEY1

C Come here if default requested while no default specified.
C Complain and invalidate inputbuffer and alternate files.
  500	CALL CIOERL ('no default available')
	GOTO KEY1

C Come here to display the currently defined flow control characters.
C Only display if at least one is defined.
  600	CTEMP = ' '
	J = 0
	DO 610 I=1,4
	IF (KSPCTL(I).NE.0) THEN
	  J = J + 1
	  CTEMP(J:J) = DSFLOW(I:I)
	ENDIF
  610	CONTINUE
	IF (J.GT.0)
	1 WRITE (LUNO,'(T8,''you can go to .......'',T30,4(4X,A))')
	1 (CTEMP(I:I),I=1,J)
C Display the legal qualifiers, if any.
	CALL CIOQSH
C And a final blank line.
	WRITE (LUNO,'(1X)')
	GOTO KEY1

C Come here just before returning to the caller in order to purge
C the internal promptbuffer, delete the possibly open prompt-
C scratchfile, and deallocate the corresponding logical unit number.
  700	KRETUR = 0
C Code for alternate returns caused by flow-control-char's joins here.
  710	IPBPTR = 0
	IF (LUNPRF .NE. 0) THEN
	  CLOSE (UNIT = LUNPRF)
	  CALL CIOLUNFREE (LUNPRF, STATUS) !???g77 status testen
	  LUNPRF = 0
	ENDIF
	RETURN KRETUR

	END

	SUBROUTINE CIODSS (SPSTR)
C++
C TITLE:  CIODSS
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Decode specification string.
C ENVIRONMENT:  FORTRAN-77.
C PROCEDURES CALLED:
C	CIO1ST, CIOMSG, CIOPUR, INDEX
C	STR__UPCASE
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 26-jan-1981 Convert specification string to uppercase before examining.
C PAK 27-feb-1981 Allow specifiers to force octal and hex conversion
C PAK 10-apr-1981 Add P specifier which purges the internal input buffer.
C FUNCTIONAL DESCRIPTION:
C	This procedure examines the specification string SPSTR.
C	Each legal character in the string causes the corresponding
C	switch KSPxxx to be set equal to the position of that
C	character in the specification string.
C	Separate position counters are maintained for argument-
C	specifiers (lower limit,higher limit,default) and alternate
C	return specifiers.
C	The 'C' (convert lower to upper case), 'O' and 'X'
C	(radix conversion) switches are treated separately.
C	The 'P' and 'Q' specifiers don't set a switch but immediately
C	cause purging of respectively the internal inputbuffer or the
C	qualifier definition list.
C CALLING SEQUENCE: (only for internal use by CIO)
C	CALL CIODSS (SPSTR)
C INPUT PARAMETERS:
C	SPSTR	specification string
C IMPLICIT OUTPUTS:
C	The optional-argument specification switches in COMMON
C	/CIO001/. These switches are names KSPxxx where xxx indicates
C	the meaning of the switch.
C--

	INCLUDE		'ciocom.inc'

	CHARACTER*(*) SPECS
	PARAMETER	(SPECS	= ' LHDCOX<>^$PQ')
	CHARACTER	SPSTR*(*)
	CHARACTER	TSPSTR*12	! Size must be large enough to
			! contain longest possible specification string.
	INTEGER		I, I1, I2

C      write (*,*) '?????? ciodss called'
C Initialize CIO package.
	CALL CIO1ST

C Reset pointers and switches.
	I1 = 1
	I2 = 1
	KSPLOW = 0
	KSPHIG = 0
	KSPDEF = 0
	KSPCNV = 0
	CSPRDX = 'I'	! Default radix is decimal (I-conversion).
	KSPBCK = 0
	KSPFWD = 0
	KSPUP  = 0
	KSPDOL = 0

C Treat upper and lower case as equal in specification string by first
C converting the entire spec.string to upper case.
C Note that we must convert into a local stringvariable, since we normally
C can and should not modify the actual argument.

C      write (*,*) '?????? str__upcase (1) called with: ', SPSTR
	CALL STR__UPCASE (TSPSTR,SPSTR)	!???g77
C      write (*,*) '?????? str__upcase (2) called returning: ', TSPSTR

C Examine all characters in specification string and set
C corresponding switch according to the position of that character.

	DO 100 I=1,LEN(SPSTR)
	GOTO (100, 21,22,23, 31,32,33, 41,42,43,44, 51,52)
	1	INDEX(SPECS,TSPSTR(I:I))
Cg77	CALL CIOMSG (1,'CIO - bad specification string: '//SPSTR)
	CALL CIOMSG (1,'CIO - bad specification string: ?g77?')

C It's a character specifying an lower-, upper limit or default.

   21	KSPLOW = I1
	GOTO 29
   22	KSPHIG = I1
	GOTO 29
   23	KSPDEF = I1
   29	I1 = I1 + 1
	GOTO 100

C It's one of the conversion specifiers

   31	KSPCNV = 1		! 'C' - convert lower to upper case.
	GOTO 100
   32	CSPRDX = 'O'		! 'O' for default radix.
	GOTO 100
   33	CSPRDX = 'Z'		! 'X' for default radix.
	GOTO 100

C It's a character corresponding to an alternate return.

   41	KSPBCK = I2
	GOTO 49
   42	KSPFWD = I2
	GOTO 49
   43	KSPUP  = I2
	GOTO 49
   44	KSPDOL = I2
   49	I2 = I2 + 1
	GOTO 100

C It's a request to purge the internal input buffer.
C Do it now, no switches involved.

   51	CALL CIOPUR
	GOTO 100

C It's a request to purge the internal input buffer.
C Do it now, no switches involved.

   52	CALL CIOQPU
	GOTO 100

  100	CONTINUE
	RETURN
	END

	SUBROUTINE CIOPRM (PROMPT)
C++
C TITLE:  CIOPRM
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: If input device is a terminal and input
C   is not from an alternate file, then:
C   if the continuation flag is not  et, display possible contents of
C   promptbuffer, possible contents of promptfile, and promptstring;
C   but if the continuation flag is set, only display the continuation prompt.
C ENVIRONMENT:  FORTRAN-77 except for the use of the $ formatspecifier.
C PROCEDURES CALLED: None.
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  21-oct-1980.
C MODIFIED BY:
C PAK 30-jan-1981: Changed for new prompting philosophy in case of
C	continuation.
C FZ  29-Oct-1987: Prompt to input device. Check only whether input
C	device is a terminal.
C PAK 02-oct-2006: Undid the above change, i.e. prompt to output device,
C     because Linux/f77 doesn't allow writing to stdin.
C
C FUNCTIONAL DESCRIPTION:
C CALLING SEQUENCE: (only for internal use by CIO)
C	CALL CIOPRM (PROMPT)
C INPUT PARAMETERS:
C	PROMPT	characterstring containing the prompt.
C--

	INCLUDE 'ciocom.inc'
	CHARACTER*(*) PROMPT
	INTEGER			I

C Prompts will only be displayed if the inputdevice
C is a terminal and we are not reading from an alternate file.

	IF (MODI.NE.0 .OR. LUNSTP.GT.0) RETURN

C If continuation flag is set, only display the continuation prompt.

	IF (LCONTIN) THEN
        WRITE (LUNO,'(1X,''_'',$)')

C If continuation flag not set then:
C First show the contents of the promptbuffer if it contains something.

	ELSE

   10	  IF (IPBPTR.GT.0) THEN
          WRITE (LUNO,9010)
	1   (PRBUF(I)(:INDEX(PRBUF(I),'@')-1), I=1,IPBPTR)
 9010	    FORMAT(1X,A)
	  ENDIF

C Then see if a scratchfile has been opened (which occurs if more
C promptstrings must be buffered than will fit in the internal buffer.
C If so, show the contents of the file.

   20	  IF (LUNPRF.NE.0) THEN
          REWIND LUNPRF
   22	    READ (LUNPRF,9022,END=30) INBUF
 9022	    FORMAT(A)
          WRITE (LUNO,9010) INBUF(:INDEX(INBUF,'@')-1)
	    GOTO 22
	  ENDIF

C Then display the final prompt if it is non-empty

   30	  IF (PROMPT .NE. ' ') THEN
          WRITE (LUNO,9030) PROMPT
 9030	    FORMAT(1X,A,' ',$)		! note ' ' is not same as 1X
	  ENDIF

	ENDIF
	RETURN
	END

	SUBROUTINE CIOERL (MESSAG)
C++
C TITLE:  CIOERL
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT: Display error message (and incurring line).
C PROCEDURES CALLED:
C	CIOMSG, CIOINV, LIB$SYS_GETMSG
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  24-nov-1980.
C MODIFIED BY:
C PAK 28-apr-1981 Made two entries CIOERR and CIOERL.
C PAK 19-may-1981 Added entry CIOERS
C PAK 11-feb-1981 Repaired faulty logic around current-item pointers
C--

	INCLUDE 'ciocom.inc'
	CHARACTER*(*)	MESSAG
	INTEGER         IST, K
C++
C ENTRY: CIOERL
C ABSTRACT: Display error message and invoking item.
C FUNCTIONAL DESCRIPTION:
C	The current internal input buffer is displayed with the
C	latest extracted item marked.
C	The string specified by MESSAG is displayed through a call
C	to CIOMSG, which will abort the program if not in
C	interactive mode.
C	Then CIOINV is called to discard the current inputbuffer
C	contents and to close all open alternate input files.
C CALLING SEQUENCE:
C	CALL CIOERL (MESSAG)
C INPUTS:
C	MESSAG	character string to be displayed.
C SIDE EFFECTS:
C	Program is aborted if in interactive mode.
C--

	IF (INBUFL.GT.0) WRITE (LUNO,9000)
	1 INBUF(1:ITPTR1-1), INBUF(ITPTR1:ITPTR2), INBUF(ITPTR2+1:INBUFL)
 9000	FORMAT (1X,T8,A,'<',A,'>',A)

C++
C ENTRY: CIOERR
C ABSTRACT: Display error message.
C FUNCTIONAL DESCRIPTION:
C	The string specified by MESSAG is displayed through a call
C	to CIOMSG, which will abort the program if not in
C	interactive mode.
C	Then CIOINV is called to discard the current inputbuffer
C	contents and to close all open alternate input files.
C CALLING SEQUENCE:
C	CALL CIOERR (MESSAG)
C INPUTS:
C	MESSAG	character string to be displayed.
C SIDE EFFECTS:
C	Program is aborted if in interactive mode.
C--

	ENTRY CIOERR (MESSAG)
C	---------------------
	CALL CIOMSG (2,MESSAG)
	CALL CIOINV
	RETURN

C++
C ENTRY: CIOERS
C ABSTRACT: Display system message according to cond.code.
C FUNCTIONAL DESCRIPTION:
C	The message specified by the condition code IST is obtained by a call
C	to LIB$SYS_GETMSG and displayed through a call to CIOMSG,
C	which will abort the program if not in interactive mode.
C	Then CIOINV is called to discard the current inputbuffer
C	contents and to close all open alternate input files.
C CALLING SEQUENCE:
C	CALL CIOERS (IST)
C INPUTS:
C	IST	condition code for message to be displayed.
C SIDE EFFECTS:
C	Program is aborted if in interactive mode.
C--

	ENTRY CIOERS (IST)
C	------------------

C	This VMS code not portable to Linux. Q&D workaround.
C	CALL LIB$SYS_GETMSG (IST, K, CWORK)	!???g77
C	CALL CIOMSG (2,CWORK(:K))
	WRITE (CWORK, 100) IST
100	FORMAT ('Error status I10')
	CALL CIOMSG (2, CWORK)
	CALL CIOINV
	RETURN
	END

	COMPLEX FUNCTION C*16(L,M,PHI)
	IMPLICIT REAL*8(A-H,O-Z)

C   CALCULATES RENORMALIZED SPHERICAL HARMONICS

	INCLUDE 'ANGCOR.INC'

	PHAS=PAR(M)
	IF(M.LT.0) PHAS=1.
	P=M*PHI
	M1=IABS(M)
	C = (0.,0.)
	IF(M1.GT.L) RETURN
	CALL FACTOR(L,M1,F)
	M1=M1+1
	L1=L+1
	C=PHAS*DCMPLX(COS(P),SIN(P))*PL(L1,M1)/SQRT(F)
	RETURN
	END

	SUBROUTINE RHOKQ(KL)
	IMPLICIT REAL*8(A-H,O-Z)

C  CALCULATES STATISTICAL TENSORS
c Nov-2000 M.Yosoi   Rev. for IBM-xlf

	INCLUDE 'ANGCOR.INC'
	COMPLEX*16 F(2*MAX_LG,2*MAX_LG)

	IF(ICO(2).EQ.1)WRITE(LUNOUT,100)
	KK=-1
	XK=-1.
	DO 1 K=1,KL
	KK=KK+1
	XK=XK+1.
	IQ=2*K-1
	DO 1 KQ=1,IQ
	MQ=KQ-K
	KMQ=KK*KK+KK+MQ+1
	XQ=MQ
	RHO(KMQ)=(0.,0.)
	IF(ICO(3).EQ.0) THEN
	  MB=-JB(1)
	  DO 2 M=1,LF2(1)
	  XMB=FLOAT(MB)/2.
	  MB1=-JB(1)
	  DO 3 MM=1,LF2(1)
	  XMB1=FLOAT(MB1)/2.
	  IF(MB-MB1.EQ.2*MQ)
     1  RHO(KMQ)=RHO(KMQ)+FPP(M,MM)*CG(XJB(1),XMB,XJB(1),-XMB1,XK,XQ)
     2  *PAR((JB(1)-MB1)/2)
	  MB1=MB1+2
3	  CONTINUE
	  MB=MB+2
2	  CONTINUE
	ELSEIF(ICO(3).EQ.1) THEN
	  CALL RHOLSJ(KK,MQ,F)
	  DO 4 J=1,NLTR
	  XJ=FLOAT(JTR(J))/2.
	  DO 5 J1=1,NLTR
	  XJ1=FLOAT(JTR(J1))/2.
	  RHO(KMQ)=RHO(KMQ)+SQRT((2.*XJ+1.)*(2.*XJ1+1.))*
     1  W(XJ,XJ1,XJB(1),XJB(1),XK,XJA)*PAR((JB(1)-JA+JTR(J)-2*KK)/2)*
     1  F(J,J1)
5	  CONTINUE
4	  CONTINUE
	  XJBB=JB(1)+1
	  RHO(KMQ)=RHO(KMQ)*XJBB
	ENDIF

	IF(ICO(2).EQ.1)WRITE(LUNOUT,101)KK,MQ,RHO(KMQ)

1	CONTINUE
	RETURN
100	FORMAT(1H0,'  K   Q    REAL RHOKQ     IMAG RHOKQ')
101	FORMAT(2I4,2E15.6)
	END

C++
C TITLE:  CIOSTRING
C FACILITY:  CIO  - conversational I/O package.
C ABSTRACT:
C	F77 implementation of some string functions that were
C	available as Run-Time-Libaray functions on OpenVMS.
C PROCEDURES CALLED:
C	none
C AUTHOR: Peter A. Kroon, KVI, Groningen, NL.
C CREATION DATE:  27-sep-2006
C MODIFIED BY:
C
C CALLING SEQUENCE:
C	See the corresponding descriptions of:
C	LIB$SCANC, LIB$SPANC, STR$UPCASE
C	in the OpenVMS documentation set.
C--

	SUBROUTINE STR__UPCASE (DESTINATION, SOURCE)

	IMPLICIT NONE
	CHARACTER*(*) DESTINATION, SOURCE

	INTEGER LENSRC, LENDST, K, IC

	LENSRC = LEN (SOURCE)
	LENDST = LEN (DESTINATION)

      DO K = 1, MIN (LENSRC, LENDST)
        IC = ICHAR (SOURCE (K:K))
        IF (IC.GE.ICHAR('a') .and. IC.LE.ICHAR('z')) THEN
                IC = IC - ICHAR('a') + ICHAR('A')
        ENDIF
		DESTINATION(K:K) = CHAR(IC)
	END DO

	IF (LENDST.GT.LENSRC)	DESTINATION (LENSRC+1:) = ''

	END

C ---------------------------------------------------------------------

	FUNCTION LIB__SCANC (SOURCE, TABLE, MASK)

	IMPLICIT		NONE
      INTEGER           LIB__SCANC
	CHARACTER(*)	SOURCE
      BYTE              TABLE(0:255)
      BYTE              MASK

      INTEGER           K, IC

      LIB__SCANC = 0    ! assume not found
	IF (LEN(SOURCE).EQ.0) RETURN
	DO K = 1, LEN(SOURCE)
		IC = ICHAR (SOURCE(K:K))
        IF (IAND(MASK,TABLE(ICHAR(SOURCE(K:K)))) .NE. 0) THEN
                LIB__SCANC = K
			RETURN
		ENDIF
	END DO
	RETURN
	END

C ---------------------------------------------------------------------

	FUNCTION LIB__SPANC (SOURCE, TABLE, MASK)

	IMPLICIT		NONE
      INTEGER           LIB__SPANC
	CHARACTER(*)	SOURCE
      BYTE              TABLE(0:255)
      BYTE              MASK

      INTEGER           K, IC

	LIB__SPANC = 0
	IF (LEN(SOURCE).EQ.0) RETURN
	DO K = 1, LEN(SOURCE)
		IC = ICHAR (SOURCE(K:K))
        IF (IAND(MASK,TABLE(ICHAR(SOURCE(K:K)))) .EQ. 0) THEN
			LIB__SPANC = K
			RETURN
		ENDIF
	END DO
	RETURN
	END

C ---------------------------------------------------------------------

BEGIN{}
{
theta_alpha=substr(FILENAME,10,3)
phi_gamma=substr(FILENAME,14,3)

test=substr(phi_gamma,3,1)
test2=substr(phi_gamma,2,1)

if(test==".") {phi_gamma=substr(FILENAME,14,2)}
if(test2==".") {phi_gamma=substr(FILENAME,14,1)}

if(theta_alpha=="10.")
{ 
	theta_alpha=substr(FILENAME,10,4);
	phi_gamma=substr(FILENAME,15,2);
	
	test3=substr(phi_gamma,2,1);
	if(test3==".") phi_gamma=substr(FILENAME,15,1)
}

print theta_alpha,$2*1,phi_gamma,$3*1

}
END{}
